# Terrafrom CDK Proxmox Provider

This is a repo that builds default CDKTF bindings for the awlsring/proxmox provider. It is semi auto-generated from the providers schema using methods pulled from the HashiCorp [cdktf-provider-project](https://github.com/cdktf/cdktf-provider-project)

This repo and the provider are still in development and should not be used in production.

As this matures, additional custom constructs will be added to this to speed up the creation of VMs and other resources.

## Links

* Provider Repo: https://github.com/awlsring/terraform-provider-proxmox
* Provider Registry: https://registry.terraform.io/providers/awlsring/proxmox/latest
* ConstructHub: https://constructs.dev/packages/@awlsring/cdktf-proxmox

## Available Packages

This provider is built for the following languages:

* Javascript/Typescript
* Python
* C#

Details on how to find these packages are below and on [ConstructHub](https://constructs.dev/packages/@awlsring/cdktf-proxmox)

### NPM

Javascript/Typescript package is available on NPM.

The npm package is viewable at https://www.npmjs.com/package/@awlsring/cdktf-proxmox

```bash
npm install @awlsring/cdktf-proxmox
```

### PyPi

Python package is available on PyPi.

The pypi package is viewable at https://pypi.org/project/cdktf-proxmox/

```bash
pip install cdktf-proxmox
```

### Nuget

C# package is available on Nuget.

The nuget package is viewable at https://www.nuget.org/packages/awlsring.CdktfProxmox/

```bash
dotnet add package awlsring.CdktfProxmox
```
