import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxLvmStorageClassesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#filters DataProxmoxLvmStorageClasses#filters}
    */
    readonly filters?: DataProxmoxLvmStorageClassesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxLvmStorageClassesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#name DataProxmoxLvmStorageClasses#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#values DataProxmoxLvmStorageClasses#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxLvmStorageClassesFiltersToTerraform(struct?: DataProxmoxLvmStorageClassesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxLvmStorageClassesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmStorageClassesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxLvmStorageClassesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxLvmStorageClassesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxLvmStorageClassesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmStorageClassesFiltersOutputReference;
}
export interface DataProxmoxLvmStorageClassesLvmStorageClasses {
}
export declare function dataProxmoxLvmStorageClassesLvmStorageClassesToTerraform(struct?: DataProxmoxLvmStorageClassesLvmStorageClasses): any;
export declare class DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmStorageClassesLvmStorageClasses | undefined;
    set internalValue(value: DataProxmoxLvmStorageClassesLvmStorageClasses | undefined);
    get contentTypes(): string[];
    get id(): string;
    get nodes(): string[];
    get volumeGroup(): string;
}
export declare class DataProxmoxLvmStorageClassesLvmStorageClassesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes proxmox_lvm_storage_classes}
*/
export declare class DataProxmoxLvmStorageClasses extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_lvm_storage_classes";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes proxmox_lvm_storage_classes} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxLvmStorageClassesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxLvmStorageClassesConfig);
    private _filters;
    get filters(): DataProxmoxLvmStorageClassesFiltersList;
    putFilters(value: DataProxmoxLvmStorageClassesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxLvmStorageClassesFilters[] | undefined;
    private _lvmStorageClasses;
    get lvmStorageClasses(): DataProxmoxLvmStorageClassesLvmStorageClassesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
