import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxLvmThinpoolStorageClassesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#filters DataProxmoxLvmThinpoolStorageClasses#filters}
    */
    readonly filters?: DataProxmoxLvmThinpoolStorageClassesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxLvmThinpoolStorageClassesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#name DataProxmoxLvmThinpoolStorageClasses#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#values DataProxmoxLvmThinpoolStorageClasses#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxLvmThinpoolStorageClassesFiltersToTerraform(struct?: DataProxmoxLvmThinpoolStorageClassesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmThinpoolStorageClassesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxLvmThinpoolStorageClassesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxLvmThinpoolStorageClassesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxLvmThinpoolStorageClassesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference;
}
export interface DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses {
}
export declare function dataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesToTerraform(struct?: DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses): any;
export declare class DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses | undefined;
    set internalValue(value: DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses | undefined);
    get contentTypes(): string[];
    get id(): string;
    get nodes(): string[];
    get thinpool(): string;
    get volumeGroup(): string;
}
export declare class DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes proxmox_lvm_thinpool_storage_classes}
*/
export declare class DataProxmoxLvmThinpoolStorageClasses extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_lvm_thinpool_storage_classes";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes proxmox_lvm_thinpool_storage_classes} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxLvmThinpoolStorageClassesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxLvmThinpoolStorageClassesConfig);
    private _filters;
    get filters(): DataProxmoxLvmThinpoolStorageClassesFiltersList;
    putFilters(value: DataProxmoxLvmThinpoolStorageClassesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxLvmThinpoolStorageClassesFilters[] | undefined;
    private _lvmThinpoolStorageClasses;
    get lvmThinpoolStorageClasses(): DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
