import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxLvmThinpoolsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#filters DataProxmoxLvmThinpools#filters}
    */
    readonly filters?: DataProxmoxLvmThinpoolsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxLvmThinpoolsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#name DataProxmoxLvmThinpools#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#values DataProxmoxLvmThinpools#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxLvmThinpoolsFiltersToTerraform(struct?: DataProxmoxLvmThinpoolsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxLvmThinpoolsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmThinpoolsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxLvmThinpoolsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxLvmThinpoolsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxLvmThinpoolsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmThinpoolsFiltersOutputReference;
}
export interface DataProxmoxLvmThinpoolsLvmThinpools {
}
export declare function dataProxmoxLvmThinpoolsLvmThinpoolsToTerraform(struct?: DataProxmoxLvmThinpoolsLvmThinpools): any;
export declare class DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmThinpoolsLvmThinpools | undefined;
    set internalValue(value: DataProxmoxLvmThinpoolsLvmThinpools | undefined);
    get device(): string;
    get id(): string;
    get metadataSize(): number;
    get name(): string;
    get nodeAttribute(): string;
    get size(): number;
    get volumeGroup(): string;
}
export declare class DataProxmoxLvmThinpoolsLvmThinpoolsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools proxmox_lvm_thinpools}
*/
export declare class DataProxmoxLvmThinpools extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_lvm_thinpools";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools proxmox_lvm_thinpools} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxLvmThinpoolsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxLvmThinpoolsConfig);
    private _filters;
    get filters(): DataProxmoxLvmThinpoolsFiltersList;
    putFilters(value: DataProxmoxLvmThinpoolsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxLvmThinpoolsFilters[] | undefined;
    private _lvmThinpools;
    get lvmThinpools(): DataProxmoxLvmThinpoolsLvmThinpoolsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
