import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxLvmsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#filters DataProxmoxLvms#filters}
    */
    readonly filters?: DataProxmoxLvmsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxLvmsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#name DataProxmoxLvms#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#values DataProxmoxLvms#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxLvmsFiltersToTerraform(struct?: DataProxmoxLvmsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxLvmsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxLvmsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxLvmsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxLvmsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmsFiltersOutputReference;
}
export interface DataProxmoxLvmsLvms {
}
export declare function dataProxmoxLvmsLvmsToTerraform(struct?: DataProxmoxLvmsLvms): any;
export declare class DataProxmoxLvmsLvmsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxLvmsLvms | undefined;
    set internalValue(value: DataProxmoxLvmsLvms | undefined);
    get device(): string;
    get id(): string;
    get name(): string;
    get nodeAttribute(): string;
    get size(): number;
}
export declare class DataProxmoxLvmsLvmsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxLvmsLvmsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvms proxmox_lvms}
*/
export declare class DataProxmoxLvms extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_lvms";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/lvms proxmox_lvms} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxLvmsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxLvmsConfig);
    private _filters;
    get filters(): DataProxmoxLvmsFiltersList;
    putFilters(value: DataProxmoxLvmsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxLvmsFilters[] | undefined;
    private _lvms;
    get lvms(): DataProxmoxLvmsLvmsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
