import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNetworkBondsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#filters DataProxmoxNetworkBonds#filters}
    */
    readonly filters?: DataProxmoxNetworkBondsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNetworkBondsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#name DataProxmoxNetworkBonds#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#values DataProxmoxNetworkBonds#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNetworkBondsFiltersToTerraform(struct?: DataProxmoxNetworkBondsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNetworkBondsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNetworkBondsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNetworkBondsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNetworkBondsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNetworkBondsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNetworkBondsFiltersOutputReference;
}
export interface DataProxmoxNetworkBondsNetworkBondsIpv4 {
}
export declare function dataProxmoxNetworkBondsNetworkBondsIpv4ToTerraform(struct?: DataProxmoxNetworkBondsNetworkBondsIpv4): any;
export declare class DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxNetworkBondsNetworkBondsIpv4 | undefined;
    set internalValue(value: DataProxmoxNetworkBondsNetworkBondsIpv4 | undefined);
    get address(): string;
    get netmask(): string;
}
export interface DataProxmoxNetworkBondsNetworkBondsIpv6 {
}
export declare function dataProxmoxNetworkBondsNetworkBondsIpv6ToTerraform(struct?: DataProxmoxNetworkBondsNetworkBondsIpv6): any;
export declare class DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxNetworkBondsNetworkBondsIpv6 | undefined;
    set internalValue(value: DataProxmoxNetworkBondsNetworkBondsIpv6 | undefined);
    get address(): string;
    get netmask(): string;
}
export interface DataProxmoxNetworkBondsNetworkBonds {
    /**
    * The ipv4 gateway.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#ipv4_gateway DataProxmoxNetworkBonds#ipv4_gateway}
    */
    readonly ipv4Gateway?: string;
    /**
    * The ipv6 gateway.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#ipv6_gateway DataProxmoxNetworkBonds#ipv6_gateway}
    */
    readonly ipv6Gateway?: string;
}
export declare function dataProxmoxNetworkBondsNetworkBondsToTerraform(struct?: DataProxmoxNetworkBondsNetworkBonds): any;
export declare class DataProxmoxNetworkBondsNetworkBondsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNetworkBondsNetworkBonds | undefined;
    set internalValue(value: DataProxmoxNetworkBondsNetworkBonds | undefined);
    get active(): cdktf.IResolvable;
    get autostart(): cdktf.IResolvable;
    get bondPrimary(): string;
    get comments(): string;
    get hashPolicy(): string;
    get id(): string;
    get interfaces(): string[];
    get ipv4(): cdktf.IResolvable;
    private _ipv4Gateway?;
    get ipv4Gateway(): string;
    set ipv4Gateway(value: string);
    resetIpv4Gateway(): void;
    get ipv4GatewayInput(): string | undefined;
    get ipv6(): cdktf.IResolvable;
    private _ipv6Gateway?;
    get ipv6Gateway(): string;
    set ipv6Gateway(value: string);
    resetIpv6Gateway(): void;
    get ipv6GatewayInput(): string | undefined;
    get miiMon(): string;
    get mode(): string;
    get name(): string;
    get nodeAttribute(): string;
}
export declare class DataProxmoxNetworkBondsNetworkBondsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNetworkBondsNetworkBonds[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNetworkBondsNetworkBondsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds proxmox_network_bonds}
*/
export declare class DataProxmoxNetworkBonds extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_network_bonds";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds proxmox_network_bonds} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNetworkBondsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNetworkBondsConfig);
    private _filters;
    get filters(): DataProxmoxNetworkBondsFiltersList;
    putFilters(value: DataProxmoxNetworkBondsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNetworkBondsFilters[] | undefined;
    private _networkBonds;
    get networkBonds(): DataProxmoxNetworkBondsNetworkBondsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
