import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNetworkBridgesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#filters DataProxmoxNetworkBridges#filters}
    */
    readonly filters?: DataProxmoxNetworkBridgesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNetworkBridgesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#name DataProxmoxNetworkBridges#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#values DataProxmoxNetworkBridges#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNetworkBridgesFiltersToTerraform(struct?: DataProxmoxNetworkBridgesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNetworkBridgesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNetworkBridgesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNetworkBridgesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNetworkBridgesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNetworkBridgesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNetworkBridgesFiltersOutputReference;
}
export interface DataProxmoxNetworkBridgesNetworkBridgesIpv4 {
}
export declare function dataProxmoxNetworkBridgesNetworkBridgesIpv4ToTerraform(struct?: DataProxmoxNetworkBridgesNetworkBridgesIpv4): any;
export declare class DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxNetworkBridgesNetworkBridgesIpv4 | undefined;
    set internalValue(value: DataProxmoxNetworkBridgesNetworkBridgesIpv4 | undefined);
    get address(): string;
    get netmask(): string;
}
export interface DataProxmoxNetworkBridgesNetworkBridgesIpv6 {
}
export declare function dataProxmoxNetworkBridgesNetworkBridgesIpv6ToTerraform(struct?: DataProxmoxNetworkBridgesNetworkBridgesIpv6): any;
export declare class DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxNetworkBridgesNetworkBridgesIpv6 | undefined;
    set internalValue(value: DataProxmoxNetworkBridgesNetworkBridgesIpv6 | undefined);
    get address(): string;
    get netmask(): string;
}
export interface DataProxmoxNetworkBridgesNetworkBridges {
    /**
    * Comment in the bond.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#comments DataProxmoxNetworkBridges#comments}
    */
    readonly comments?: string;
    /**
    * The ipv4 gateway.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#ipv4_gateway DataProxmoxNetworkBridges#ipv4_gateway}
    */
    readonly ipv4Gateway?: string;
    /**
    * The ipv6 gateway.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#ipv6_gateway DataProxmoxNetworkBridges#ipv6_gateway}
    */
    readonly ipv6Gateway?: string;
}
export declare function dataProxmoxNetworkBridgesNetworkBridgesToTerraform(struct?: DataProxmoxNetworkBridgesNetworkBridges): any;
export declare class DataProxmoxNetworkBridgesNetworkBridgesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNetworkBridgesNetworkBridges | undefined;
    set internalValue(value: DataProxmoxNetworkBridgesNetworkBridges | undefined);
    get active(): cdktf.IResolvable;
    get autostart(): cdktf.IResolvable;
    private _comments?;
    get comments(): string;
    set comments(value: string);
    resetComments(): void;
    get commentsInput(): string | undefined;
    get id(): string;
    get interfaces(): string[];
    get ipv4(): cdktf.IResolvable;
    private _ipv4Gateway?;
    get ipv4Gateway(): string;
    set ipv4Gateway(value: string);
    resetIpv4Gateway(): void;
    get ipv4GatewayInput(): string | undefined;
    get ipv6(): cdktf.IResolvable;
    private _ipv6Gateway?;
    get ipv6Gateway(): string;
    set ipv6Gateway(value: string);
    resetIpv6Gateway(): void;
    get ipv6GatewayInput(): string | undefined;
    get name(): string;
    get nodeAttribute(): string;
    get vlanAware(): cdktf.IResolvable;
}
export declare class DataProxmoxNetworkBridgesNetworkBridgesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNetworkBridgesNetworkBridges[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNetworkBridgesNetworkBridgesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges proxmox_network_bridges}
*/
export declare class DataProxmoxNetworkBridges extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_network_bridges";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges proxmox_network_bridges} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNetworkBridgesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNetworkBridgesConfig);
    private _filters;
    get filters(): DataProxmoxNetworkBridgesFiltersList;
    putFilters(value: DataProxmoxNetworkBridgesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNetworkBridgesFilters[] | undefined;
    private _networkBridges;
    get networkBridges(): DataProxmoxNetworkBridgesNetworkBridgesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
