import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNfsStorageClassesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#filters DataProxmoxNfsStorageClasses#filters}
    */
    readonly filters?: DataProxmoxNfsStorageClassesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNfsStorageClassesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#name DataProxmoxNfsStorageClasses#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#values DataProxmoxNfsStorageClasses#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNfsStorageClassesFiltersToTerraform(struct?: DataProxmoxNfsStorageClassesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNfsStorageClassesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNfsStorageClassesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNfsStorageClassesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNfsStorageClassesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNfsStorageClassesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNfsStorageClassesFiltersOutputReference;
}
export interface DataProxmoxNfsStorageClassesNfsStorageClasses {
}
export declare function dataProxmoxNfsStorageClassesNfsStorageClassesToTerraform(struct?: DataProxmoxNfsStorageClassesNfsStorageClasses): any;
export declare class DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNfsStorageClassesNfsStorageClasses | undefined;
    set internalValue(value: DataProxmoxNfsStorageClassesNfsStorageClasses | undefined);
    get contentTypes(): string[];
    get export(): string;
    get id(): string;
    get mount(): string;
    get nodes(): string[];
    get server(): string;
}
export declare class DataProxmoxNfsStorageClassesNfsStorageClassesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes proxmox_nfs_storage_classes}
*/
export declare class DataProxmoxNfsStorageClasses extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_nfs_storage_classes";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes proxmox_nfs_storage_classes} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNfsStorageClassesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNfsStorageClassesConfig);
    private _filters;
    get filters(): DataProxmoxNfsStorageClassesFiltersList;
    putFilters(value: DataProxmoxNfsStorageClassesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNfsStorageClassesFilters[] | undefined;
    private _nfsStorageClasses;
    get nfsStorageClasses(): DataProxmoxNfsStorageClassesNfsStorageClassesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
