import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNodeStorageLvmThinpoolsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#filters DataProxmoxNodeStorageLvmThinpools#filters}
    */
    readonly filters?: DataProxmoxNodeStorageLvmThinpoolsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNodeStorageLvmThinpoolsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#name DataProxmoxNodeStorageLvmThinpools#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#values DataProxmoxNodeStorageLvmThinpools#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNodeStorageLvmThinpoolsFiltersToTerraform(struct?: DataProxmoxNodeStorageLvmThinpoolsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodeStorageLvmThinpoolsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNodeStorageLvmThinpoolsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNodeStorageLvmThinpoolsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNodeStorageLvmThinpoolsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference;
}
export interface DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools {
}
export declare function dataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsToTerraform(struct?: DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools): any;
export declare class DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools | undefined;
    set internalValue(value: DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools | undefined);
    get contentTypes(): string[];
    get id(): string;
    get nodeAttribute(): string;
    get size(): number;
    get storage(): string;
    get thinpool(): string;
    get volumeGroup(): string;
}
export declare class DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools proxmox_node_storage_lvm_thinpools}
*/
export declare class DataProxmoxNodeStorageLvmThinpools extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_node_storage_lvm_thinpools";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools proxmox_node_storage_lvm_thinpools} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNodeStorageLvmThinpoolsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNodeStorageLvmThinpoolsConfig);
    private _filters;
    get filters(): DataProxmoxNodeStorageLvmThinpoolsFiltersList;
    putFilters(value: DataProxmoxNodeStorageLvmThinpoolsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNodeStorageLvmThinpoolsFilters[] | undefined;
    private _nodeStorageLvmThinpools;
    get nodeStorageLvmThinpools(): DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
