import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNodeStorageLvmsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#filters DataProxmoxNodeStorageLvms#filters}
    */
    readonly filters?: DataProxmoxNodeStorageLvmsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNodeStorageLvmsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#name DataProxmoxNodeStorageLvms#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#values DataProxmoxNodeStorageLvms#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNodeStorageLvmsFiltersToTerraform(struct?: DataProxmoxNodeStorageLvmsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNodeStorageLvmsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodeStorageLvmsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNodeStorageLvmsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNodeStorageLvmsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNodeStorageLvmsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodeStorageLvmsFiltersOutputReference;
}
export interface DataProxmoxNodeStorageLvmsNodeStorageLvms {
}
export declare function dataProxmoxNodeStorageLvmsNodeStorageLvmsToTerraform(struct?: DataProxmoxNodeStorageLvmsNodeStorageLvms): any;
export declare class DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodeStorageLvmsNodeStorageLvms | undefined;
    set internalValue(value: DataProxmoxNodeStorageLvmsNodeStorageLvms | undefined);
    get contentTypes(): string[];
    get id(): string;
    get nodeAttribute(): string;
    get size(): number;
    get storage(): string;
    get volumeGroup(): string;
}
export declare class DataProxmoxNodeStorageLvmsNodeStorageLvmsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms proxmox_node_storage_lvms}
*/
export declare class DataProxmoxNodeStorageLvms extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_node_storage_lvms";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms proxmox_node_storage_lvms} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNodeStorageLvmsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNodeStorageLvmsConfig);
    private _filters;
    get filters(): DataProxmoxNodeStorageLvmsFiltersList;
    putFilters(value: DataProxmoxNodeStorageLvmsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNodeStorageLvmsFilters[] | undefined;
    private _nodeStorageLvms;
    get nodeStorageLvms(): DataProxmoxNodeStorageLvmsNodeStorageLvmsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
