import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNodeStorageNfsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#filters DataProxmoxNodeStorageNfs#filters}
    */
    readonly filters?: DataProxmoxNodeStorageNfsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNodeStorageNfsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#name DataProxmoxNodeStorageNfs#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#values DataProxmoxNodeStorageNfs#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNodeStorageNfsFiltersToTerraform(struct?: DataProxmoxNodeStorageNfsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNodeStorageNfsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodeStorageNfsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNodeStorageNfsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNodeStorageNfsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNodeStorageNfsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodeStorageNfsFiltersOutputReference;
}
export interface DataProxmoxNodeStorageNfsNodeStorageNfs {
}
export declare function dataProxmoxNodeStorageNfsNodeStorageNfsToTerraform(struct?: DataProxmoxNodeStorageNfsNodeStorageNfs): any;
export declare class DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodeStorageNfsNodeStorageNfs | undefined;
    set internalValue(value: DataProxmoxNodeStorageNfsNodeStorageNfs | undefined);
    get contentTypes(): string[];
    get export(): string;
    get id(): string;
    get mount(): string;
    get nodeAttribute(): string;
    get server(): string;
    get size(): number;
    get storage(): string;
}
export declare class DataProxmoxNodeStorageNfsNodeStorageNfsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs proxmox_node_storage_nfs}
*/
export declare class DataProxmoxNodeStorageNfs extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_node_storage_nfs";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs proxmox_node_storage_nfs} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNodeStorageNfsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNodeStorageNfsConfig);
    private _filters;
    get filters(): DataProxmoxNodeStorageNfsFiltersList;
    putFilters(value: DataProxmoxNodeStorageNfsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNodeStorageNfsFilters[] | undefined;
    private _nodeStorageNfs;
    get nodeStorageNfs(): DataProxmoxNodeStorageNfsNodeStorageNfsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
