import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxNodesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#filters DataProxmoxNodes#filters}
    */
    readonly filters?: DataProxmoxNodesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxNodesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#name DataProxmoxNodes#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#values DataProxmoxNodes#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxNodesFiltersToTerraform(struct?: DataProxmoxNodesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxNodesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxNodesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxNodesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxNodesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodesFiltersOutputReference;
}
export interface DataProxmoxNodesNodesDisks {
}
export declare function dataProxmoxNodesNodesDisksToTerraform(struct?: DataProxmoxNodesNodesDisks): any;
export declare class DataProxmoxNodesNodesDisksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodesNodesDisks | undefined;
    set internalValue(value: DataProxmoxNodesNodesDisks | undefined);
    get device(): string;
    get idLink(): string;
    get model(): string;
    get serial(): string;
    get size(): number;
    get type(): string;
    get vendor(): string;
}
export declare class DataProxmoxNodesNodesDisksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodesNodesDisksOutputReference;
}
export interface DataProxmoxNodesNodes {
}
export declare function dataProxmoxNodesNodesToTerraform(struct?: DataProxmoxNodesNodes): any;
export declare class DataProxmoxNodesNodesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxNodesNodes | undefined;
    set internalValue(value: DataProxmoxNodesNodes | undefined);
    get cores(): number;
    private _disks;
    get disks(): DataProxmoxNodesNodesDisksList;
    get id(): string;
    get memory(): number;
    get networkInterfaces(): string[];
    get nodeAttribute(): string;
    get sslFingerprint(): string;
}
export declare class DataProxmoxNodesNodesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxNodesNodesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/nodes proxmox_nodes}
*/
export declare class DataProxmoxNodes extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_nodes";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/nodes proxmox_nodes} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxNodesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxNodesConfig);
    private _filters;
    get filters(): DataProxmoxNodesFiltersList;
    putFilters(value: DataProxmoxNodesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxNodesFilters[] | undefined;
    private _nodes;
    get nodes(): DataProxmoxNodesNodesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
