import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxResourcePoolsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#filters DataProxmoxResourcePools#filters}
    */
    readonly filters?: DataProxmoxResourcePoolsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxResourcePoolsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#name DataProxmoxResourcePools#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#values DataProxmoxResourcePools#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxResourcePoolsFiltersToTerraform(struct?: DataProxmoxResourcePoolsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxResourcePoolsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxResourcePoolsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxResourcePoolsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxResourcePoolsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxResourcePoolsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxResourcePoolsFiltersOutputReference;
}
export interface DataProxmoxResourcePoolsResourcePoolsMembers {
}
export declare function dataProxmoxResourcePoolsResourcePoolsMembersToTerraform(struct?: DataProxmoxResourcePoolsResourcePoolsMembers): any;
export declare class DataProxmoxResourcePoolsResourcePoolsMembersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxResourcePoolsResourcePoolsMembers | undefined;
    set internalValue(value: DataProxmoxResourcePoolsResourcePoolsMembers | undefined);
    get id(): string;
    get type(): string;
}
export declare class DataProxmoxResourcePoolsResourcePoolsMembersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxResourcePoolsResourcePoolsMembersOutputReference;
}
export interface DataProxmoxResourcePoolsResourcePools {
}
export declare function dataProxmoxResourcePoolsResourcePoolsToTerraform(struct?: DataProxmoxResourcePoolsResourcePools): any;
export declare class DataProxmoxResourcePoolsResourcePoolsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxResourcePoolsResourcePools | undefined;
    set internalValue(value: DataProxmoxResourcePoolsResourcePools | undefined);
    get comment(): string;
    get id(): string;
    private _members;
    get members(): DataProxmoxResourcePoolsResourcePoolsMembersList;
}
export declare class DataProxmoxResourcePoolsResourcePoolsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxResourcePoolsResourcePoolsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools proxmox_resource_pools}
*/
export declare class DataProxmoxResourcePools extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_resource_pools";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools proxmox_resource_pools} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxResourcePoolsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxResourcePoolsConfig);
    private _filters;
    get filters(): DataProxmoxResourcePoolsFiltersList;
    putFilters(value: DataProxmoxResourcePoolsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxResourcePoolsFilters[] | undefined;
    private _resourcePools;
    get resourcePools(): DataProxmoxResourcePoolsResourcePoolsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
