import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxTemplatesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#filters DataProxmoxTemplates#filters}
    */
    readonly filters?: DataProxmoxTemplatesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxTemplatesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#name DataProxmoxTemplates#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#values DataProxmoxTemplates#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxTemplatesFiltersToTerraform(struct?: DataProxmoxTemplatesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxTemplatesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxTemplatesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxTemplatesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxTemplatesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxTemplatesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxTemplatesFiltersOutputReference;
}
export interface DataProxmoxTemplatesTemplatesAgent {
}
export declare function dataProxmoxTemplatesTemplatesAgentToTerraform(struct?: DataProxmoxTemplatesTemplatesAgent): any;
export declare class DataProxmoxTemplatesTemplatesAgentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesAgent | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesAgent | undefined);
    get enabled(): cdktf.IResolvable;
    get type(): string;
    get useFstrim(): cdktf.IResolvable;
}
export interface DataProxmoxTemplatesTemplatesCloudInitDns {
}
export declare function dataProxmoxTemplatesTemplatesCloudInitDnsToTerraform(struct?: DataProxmoxTemplatesTemplatesCloudInitDns): any;
export declare class DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesCloudInitDns | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCloudInitDns | undefined);
    get domain(): string;
    get nameserver(): string;
}
export interface DataProxmoxTemplatesTemplatesCloudInitIpV4 {
}
export declare function dataProxmoxTemplatesTemplatesCloudInitIpV4ToTerraform(struct?: DataProxmoxTemplatesTemplatesCloudInitIpV4): any;
export declare class DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesCloudInitIpV4 | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCloudInitIpV4 | undefined);
    get address(): string;
    get dhcp(): cdktf.IResolvable;
    get gateway(): string;
    get netmask(): string;
}
export interface DataProxmoxTemplatesTemplatesCloudInitIpV6 {
}
export declare function dataProxmoxTemplatesTemplatesCloudInitIpV6ToTerraform(struct?: DataProxmoxTemplatesTemplatesCloudInitIpV6): any;
export declare class DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesCloudInitIpV6 | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCloudInitIpV6 | undefined);
    get address(): string;
    get dhcp(): cdktf.IResolvable;
    get gateway(): string;
    get netmask(): string;
}
export interface DataProxmoxTemplatesTemplatesCloudInitIp {
}
export declare function dataProxmoxTemplatesTemplatesCloudInitIpToTerraform(struct?: DataProxmoxTemplatesTemplatesCloudInitIp): any;
export declare class DataProxmoxTemplatesTemplatesCloudInitIpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxTemplatesTemplatesCloudInitIp | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCloudInitIp | undefined);
    get position(): number;
    private _v4;
    get v4(): DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference;
    private _v6;
    get v6(): DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference;
}
export declare class DataProxmoxTemplatesTemplatesCloudInitIpList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxTemplatesTemplatesCloudInitIpOutputReference;
}
export interface DataProxmoxTemplatesTemplatesCloudInitUser {
}
export declare function dataProxmoxTemplatesTemplatesCloudInitUserToTerraform(struct?: DataProxmoxTemplatesTemplatesCloudInitUser): any;
export declare class DataProxmoxTemplatesTemplatesCloudInitUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesCloudInitUser | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCloudInitUser | undefined);
    get name(): string;
    get password(): string;
    get publicKeys(): string[];
}
export interface DataProxmoxTemplatesTemplatesCloudInit {
}
export declare function dataProxmoxTemplatesTemplatesCloudInitToTerraform(struct?: DataProxmoxTemplatesTemplatesCloudInit): any;
export declare class DataProxmoxTemplatesTemplatesCloudInitOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesCloudInit | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCloudInit | undefined);
    private _dns;
    get dns(): DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference;
    private _ip;
    get ip(): DataProxmoxTemplatesTemplatesCloudInitIpList;
    private _user;
    get user(): DataProxmoxTemplatesTemplatesCloudInitUserOutputReference;
}
export interface DataProxmoxTemplatesTemplatesCpu {
}
export declare function dataProxmoxTemplatesTemplatesCpuToTerraform(struct?: DataProxmoxTemplatesTemplatesCpu): any;
export declare class DataProxmoxTemplatesTemplatesCpuOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesCpu | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesCpu | undefined);
    get architecture(): string;
    get cores(): number;
    get cpuUnits(): number;
    get emulatedType(): string;
    get sockets(): number;
}
export interface DataProxmoxTemplatesTemplatesDisksSpeedLimits {
}
export declare function dataProxmoxTemplatesTemplatesDisksSpeedLimitsToTerraform(struct?: DataProxmoxTemplatesTemplatesDisksSpeedLimits): any;
export declare class DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesDisksSpeedLimits | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesDisksSpeedLimits | undefined);
    get read(): number;
    get readBurstable(): number;
    get write(): number;
    get writeBurstable(): number;
}
export interface DataProxmoxTemplatesTemplatesDisks {
}
export declare function dataProxmoxTemplatesTemplatesDisksToTerraform(struct?: DataProxmoxTemplatesTemplatesDisks): any;
export declare class DataProxmoxTemplatesTemplatesDisksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxTemplatesTemplatesDisks | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesDisks | undefined);
    get discard(): cdktf.IResolvable;
    get fileFormat(): string;
    get interfaceType(): string;
    get name(): string;
    get position(): number;
    get size(): number;
    private _speedLimits;
    get speedLimits(): DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference;
    get ssdEmulation(): cdktf.IResolvable;
    get storage(): string;
    get useIothread(): cdktf.IResolvable;
}
export declare class DataProxmoxTemplatesTemplatesDisksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxTemplatesTemplatesDisksOutputReference;
}
export interface DataProxmoxTemplatesTemplatesMemory {
}
export declare function dataProxmoxTemplatesTemplatesMemoryToTerraform(struct?: DataProxmoxTemplatesTemplatesMemory): any;
export declare class DataProxmoxTemplatesTemplatesMemoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataProxmoxTemplatesTemplatesMemory | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesMemory | undefined);
    get dedicated(): number;
    get floating(): number;
    get shared(): number;
}
export interface DataProxmoxTemplatesTemplatesNetworkInterfaces {
}
export declare function dataProxmoxTemplatesTemplatesNetworkInterfacesToTerraform(struct?: DataProxmoxTemplatesTemplatesNetworkInterfaces): any;
export declare class DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxTemplatesTemplatesNetworkInterfaces | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesNetworkInterfaces | undefined);
    get bridge(): string;
    get enabled(): cdktf.IResolvable;
    get macAddress(): string;
    get model(): string;
    get mtu(): number;
    get position(): number;
    get rateLimit(): number;
    get useFirewall(): cdktf.IResolvable;
    get vlan(): number;
}
export declare class DataProxmoxTemplatesTemplatesNetworkInterfacesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference;
}
export interface DataProxmoxTemplatesTemplatesPciDevices {
}
export declare function dataProxmoxTemplatesTemplatesPciDevicesToTerraform(struct?: DataProxmoxTemplatesTemplatesPciDevices): any;
export declare class DataProxmoxTemplatesTemplatesPciDevicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxTemplatesTemplatesPciDevices | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplatesPciDevices | undefined);
    get id(): string;
    get mdev(): string;
    get name(): string;
    get pcie(): cdktf.IResolvable;
    get primaryGpu(): cdktf.IResolvable;
    get romFile(): string;
    get rombar(): cdktf.IResolvable;
}
export declare class DataProxmoxTemplatesTemplatesPciDevicesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxTemplatesTemplatesPciDevicesOutputReference;
}
export interface DataProxmoxTemplatesTemplates {
}
export declare function dataProxmoxTemplatesTemplatesToTerraform(struct?: DataProxmoxTemplatesTemplates): any;
export declare class DataProxmoxTemplatesTemplatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxTemplatesTemplates | undefined;
    set internalValue(value: DataProxmoxTemplatesTemplates | undefined);
    private _agent;
    get agent(): DataProxmoxTemplatesTemplatesAgentOutputReference;
    get bios(): string;
    private _cloudInit;
    get cloudInit(): DataProxmoxTemplatesTemplatesCloudInitOutputReference;
    private _cpu;
    get cpu(): DataProxmoxTemplatesTemplatesCpuOutputReference;
    get description(): string;
    private _disks;
    get disks(): DataProxmoxTemplatesTemplatesDisksList;
    get id(): number;
    get keyboardLayout(): string;
    get kvmArguments(): string;
    get machineType(): string;
    private _memory;
    get memory(): DataProxmoxTemplatesTemplatesMemoryOutputReference;
    get name(): string;
    private _networkInterfaces;
    get networkInterfaces(): DataProxmoxTemplatesTemplatesNetworkInterfacesList;
    get nodeAttribute(): string;
    private _pciDevices;
    get pciDevices(): DataProxmoxTemplatesTemplatesPciDevicesList;
    get resourcePool(): string;
    get startOnNodeBoot(): cdktf.IResolvable;
    get tags(): string[];
    get type(): string;
}
export declare class DataProxmoxTemplatesTemplatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxTemplatesTemplatesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/templates proxmox_templates}
*/
export declare class DataProxmoxTemplates extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_templates";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/templates proxmox_templates} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxTemplatesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxTemplatesConfig);
    private _filters;
    get filters(): DataProxmoxTemplatesFiltersList;
    putFilters(value: DataProxmoxTemplatesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxTemplatesFilters[] | undefined;
    private _templates;
    get templates(): DataProxmoxTemplatesTemplatesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
