import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxZfsPoolsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#filters DataProxmoxZfsPools#filters}
    */
    readonly filters?: DataProxmoxZfsPoolsFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxZfsPoolsFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#name DataProxmoxZfsPools#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#values DataProxmoxZfsPools#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxZfsPoolsFiltersToTerraform(struct?: DataProxmoxZfsPoolsFilters | cdktf.IResolvable): any;
export declare class DataProxmoxZfsPoolsFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxZfsPoolsFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxZfsPoolsFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxZfsPoolsFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxZfsPoolsFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxZfsPoolsFiltersOutputReference;
}
export interface DataProxmoxZfsPoolsZfsPools {
}
export declare function dataProxmoxZfsPoolsZfsPoolsToTerraform(struct?: DataProxmoxZfsPoolsZfsPools): any;
export declare class DataProxmoxZfsPoolsZfsPoolsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxZfsPoolsZfsPools | undefined;
    set internalValue(value: DataProxmoxZfsPoolsZfsPools | undefined);
    get disks(): string[];
    get health(): string;
    get id(): string;
    get name(): string;
    get nodeAttribute(): string;
    get raidLevel(): string;
    get size(): number;
}
export declare class DataProxmoxZfsPoolsZfsPoolsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxZfsPoolsZfsPoolsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools proxmox_zfs_pools}
*/
export declare class DataProxmoxZfsPools extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_zfs_pools";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools proxmox_zfs_pools} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxZfsPoolsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxZfsPoolsConfig);
    private _filters;
    get filters(): DataProxmoxZfsPoolsFiltersList;
    putFilters(value: DataProxmoxZfsPoolsFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxZfsPoolsFilters[] | undefined;
    private _zfsPools;
    get zfsPools(): DataProxmoxZfsPoolsZfsPoolsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
