import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataProxmoxZfsStorageClassesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#filters DataProxmoxZfsStorageClasses#filters}
    */
    readonly filters?: DataProxmoxZfsStorageClassesFilters[] | cdktf.IResolvable;
}
export interface DataProxmoxZfsStorageClassesFilters {
    /**
    * The name of the attribute to filter on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#name DataProxmoxZfsStorageClasses#name}
    */
    readonly name: string;
    /**
    * The value(s) to be used in the filter.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#values DataProxmoxZfsStorageClasses#values}
    */
    readonly values: string[];
}
export declare function dataProxmoxZfsStorageClassesFiltersToTerraform(struct?: DataProxmoxZfsStorageClassesFilters | cdktf.IResolvable): any;
export declare class DataProxmoxZfsStorageClassesFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxZfsStorageClassesFilters | cdktf.IResolvable | undefined;
    set internalValue(value: DataProxmoxZfsStorageClassesFilters | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _values?;
    get values(): string[];
    set values(value: string[]);
    get valuesInput(): string[] | undefined;
}
export declare class DataProxmoxZfsStorageClassesFiltersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataProxmoxZfsStorageClassesFilters[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxZfsStorageClassesFiltersOutputReference;
}
export interface DataProxmoxZfsStorageClassesZfsStorageClasses {
}
export declare function dataProxmoxZfsStorageClassesZfsStorageClassesToTerraform(struct?: DataProxmoxZfsStorageClassesZfsStorageClasses): any;
export declare class DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataProxmoxZfsStorageClassesZfsStorageClasses | undefined;
    set internalValue(value: DataProxmoxZfsStorageClassesZfsStorageClasses | undefined);
    get contentTypes(): string[];
    get id(): string;
    get mount(): string;
    get nodes(): string[];
    get pool(): string;
}
export declare class DataProxmoxZfsStorageClassesZfsStorageClassesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes proxmox_zfs_storage_classes}
*/
export declare class DataProxmoxZfsStorageClasses extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "proxmox_zfs_storage_classes";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes proxmox_zfs_storage_classes} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataProxmoxZfsStorageClassesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataProxmoxZfsStorageClassesConfig);
    private _filters;
    get filters(): DataProxmoxZfsStorageClassesFiltersList;
    putFilters(value: DataProxmoxZfsStorageClassesFilters[] | cdktf.IResolvable): void;
    resetFilters(): void;
    get filtersInput(): cdktf.IResolvable | DataProxmoxZfsStorageClassesFilters[] | undefined;
    private _zfsStorageClasses;
    get zfsStorageClasses(): DataProxmoxZfsStorageClassesZfsStorageClassesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
