import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LvmConfig extends cdktf.TerraformMetaArguments {
    /**
    * Device the LVM is on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm#device Lvm#device}
    */
    readonly device: string;
    /**
    * The name of the LVM.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm#name Lvm#name}
    */
    readonly name: string;
    /**
    * The node the LVM is on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm#node Lvm#node}
    */
    readonly nodeAttribute: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/lvm proxmox_lvm}
*/
export declare class Lvm extends cdktf.TerraformResource {
    static readonly tfResourceType = "proxmox_lvm";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/r/lvm proxmox_lvm} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LvmConfig
    */
    constructor(scope: Construct, id: string, config: LvmConfig);
    private _device?;
    get device(): string;
    set device(value: string);
    get deviceInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _node?;
    get nodeAttribute(): string;
    set nodeAttribute(value: string);
    get nodeAttributeInput(): string | undefined;
    get size(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
