import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ZfsPoolConfig extends cdktf.TerraformMetaArguments {
    /**
    * List of disks that make the ZFS pool.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#disks ZfsPool#disks}
    */
    readonly disks: string[];
    /**
    * The name of the ZFS pool.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#name ZfsPool#name}
    */
    readonly name: string;
    /**
    * The node the ZFS pool is on.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#node ZfsPool#node}
    */
    readonly nodeAttribute: string;
    /**
    * The RAID level of the ZFS pool.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#raid_level ZfsPool#raid_level}
    */
    readonly raidLevel: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool proxmox_zfs_pool}
*/
export declare class ZfsPool extends cdktf.TerraformResource {
    static readonly tfResourceType = "proxmox_zfs_pool";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool proxmox_zfs_pool} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ZfsPoolConfig
    */
    constructor(scope: Construct, id: string, config: ZfsPoolConfig);
    private _disks?;
    get disks(): string[];
    set disks(value: string[]);
    get disksInput(): string[] | undefined;
    get health(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _node?;
    get nodeAttribute(): string;
    set nodeAttribute(value: string);
    get nodeAttributeInput(): string | undefined;
    private _raidLevel?;
    get raidLevel(): string;
    set raidLevel(value: string);
    get raidLevelInput(): string | undefined;
    get size(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
