# Terrafrom CDK Proxmox Provider

This is a repo that builds default CDKTF bindings for the awlsring/proxmox provider. It is semi auto-generated from the providers schema using methods pulled from the HashiCorp [cdktf-provider-project](https://github.com/cdktf/cdktf-provider-project)

This repo and the provider are still in development and should not be used in production.

As this matures, additional custom constructs will be added to this to speed up the creation of VMs and other resources.

## Links

* Provider Repo: https://github.com/awlsring/terraform-provider-proxmox
* Provider Registry: https://registry.terraform.io/providers/awlsring/proxmox/latest
* ConstructHub: https://constructs.dev/packages/@awlsring/cdktf-proxmox

## Available Packages

This provider is built for the following languages:

* Javascript/Typescript
* Python
* C#

Details on how to find these packages are below and on [ConstructHub](https://constructs.dev/packages/@awlsring/cdktf-proxmox)

### NPM

Javascript/Typescript package is available on NPM.

The npm package is viewable at https://www.npmjs.com/package/@awlsring/cdktf-proxmox

```bash
npm install @awlsring/cdktf-proxmox
```

### PyPi

Python package is available on PyPi.

The pypi package is viewable at https://pypi.org/project/cdktf-proxmox/

```bash
pip install cdktf-proxmox
```

### Nuget

C# package is available on Nuget.

The nuget package is viewable at https://www.nuget.org/packages/awlsring.CdktfProxmox/

```bash
dotnet add package awlsring.CdktfProxmox
```
# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### DataProxmoxLvms <a name="DataProxmoxLvms" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvms proxmox_lvms}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvms.DataProxmoxLvms(scope: Construct, id: string, config?: DataProxmoxLvmsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxLvmsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isConstruct"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

dataProxmoxLvms.DataProxmoxLvms.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isTerraformElement"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

dataProxmoxLvms.DataProxmoxLvms.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isTerraformDataSource"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

dataProxmoxLvms.DataProxmoxLvms.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.lvms">lvms</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.filters"></a>

```typescript
public readonly filters: DataProxmoxLvmsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList

---

##### `lvms`<sup>Required</sup> <a name="lvms" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.lvms"></a>

```typescript
public readonly lvms: DataProxmoxLvmsLvmsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxLvmsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvms.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxLvmStorageClasses <a name="DataProxmoxLvmStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes proxmox_lvm_storage_classes}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses(scope: Construct, id: string, config?: DataProxmoxLvmStorageClassesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxLvmStorageClassesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isConstruct"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformElement"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformDataSource"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.lvmStorageClasses">lvmStorageClasses</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.filters"></a>

```typescript
public readonly filters: DataProxmoxLvmStorageClassesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList

---

##### `lvmStorageClasses`<sup>Required</sup> <a name="lvmStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.lvmStorageClasses"></a>

```typescript
public readonly lvmStorageClasses: DataProxmoxLvmStorageClassesLvmStorageClassesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxLvmStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClasses.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxLvmThinpools <a name="DataProxmoxLvmThinpools" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools proxmox_lvm_thinpools}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpools.DataProxmoxLvmThinpools(scope: Construct, id: string, config?: DataProxmoxLvmThinpoolsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxLvmThinpoolsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isConstruct"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformElement"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformDataSource"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.lvmThinpools">lvmThinpools</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.filters"></a>

```typescript
public readonly filters: DataProxmoxLvmThinpoolsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList

---

##### `lvmThinpools`<sup>Required</sup> <a name="lvmThinpools" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.lvmThinpools"></a>

```typescript
public readonly lvmThinpools: DataProxmoxLvmThinpoolsLvmThinpoolsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxLvmThinpoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpools.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxLvmThinpoolStorageClasses <a name="DataProxmoxLvmThinpoolStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes proxmox_lvm_thinpool_storage_classes}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses(scope: Construct, id: string, config?: DataProxmoxLvmThinpoolStorageClassesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxLvmThinpoolStorageClassesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isConstruct"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformElement"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformDataSource"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.lvmThinpoolStorageClasses">lvmThinpoolStorageClasses</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.filters"></a>

```typescript
public readonly filters: DataProxmoxLvmThinpoolStorageClassesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList

---

##### `lvmThinpoolStorageClasses`<sup>Required</sup> <a name="lvmThinpoolStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.lvmThinpoolStorageClasses"></a>

```typescript
public readonly lvmThinpoolStorageClasses: DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxLvmThinpoolStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClasses.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNetworkBonds <a name="DataProxmoxNetworkBonds" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds proxmox_network_bonds}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBonds(scope: Construct, id: string, config?: DataProxmoxNetworkBondsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNetworkBondsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isConstruct"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformElement"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.networkBonds">networkBonds</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNetworkBondsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList

---

##### `networkBonds`<sup>Required</sup> <a name="networkBonds" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.networkBonds"></a>

```typescript
public readonly networkBonds: DataProxmoxNetworkBondsNetworkBondsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNetworkBondsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBonds.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNetworkBridges <a name="DataProxmoxNetworkBridges" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges proxmox_network_bridges}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridges(scope: Construct, id: string, config?: DataProxmoxNetworkBridgesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNetworkBridgesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isConstruct"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformElement"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.networkBridges">networkBridges</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNetworkBridgesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList

---

##### `networkBridges`<sup>Required</sup> <a name="networkBridges" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.networkBridges"></a>

```typescript
public readonly networkBridges: DataProxmoxNetworkBridgesNetworkBridgesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNetworkBridgesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridges.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNfsStorageClasses <a name="DataProxmoxNfsStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes proxmox_nfs_storage_classes}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses(scope: Construct, id: string, config?: DataProxmoxNfsStorageClassesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNfsStorageClassesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isConstruct"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformElement"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.nfsStorageClasses">nfsStorageClasses</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNfsStorageClassesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList

---

##### `nfsStorageClasses`<sup>Required</sup> <a name="nfsStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.nfsStorageClasses"></a>

```typescript
public readonly nfsStorageClasses: DataProxmoxNfsStorageClassesNfsStorageClassesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNfsStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClasses.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNodes <a name="DataProxmoxNodes" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/nodes proxmox_nodes}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodes(scope: Construct, id: string, config?: DataProxmoxNodesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNodesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isConstruct"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

dataProxmoxNodes.DataProxmoxNodes.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isTerraformElement"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

dataProxmoxNodes.DataProxmoxNodes.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

dataProxmoxNodes.DataProxmoxNodes.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.nodes">nodes</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNodesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.nodes"></a>

```typescript
public readonly nodes: DataProxmoxNodesNodesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNodesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodes.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNodeStorageLvms <a name="DataProxmoxNodeStorageLvms" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms proxmox_node_storage_lvms}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms(scope: Construct, id: string, config?: DataProxmoxNodeStorageLvmsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNodeStorageLvmsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isConstruct"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformElement"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.nodeStorageLvms">nodeStorageLvms</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNodeStorageLvmsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList

---

##### `nodeStorageLvms`<sup>Required</sup> <a name="nodeStorageLvms" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.nodeStorageLvms"></a>

```typescript
public readonly nodeStorageLvms: DataProxmoxNodeStorageLvmsNodeStorageLvmsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNodeStorageLvmsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvms.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNodeStorageLvmThinpools <a name="DataProxmoxNodeStorageLvmThinpools" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools proxmox_node_storage_lvm_thinpools}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools(scope: Construct, id: string, config?: DataProxmoxNodeStorageLvmThinpoolsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNodeStorageLvmThinpoolsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isConstruct"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformElement"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.nodeStorageLvmThinpools">nodeStorageLvmThinpools</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNodeStorageLvmThinpoolsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList

---

##### `nodeStorageLvmThinpools`<sup>Required</sup> <a name="nodeStorageLvmThinpools" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.nodeStorageLvmThinpools"></a>

```typescript
public readonly nodeStorageLvmThinpools: DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNodeStorageLvmThinpoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpools.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNodeStorageNfs <a name="DataProxmoxNodeStorageNfs" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs proxmox_node_storage_nfs}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs(scope: Construct, id: string, config?: DataProxmoxNodeStorageNfsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNodeStorageNfsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isConstruct"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformElement"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.nodeStorageNfs">nodeStorageNfs</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNodeStorageNfsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList

---

##### `nodeStorageNfs`<sup>Required</sup> <a name="nodeStorageNfs" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.nodeStorageNfs"></a>

```typescript
public readonly nodeStorageNfs: DataProxmoxNodeStorageNfsNodeStorageNfsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNodeStorageNfsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfs.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxNodeStorageZfs <a name="DataProxmoxNodeStorageZfs" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_zfs proxmox_node_storage_zfs}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs(scope: Construct, id: string, config?: DataProxmoxNodeStorageZfsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxNodeStorageZfsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isConstruct"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformElement"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformDataSource"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.nodeStorageZfs">nodeStorageZfs</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.filters"></a>

```typescript
public readonly filters: DataProxmoxNodeStorageZfsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList

---

##### `nodeStorageZfs`<sup>Required</sup> <a name="nodeStorageZfs" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.nodeStorageZfs"></a>

```typescript
public readonly nodeStorageZfs: DataProxmoxNodeStorageZfsNodeStorageZfsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxNodeStorageZfsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfs.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxResourcePools <a name="DataProxmoxResourcePools" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools proxmox_resource_pools}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePools(scope: Construct, id: string, config?: DataProxmoxResourcePoolsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxResourcePoolsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isConstruct"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

dataProxmoxResourcePools.DataProxmoxResourcePools.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformElement"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformDataSource"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.resourcePools">resourcePools</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.filters"></a>

```typescript
public readonly filters: DataProxmoxResourcePoolsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList

---

##### `resourcePools`<sup>Required</sup> <a name="resourcePools" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.resourcePools"></a>

```typescript
public readonly resourcePools: DataProxmoxResourcePoolsResourcePoolsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxResourcePoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePools.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxTemplate <a name="DataProxmoxTemplate" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/template proxmox_template}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplate(scope: Construct, id: string, config: DataProxmoxTemplateConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isConstruct"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

dataProxmoxTemplate.DataProxmoxTemplate.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isTerraformElement"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

dataProxmoxTemplate.DataProxmoxTemplate.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isTerraformDataSource"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

dataProxmoxTemplate.DataProxmoxTemplate.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.agent">agent</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.bios">bios</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.cloudInit">cloudInit</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.cpu">cpu</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.disks">disks</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.keyboardLayout">keyboardLayout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.kvmArguments">kvmArguments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.machineType">machineType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.memory">memory</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.networkInterfaces">networkInterfaces</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.pciDevices">pciDevices</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.resourcePool">resourcePool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.startOnNodeBoot">startOnNodeBoot</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.tags">tags</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.idInput">idInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.id">id</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `agent`<sup>Required</sup> <a name="agent" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.agent"></a>

```typescript
public readonly agent: DataProxmoxTemplateAgentOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference

---

##### `bios`<sup>Required</sup> <a name="bios" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.bios"></a>

```typescript
public readonly bios: string;
```

- *Type:* string

---

##### `cloudInit`<sup>Required</sup> <a name="cloudInit" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.cloudInit"></a>

```typescript
public readonly cloudInit: DataProxmoxTemplateCloudInitOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference

---

##### `cpu`<sup>Required</sup> <a name="cpu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.cpu"></a>

```typescript
public readonly cpu: DataProxmoxTemplateCpuOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference

---

##### `description`<sup>Required</sup> <a name="description" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.disks"></a>

```typescript
public readonly disks: DataProxmoxTemplateDisksList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList

---

##### `keyboardLayout`<sup>Required</sup> <a name="keyboardLayout" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.keyboardLayout"></a>

```typescript
public readonly keyboardLayout: string;
```

- *Type:* string

---

##### `kvmArguments`<sup>Required</sup> <a name="kvmArguments" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.kvmArguments"></a>

```typescript
public readonly kvmArguments: string;
```

- *Type:* string

---

##### `machineType`<sup>Required</sup> <a name="machineType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.machineType"></a>

```typescript
public readonly machineType: string;
```

- *Type:* string

---

##### `memory`<sup>Required</sup> <a name="memory" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.memory"></a>

```typescript
public readonly memory: DataProxmoxTemplateMemoryOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference

---

##### `networkInterfaces`<sup>Required</sup> <a name="networkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.networkInterfaces"></a>

```typescript
public readonly networkInterfaces: DataProxmoxTemplateNetworkInterfacesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList

---

##### `pciDevices`<sup>Required</sup> <a name="pciDevices" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.pciDevices"></a>

```typescript
public readonly pciDevices: DataProxmoxTemplatePciDevicesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList

---

##### `resourcePool`<sup>Required</sup> <a name="resourcePool" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.resourcePool"></a>

```typescript
public readonly resourcePool: string;
```

- *Type:* string

---

##### `startOnNodeBoot`<sup>Required</sup> <a name="startOnNodeBoot" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.startOnNodeBoot"></a>

```typescript
public readonly startOnNodeBoot: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `tags`<sup>Required</sup> <a name="tags" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.idInput"></a>

```typescript
public readonly idInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.id"></a>

```typescript
public readonly id: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplate.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxTemplates <a name="DataProxmoxTemplates" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/templates proxmox_templates}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplates(scope: Construct, id: string, config?: DataProxmoxTemplatesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxTemplatesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isConstruct"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

dataProxmoxTemplates.DataProxmoxTemplates.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isTerraformElement"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

dataProxmoxTemplates.DataProxmoxTemplates.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isTerraformDataSource"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

dataProxmoxTemplates.DataProxmoxTemplates.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.templates">templates</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.filters"></a>

```typescript
public readonly filters: DataProxmoxTemplatesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList

---

##### `templates`<sup>Required</sup> <a name="templates" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.templates"></a>

```typescript
public readonly templates: DataProxmoxTemplatesTemplatesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxTemplatesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplates.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxVirtualMachines <a name="DataProxmoxVirtualMachines" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/virtual_machines proxmox_virtual_machines}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachines(scope: Construct, id: string, config?: DataProxmoxVirtualMachinesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxVirtualMachinesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isConstruct"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformElement"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformDataSource"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.virtualMachines">virtualMachines</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.filters"></a>

```typescript
public readonly filters: DataProxmoxVirtualMachinesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList

---

##### `virtualMachines`<sup>Required</sup> <a name="virtualMachines" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.virtualMachines"></a>

```typescript
public readonly virtualMachines: DataProxmoxVirtualMachinesVirtualMachinesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxVirtualMachinesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachines.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxZfsPools <a name="DataProxmoxZfsPools" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools proxmox_zfs_pools}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsPools.DataProxmoxZfsPools(scope: Construct, id: string, config?: DataProxmoxZfsPoolsConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxZfsPoolsFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isConstruct"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

dataProxmoxZfsPools.DataProxmoxZfsPools.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformElement"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformDataSource"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.zfsPools">zfsPools</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.filters"></a>

```typescript
public readonly filters: DataProxmoxZfsPoolsFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList

---

##### `zfsPools`<sup>Required</sup> <a name="zfsPools" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.zfsPools"></a>

```typescript
public readonly zfsPools: DataProxmoxZfsPoolsZfsPoolsList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxZfsPoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPools.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataProxmoxZfsStorageClasses <a name="DataProxmoxZfsStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes proxmox_zfs_storage_classes}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses(scope: Construct, id: string, config?: DataProxmoxZfsStorageClassesConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.putFilters">putFilters</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.resetFilters">resetFilters</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putFilters` <a name="putFilters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.putFilters"></a>

```typescript
public putFilters(value: IResolvable | DataProxmoxZfsStorageClassesFilters[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.putFilters.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]

---

##### `resetFilters` <a name="resetFilters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.resetFilters"></a>

```typescript
public resetFilters(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformDataSource">isTerraformDataSource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isConstruct"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformElement"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformDataSource` <a name="isTerraformDataSource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformDataSource"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformDataSource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.isTerraformDataSource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.filters">filters</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.zfsStorageClasses">zfsStorageClasses</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.filtersInput">filtersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `filters`<sup>Required</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.filters"></a>

```typescript
public readonly filters: DataProxmoxZfsStorageClassesFiltersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList

---

##### `zfsStorageClasses`<sup>Required</sup> <a name="zfsStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.zfsStorageClasses"></a>

```typescript
public readonly zfsStorageClasses: DataProxmoxZfsStorageClassesZfsStorageClassesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList

---

##### `filtersInput`<sup>Optional</sup> <a name="filtersInput" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.filtersInput"></a>

```typescript
public readonly filtersInput: IResolvable | DataProxmoxZfsStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClasses.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### Lvm <a name="Lvm" id="@awlsring/cdktf-proxmox.lvm.Lvm"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/lvm proxmox_lvm}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.lvm.Lvm.Initializer"></a>

```typescript
import { lvm } from '@awlsring/cdktf-proxmox'

new lvm.Lvm(scope: Construct, id: string, config: LvmConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.lvm.LvmConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.lvm.Lvm.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvm.Lvm.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.lvm.Lvm.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.lvm.LvmConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.lvm.Lvm.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.lvm.Lvm.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.lvm.Lvm.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.lvm.Lvm.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.lvm.Lvm.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.lvm.Lvm.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.lvm.Lvm.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.lvm.Lvm.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.lvm.Lvm.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.lvm.Lvm.isConstruct"></a>

```typescript
import { lvm } from '@awlsring/cdktf-proxmox'

lvm.Lvm.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvm.Lvm.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.lvm.Lvm.isTerraformElement"></a>

```typescript
import { lvm } from '@awlsring/cdktf-proxmox'

lvm.Lvm.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvm.Lvm.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.lvm.Lvm.isTerraformResource"></a>

```typescript
import { lvm } from '@awlsring/cdktf-proxmox'

lvm.Lvm.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvm.Lvm.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.deviceInput">deviceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.device">device</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `deviceInput`<sup>Optional</sup> <a name="deviceInput" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.deviceInput"></a>

```typescript
public readonly deviceInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.Lvm.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.lvm.Lvm.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### LvmStorageClass <a name="LvmStorageClass" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_storage_class proxmox_lvm_storage_class}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer"></a>

```typescript
import { lvmStorageClass } from '@awlsring/cdktf-proxmox'

new lvmStorageClass.LvmStorageClass(scope: Construct, id: string, config: LvmStorageClassConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.resetContentTypes">resetContentTypes</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.resetNodes">resetNodes</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetContentTypes` <a name="resetContentTypes" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.resetContentTypes"></a>

```typescript
public resetContentTypes(): void
```

##### `resetNodes` <a name="resetNodes" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.resetNodes"></a>

```typescript
public resetNodes(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isConstruct"></a>

```typescript
import { lvmStorageClass } from '@awlsring/cdktf-proxmox'

lvmStorageClass.LvmStorageClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isTerraformElement"></a>

```typescript
import { lvmStorageClass } from '@awlsring/cdktf-proxmox'

lvmStorageClass.LvmStorageClass.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isTerraformResource"></a>

```typescript
import { lvmStorageClass } from '@awlsring/cdktf-proxmox'

lvmStorageClass.LvmStorageClass.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.contentTypesInput">contentTypesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.nodesInput">nodesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.volumeGroupInput">volumeGroupInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `contentTypesInput`<sup>Optional</sup> <a name="contentTypesInput" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.contentTypesInput"></a>

```typescript
public readonly contentTypesInput: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nodesInput`<sup>Optional</sup> <a name="nodesInput" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.nodesInput"></a>

```typescript
public readonly nodesInput: string[];
```

- *Type:* string[]

---

##### `volumeGroupInput`<sup>Optional</sup> <a name="volumeGroupInput" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.volumeGroupInput"></a>

```typescript
public readonly volumeGroupInput: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClass.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### LvmThinpool <a name="LvmThinpool" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool proxmox_lvm_thinpool}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer"></a>

```typescript
import { lvmThinpool } from '@awlsring/cdktf-proxmox'

new lvmThinpool.LvmThinpool(scope: Construct, id: string, config: LvmThinpoolConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isConstruct"></a>

```typescript
import { lvmThinpool } from '@awlsring/cdktf-proxmox'

lvmThinpool.LvmThinpool.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isTerraformElement"></a>

```typescript
import { lvmThinpool } from '@awlsring/cdktf-proxmox'

lvmThinpool.LvmThinpool.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isTerraformResource"></a>

```typescript
import { lvmThinpool } from '@awlsring/cdktf-proxmox'

lvmThinpool.LvmThinpool.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.metadataSize">metadataSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.deviceInput">deviceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.device">device</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `metadataSize`<sup>Required</sup> <a name="metadataSize" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.metadataSize"></a>

```typescript
public readonly metadataSize: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

##### `deviceInput`<sup>Optional</sup> <a name="deviceInput" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.deviceInput"></a>

```typescript
public readonly deviceInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpool.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### LvmThinpoolStorageClass <a name="LvmThinpoolStorageClass" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool_storage_class proxmox_lvm_thinpool_storage_class}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer"></a>

```typescript
import { lvmThinpoolStorageClass } from '@awlsring/cdktf-proxmox'

new lvmThinpoolStorageClass.LvmThinpoolStorageClass(scope: Construct, id: string, config: LvmThinpoolStorageClassConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.resetContentTypes">resetContentTypes</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.resetNodes">resetNodes</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetContentTypes` <a name="resetContentTypes" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.resetContentTypes"></a>

```typescript
public resetContentTypes(): void
```

##### `resetNodes` <a name="resetNodes" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.resetNodes"></a>

```typescript
public resetNodes(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isConstruct"></a>

```typescript
import { lvmThinpoolStorageClass } from '@awlsring/cdktf-proxmox'

lvmThinpoolStorageClass.LvmThinpoolStorageClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformElement"></a>

```typescript
import { lvmThinpoolStorageClass } from '@awlsring/cdktf-proxmox'

lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformResource"></a>

```typescript
import { lvmThinpoolStorageClass } from '@awlsring/cdktf-proxmox'

lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.contentTypesInput">contentTypesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.nodesInput">nodesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.thinpoolInput">thinpoolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.volumeGroupInput">volumeGroupInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.thinpool">thinpool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `contentTypesInput`<sup>Optional</sup> <a name="contentTypesInput" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.contentTypesInput"></a>

```typescript
public readonly contentTypesInput: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nodesInput`<sup>Optional</sup> <a name="nodesInput" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.nodesInput"></a>

```typescript
public readonly nodesInput: string[];
```

- *Type:* string[]

---

##### `thinpoolInput`<sup>Optional</sup> <a name="thinpoolInput" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.thinpoolInput"></a>

```typescript
public readonly thinpoolInput: string;
```

- *Type:* string

---

##### `volumeGroupInput`<sup>Optional</sup> <a name="volumeGroupInput" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.volumeGroupInput"></a>

```typescript
public readonly volumeGroupInput: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `thinpool`<sup>Required</sup> <a name="thinpool" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.thinpool"></a>

```typescript
public readonly thinpool: string;
```

- *Type:* string

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClass.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### NetworkBond <a name="NetworkBond" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond proxmox_network_bond}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

new networkBond.NetworkBond(scope: Construct, id: string, config: NetworkBondConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetAutostart">resetAutostart</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetBondPrimary">resetBondPrimary</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetComments">resetComments</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetHashPolicy">resetHashPolicy</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv4">resetIpv4</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv4Gateway">resetIpv4Gateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv6">resetIpv6</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv6Gateway">resetIpv6Gateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetAutostart` <a name="resetAutostart" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetAutostart"></a>

```typescript
public resetAutostart(): void
```

##### `resetBondPrimary` <a name="resetBondPrimary" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetBondPrimary"></a>

```typescript
public resetBondPrimary(): void
```

##### `resetComments` <a name="resetComments" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetComments"></a>

```typescript
public resetComments(): void
```

##### `resetHashPolicy` <a name="resetHashPolicy" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetHashPolicy"></a>

```typescript
public resetHashPolicy(): void
```

##### `resetIpv4` <a name="resetIpv4" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv4"></a>

```typescript
public resetIpv4(): void
```

##### `resetIpv4Gateway` <a name="resetIpv4Gateway" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv4Gateway"></a>

```typescript
public resetIpv4Gateway(): void
```

##### `resetIpv6` <a name="resetIpv6" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv6"></a>

```typescript
public resetIpv6(): void
```

##### `resetIpv6Gateway` <a name="resetIpv6Gateway" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetIpv6Gateway"></a>

```typescript
public resetIpv6Gateway(): void
```

##### `resetName` <a name="resetName" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.isConstruct"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

networkBond.NetworkBond.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.isTerraformElement"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

networkBond.NetworkBond.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.isTerraformResource"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

networkBond.NetworkBond.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.active">active</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.miiMon">miiMon</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.autostartInput">autostartInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.bondPrimaryInput">bondPrimaryInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.commentsInput">commentsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.hashPolicyInput">hashPolicyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.interfacesInput">interfacesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4GatewayInput">ipv4GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4Input">ipv4Input</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6GatewayInput">ipv6GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6Input">ipv6Input</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.modeInput">modeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.autostart">autostart</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.bondPrimary">bondPrimary</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.comments">comments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.hashPolicy">hashPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.interfaces">interfaces</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4">ipv4</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6">ipv6</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `active`<sup>Required</sup> <a name="active" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.active"></a>

```typescript
public readonly active: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `miiMon`<sup>Required</sup> <a name="miiMon" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.miiMon"></a>

```typescript
public readonly miiMon: string;
```

- *Type:* string

---

##### `autostartInput`<sup>Optional</sup> <a name="autostartInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.autostartInput"></a>

```typescript
public readonly autostartInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `bondPrimaryInput`<sup>Optional</sup> <a name="bondPrimaryInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.bondPrimaryInput"></a>

```typescript
public readonly bondPrimaryInput: string;
```

- *Type:* string

---

##### `commentsInput`<sup>Optional</sup> <a name="commentsInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.commentsInput"></a>

```typescript
public readonly commentsInput: string;
```

- *Type:* string

---

##### `hashPolicyInput`<sup>Optional</sup> <a name="hashPolicyInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.hashPolicyInput"></a>

```typescript
public readonly hashPolicyInput: string;
```

- *Type:* string

---

##### `interfacesInput`<sup>Optional</sup> <a name="interfacesInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.interfacesInput"></a>

```typescript
public readonly interfacesInput: string[];
```

- *Type:* string[]

---

##### `ipv4GatewayInput`<sup>Optional</sup> <a name="ipv4GatewayInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4GatewayInput"></a>

```typescript
public readonly ipv4GatewayInput: string;
```

- *Type:* string

---

##### `ipv4Input`<sup>Optional</sup> <a name="ipv4Input" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4Input"></a>

```typescript
public readonly ipv4Input: NetworkBondIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 | cdktf.IResolvable

---

##### `ipv6GatewayInput`<sup>Optional</sup> <a name="ipv6GatewayInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6GatewayInput"></a>

```typescript
public readonly ipv6GatewayInput: string;
```

- *Type:* string

---

##### `ipv6Input`<sup>Optional</sup> <a name="ipv6Input" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6Input"></a>

```typescript
public readonly ipv6Input: NetworkBondIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 | cdktf.IResolvable

---

##### `modeInput`<sup>Optional</sup> <a name="modeInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.modeInput"></a>

```typescript
public readonly modeInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `autostart`<sup>Required</sup> <a name="autostart" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.autostart"></a>

```typescript
public readonly autostart: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `bondPrimary`<sup>Required</sup> <a name="bondPrimary" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.bondPrimary"></a>

```typescript
public readonly bondPrimary: string;
```

- *Type:* string

---

##### `comments`<sup>Required</sup> <a name="comments" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

---

##### `hashPolicy`<sup>Required</sup> <a name="hashPolicy" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.hashPolicy"></a>

```typescript
public readonly hashPolicy: string;
```

- *Type:* string

---

##### `interfaces`<sup>Required</sup> <a name="interfaces" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.interfaces"></a>

```typescript
public readonly interfaces: string[];
```

- *Type:* string[]

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4"></a>

```typescript
public readonly ipv4: NetworkBondIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 | cdktf.IResolvable

---

##### `ipv4Gateway`<sup>Required</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6"></a>

```typescript
public readonly ipv6: NetworkBondIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 | cdktf.IResolvable

---

##### `ipv6Gateway`<sup>Required</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.networkBond.NetworkBond.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### NetworkBridge <a name="NetworkBridge" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge proxmox_network_bridge}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

new networkBridge.NetworkBridge(scope: Construct, id: string, config: NetworkBridgeConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetAutostart">resetAutostart</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetComments">resetComments</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv4">resetIpv4</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv4Gateway">resetIpv4Gateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv6">resetIpv6</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv6Gateway">resetIpv6Gateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetVlanAware">resetVlanAware</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetAutostart` <a name="resetAutostart" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetAutostart"></a>

```typescript
public resetAutostart(): void
```

##### `resetComments` <a name="resetComments" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetComments"></a>

```typescript
public resetComments(): void
```

##### `resetIpv4` <a name="resetIpv4" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv4"></a>

```typescript
public resetIpv4(): void
```

##### `resetIpv4Gateway` <a name="resetIpv4Gateway" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv4Gateway"></a>

```typescript
public resetIpv4Gateway(): void
```

##### `resetIpv6` <a name="resetIpv6" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv6"></a>

```typescript
public resetIpv6(): void
```

##### `resetIpv6Gateway` <a name="resetIpv6Gateway" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetIpv6Gateway"></a>

```typescript
public resetIpv6Gateway(): void
```

##### `resetName` <a name="resetName" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetName"></a>

```typescript
public resetName(): void
```

##### `resetVlanAware` <a name="resetVlanAware" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.resetVlanAware"></a>

```typescript
public resetVlanAware(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isConstruct"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

networkBridge.NetworkBridge.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isTerraformElement"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

networkBridge.NetworkBridge.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isTerraformResource"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

networkBridge.NetworkBridge.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.active">active</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.autostartInput">autostartInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.commentsInput">commentsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.interfacesInput">interfacesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4GatewayInput">ipv4GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4Input">ipv4Input</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6GatewayInput">ipv6GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6Input">ipv6Input</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.vlanAwareInput">vlanAwareInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.autostart">autostart</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.comments">comments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.interfaces">interfaces</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4">ipv4</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6">ipv6</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.vlanAware">vlanAware</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `active`<sup>Required</sup> <a name="active" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.active"></a>

```typescript
public readonly active: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `autostartInput`<sup>Optional</sup> <a name="autostartInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.autostartInput"></a>

```typescript
public readonly autostartInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `commentsInput`<sup>Optional</sup> <a name="commentsInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.commentsInput"></a>

```typescript
public readonly commentsInput: string;
```

- *Type:* string

---

##### `interfacesInput`<sup>Optional</sup> <a name="interfacesInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.interfacesInput"></a>

```typescript
public readonly interfacesInput: string[];
```

- *Type:* string[]

---

##### `ipv4GatewayInput`<sup>Optional</sup> <a name="ipv4GatewayInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4GatewayInput"></a>

```typescript
public readonly ipv4GatewayInput: string;
```

- *Type:* string

---

##### `ipv4Input`<sup>Optional</sup> <a name="ipv4Input" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4Input"></a>

```typescript
public readonly ipv4Input: NetworkBridgeIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 | cdktf.IResolvable

---

##### `ipv6GatewayInput`<sup>Optional</sup> <a name="ipv6GatewayInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6GatewayInput"></a>

```typescript
public readonly ipv6GatewayInput: string;
```

- *Type:* string

---

##### `ipv6Input`<sup>Optional</sup> <a name="ipv6Input" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6Input"></a>

```typescript
public readonly ipv6Input: NetworkBridgeIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 | cdktf.IResolvable

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `vlanAwareInput`<sup>Optional</sup> <a name="vlanAwareInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.vlanAwareInput"></a>

```typescript
public readonly vlanAwareInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `autostart`<sup>Required</sup> <a name="autostart" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.autostart"></a>

```typescript
public readonly autostart: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `comments`<sup>Required</sup> <a name="comments" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

---

##### `interfaces`<sup>Required</sup> <a name="interfaces" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.interfaces"></a>

```typescript
public readonly interfaces: string[];
```

- *Type:* string[]

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4"></a>

```typescript
public readonly ipv4: NetworkBridgeIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 | cdktf.IResolvable

---

##### `ipv4Gateway`<sup>Required</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6"></a>

```typescript
public readonly ipv6: NetworkBridgeIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 | cdktf.IResolvable

---

##### `ipv6Gateway`<sup>Required</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `vlanAware`<sup>Required</sup> <a name="vlanAware" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.vlanAware"></a>

```typescript
public readonly vlanAware: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridge.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### NfsStorageClass <a name="NfsStorageClass" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/nfs_storage_class proxmox_nfs_storage_class}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer"></a>

```typescript
import { nfsStorageClass } from '@awlsring/cdktf-proxmox'

new nfsStorageClass.NfsStorageClass(scope: Construct, id: string, config: NfsStorageClassConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.resetContentTypes">resetContentTypes</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.resetNodes">resetNodes</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetContentTypes` <a name="resetContentTypes" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.resetContentTypes"></a>

```typescript
public resetContentTypes(): void
```

##### `resetNodes` <a name="resetNodes" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.resetNodes"></a>

```typescript
public resetNodes(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isConstruct"></a>

```typescript
import { nfsStorageClass } from '@awlsring/cdktf-proxmox'

nfsStorageClass.NfsStorageClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isTerraformElement"></a>

```typescript
import { nfsStorageClass } from '@awlsring/cdktf-proxmox'

nfsStorageClass.NfsStorageClass.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isTerraformResource"></a>

```typescript
import { nfsStorageClass } from '@awlsring/cdktf-proxmox'

nfsStorageClass.NfsStorageClass.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.mount">mount</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.contentTypesInput">contentTypesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.exportInput">exportInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.nodesInput">nodesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.serverInput">serverInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.export">export</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.server">server</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `mount`<sup>Required</sup> <a name="mount" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.mount"></a>

```typescript
public readonly mount: string;
```

- *Type:* string

---

##### `contentTypesInput`<sup>Optional</sup> <a name="contentTypesInput" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.contentTypesInput"></a>

```typescript
public readonly contentTypesInput: string[];
```

- *Type:* string[]

---

##### `exportInput`<sup>Optional</sup> <a name="exportInput" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.exportInput"></a>

```typescript
public readonly exportInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nodesInput`<sup>Optional</sup> <a name="nodesInput" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.nodesInput"></a>

```typescript
public readonly nodesInput: string[];
```

- *Type:* string[]

---

##### `serverInput`<sup>Optional</sup> <a name="serverInput" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.serverInput"></a>

```typescript
public readonly serverInput: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `export`<sup>Required</sup> <a name="export" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.export"></a>

```typescript
public readonly export: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `server`<sup>Required</sup> <a name="server" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClass.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ProxmoxProvider <a name="ProxmoxProvider" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox proxmox}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer"></a>

```typescript
import { provider } from '@awlsring/cdktf-proxmox'

new provider.ProxmoxProvider(scope: Construct, id: string, config: ProxmoxProviderConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetAlias">resetAlias</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetApiKey">resetApiKey</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetInsecure">resetInsecure</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetUsername">resetUsername</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `resetAlias` <a name="resetAlias" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetAlias"></a>

```typescript
public resetAlias(): void
```

##### `resetApiKey` <a name="resetApiKey" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetApiKey"></a>

```typescript
public resetApiKey(): void
```

##### `resetInsecure` <a name="resetInsecure" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetInsecure"></a>

```typescript
public resetInsecure(): void
```

##### `resetPassword` <a name="resetPassword" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetUsername` <a name="resetUsername" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.resetUsername"></a>

```typescript
public resetUsername(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isTerraformProvider">isTerraformProvider</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isConstruct"></a>

```typescript
import { provider } from '@awlsring/cdktf-proxmox'

provider.ProxmoxProvider.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isTerraformElement"></a>

```typescript
import { provider } from '@awlsring/cdktf-proxmox'

provider.ProxmoxProvider.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformProvider` <a name="isTerraformProvider" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isTerraformProvider"></a>

```typescript
import { provider } from '@awlsring/cdktf-proxmox'

provider.ProxmoxProvider.isTerraformProvider(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.isTerraformProvider.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.metaAttributes">metaAttributes</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.terraformProviderSource">terraformProviderSource</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.alias">alias</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.aliasInput">aliasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.apiKeyInput">apiKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.endpointInput">endpointInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.insecureInput">insecureInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.usernameInput">usernameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.apiKey">apiKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.endpoint">endpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.insecure">insecure</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.username">username</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `metaAttributes`<sup>Required</sup> <a name="metaAttributes" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.metaAttributes"></a>

```typescript
public readonly metaAttributes: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `terraformProviderSource`<sup>Optional</sup> <a name="terraformProviderSource" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.terraformProviderSource"></a>

```typescript
public readonly terraformProviderSource: string;
```

- *Type:* string

---

##### `alias`<sup>Optional</sup> <a name="alias" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

---

##### `aliasInput`<sup>Optional</sup> <a name="aliasInput" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.aliasInput"></a>

```typescript
public readonly aliasInput: string;
```

- *Type:* string

---

##### `apiKeyInput`<sup>Optional</sup> <a name="apiKeyInput" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.apiKeyInput"></a>

```typescript
public readonly apiKeyInput: string;
```

- *Type:* string

---

##### `endpointInput`<sup>Optional</sup> <a name="endpointInput" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.endpointInput"></a>

```typescript
public readonly endpointInput: string;
```

- *Type:* string

---

##### `insecureInput`<sup>Optional</sup> <a name="insecureInput" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.insecureInput"></a>

```typescript
public readonly insecureInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `usernameInput`<sup>Optional</sup> <a name="usernameInput" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.usernameInput"></a>

```typescript
public readonly usernameInput: string;
```

- *Type:* string

---

##### `apiKey`<sup>Optional</sup> <a name="apiKey" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.apiKey"></a>

```typescript
public readonly apiKey: string;
```

- *Type:* string

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

---

##### `insecure`<sup>Optional</sup> <a name="insecure" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.insecure"></a>

```typescript
public readonly insecure: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `password`<sup>Optional</sup> <a name="password" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `username`<sup>Optional</sup> <a name="username" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.provider.ProxmoxProvider.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcePool <a name="ResourcePool" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/resource_pool proxmox_resource_pool}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

new resourcePool.ResourcePool(scope: Construct, id: string, config: ResourcePoolConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.putMembers">putMembers</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.resetComment">resetComment</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.resetMembers">resetMembers</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putMembers` <a name="putMembers" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.putMembers"></a>

```typescript
public putMembers(value: IResolvable | ResourcePoolMembers[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.putMembers.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]

---

##### `resetComment` <a name="resetComment" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.resetComment"></a>

```typescript
public resetComment(): void
```

##### `resetMembers` <a name="resetMembers" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.resetMembers"></a>

```typescript
public resetMembers(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isConstruct"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

resourcePool.ResourcePool.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isTerraformElement"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

resourcePool.ResourcePool.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isTerraformResource"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

resourcePool.ResourcePool.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.members">members</a></code> | <code>@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.commentInput">commentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.membersInput">membersInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.comment">comment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.id">id</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `members`<sup>Required</sup> <a name="members" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.members"></a>

```typescript
public readonly members: ResourcePoolMembersList;
```

- *Type:* @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList

---

##### `commentInput`<sup>Optional</sup> <a name="commentInput" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.commentInput"></a>

```typescript
public readonly commentInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.membersInput"></a>

```typescript
public readonly membersInput: IResolvable | ResourcePoolMembers[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]

---

##### `comment`<sup>Required</sup> <a name="comment" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePool.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VirtualMachine <a name="VirtualMachine" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine proxmox_virtual_machine}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachine(scope: Construct, id: string, config: VirtualMachineConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putAgent">putAgent</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putClone">putClone</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putCloudInit">putCloudInit</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putCpu">putCpu</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putDisks">putDisks</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putIso">putIso</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putMemory">putMemory</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putNetworkInterfaces">putNetworkInterfaces</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putPciDevices">putPciDevices</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetAgent">resetAgent</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetBios">resetBios</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetClone">resetClone</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetCloudInit">resetCloudInit</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetCpu">resetCpu</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetDisks">resetDisks</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetIso">resetIso</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetKeyboardLayout">resetKeyboardLayout</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetKvmArguments">resetKvmArguments</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetMachineType">resetMachineType</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetMemory">resetMemory</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetNetworkInterfaces">resetNetworkInterfaces</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetPciDevices">resetPciDevices</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetResourcePool">resetResourcePool</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetStartOnCreate">resetStartOnCreate</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetStartOnNodeBoot">resetStartOnNodeBoot</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetTags">resetTags</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetType">resetType</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAgent` <a name="putAgent" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putAgent"></a>

```typescript
public putAgent(value: VirtualMachineAgent | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putAgent.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent | cdktf.IResolvable

---

##### `putClone` <a name="putClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putClone"></a>

```typescript
public putClone(value: VirtualMachineClone | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putClone.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone | cdktf.IResolvable

---

##### `putCloudInit` <a name="putCloudInit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putCloudInit"></a>

```typescript
public putCloudInit(value: VirtualMachineCloudInit | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putCloudInit.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit | cdktf.IResolvable

---

##### `putCpu` <a name="putCpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putCpu"></a>

```typescript
public putCpu(value: VirtualMachineCpu | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putCpu.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu | cdktf.IResolvable

---

##### `putDisks` <a name="putDisks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putDisks"></a>

```typescript
public putDisks(value: IResolvable | VirtualMachineDisks[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putDisks.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]

---

##### `putIso` <a name="putIso" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putIso"></a>

```typescript
public putIso(value: VirtualMachineIso | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putIso.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso | cdktf.IResolvable

---

##### `putMemory` <a name="putMemory" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putMemory"></a>

```typescript
public putMemory(value: VirtualMachineMemory | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putMemory.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory | cdktf.IResolvable

---

##### `putNetworkInterfaces` <a name="putNetworkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putNetworkInterfaces"></a>

```typescript
public putNetworkInterfaces(value: IResolvable | VirtualMachineNetworkInterfaces[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putNetworkInterfaces.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]

---

##### `putPciDevices` <a name="putPciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putPciDevices"></a>

```typescript
public putPciDevices(value: IResolvable | VirtualMachinePciDevices[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putPciDevices.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]

---

##### `putTimeouts` <a name="putTimeouts" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putTimeouts"></a>

```typescript
public putTimeouts(value: VirtualMachineTimeouts | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.putTimeouts.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts | cdktf.IResolvable

---

##### `resetAgent` <a name="resetAgent" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetAgent"></a>

```typescript
public resetAgent(): void
```

##### `resetBios` <a name="resetBios" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetBios"></a>

```typescript
public resetBios(): void
```

##### `resetClone` <a name="resetClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetClone"></a>

```typescript
public resetClone(): void
```

##### `resetCloudInit` <a name="resetCloudInit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetCloudInit"></a>

```typescript
public resetCloudInit(): void
```

##### `resetCpu` <a name="resetCpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetCpu"></a>

```typescript
public resetCpu(): void
```

##### `resetDescription` <a name="resetDescription" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetDisks` <a name="resetDisks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetDisks"></a>

```typescript
public resetDisks(): void
```

##### `resetId` <a name="resetId" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetId"></a>

```typescript
public resetId(): void
```

##### `resetIso` <a name="resetIso" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetIso"></a>

```typescript
public resetIso(): void
```

##### `resetKeyboardLayout` <a name="resetKeyboardLayout" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetKeyboardLayout"></a>

```typescript
public resetKeyboardLayout(): void
```

##### `resetKvmArguments` <a name="resetKvmArguments" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetKvmArguments"></a>

```typescript
public resetKvmArguments(): void
```

##### `resetMachineType` <a name="resetMachineType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetMachineType"></a>

```typescript
public resetMachineType(): void
```

##### `resetMemory` <a name="resetMemory" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetMemory"></a>

```typescript
public resetMemory(): void
```

##### `resetName` <a name="resetName" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNetworkInterfaces` <a name="resetNetworkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetNetworkInterfaces"></a>

```typescript
public resetNetworkInterfaces(): void
```

##### `resetPciDevices` <a name="resetPciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetPciDevices"></a>

```typescript
public resetPciDevices(): void
```

##### `resetResourcePool` <a name="resetResourcePool" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetResourcePool"></a>

```typescript
public resetResourcePool(): void
```

##### `resetStartOnCreate` <a name="resetStartOnCreate" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetStartOnCreate"></a>

```typescript
public resetStartOnCreate(): void
```

##### `resetStartOnNodeBoot` <a name="resetStartOnNodeBoot" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetStartOnNodeBoot"></a>

```typescript
public resetStartOnNodeBoot(): void
```

##### `resetTags` <a name="resetTags" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetTags"></a>

```typescript
public resetTags(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetType` <a name="resetType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.resetType"></a>

```typescript
public resetType(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isConstruct"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

virtualMachine.VirtualMachine.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isTerraformElement"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

virtualMachine.VirtualMachine.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isTerraformResource"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

virtualMachine.VirtualMachine.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.agent">agent</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.clone">clone</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cloudInit">cloudInit</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.computedDisks">computedDisks</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.computedNetworkInterfaces">computedNetworkInterfaces</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.computedPciDevices">computedPciDevices</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cpu">cpu</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.disks">disks</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.iso">iso</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.memory">memory</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.networkInterfaces">networkInterfaces</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.pciDevices">pciDevices</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.timeouts">timeouts</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.agentInput">agentInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.biosInput">biosInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cloneInput">cloneInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cloudInitInput">cloudInitInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cpuInput">cpuInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.disksInput">disksInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.idInput">idInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.isoInput">isoInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.keyboardLayoutInput">keyboardLayoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.kvmArgumentsInput">kvmArgumentsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.machineTypeInput">machineTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.memoryInput">memoryInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.networkInterfacesInput">networkInterfacesInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.pciDevicesInput">pciDevicesInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.resourcePoolInput">resourcePoolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnCreateInput">startOnCreateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnNodeBootInput">startOnNodeBootInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.tagsInput">tagsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.timeoutsInput">timeoutsInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.bios">bios</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.id">id</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.keyboardLayout">keyboardLayout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.kvmArguments">kvmArguments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.machineType">machineType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.resourcePool">resourcePool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnCreate">startOnCreate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnNodeBoot">startOnNodeBoot</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.tags">tags</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.type">type</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `agent`<sup>Required</sup> <a name="agent" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.agent"></a>

```typescript
public readonly agent: VirtualMachineAgentOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference

---

##### `clone`<sup>Required</sup> <a name="clone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.clone"></a>

```typescript
public readonly clone: VirtualMachineCloneOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference

---

##### `cloudInit`<sup>Required</sup> <a name="cloudInit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cloudInit"></a>

```typescript
public readonly cloudInit: VirtualMachineCloudInitOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference

---

##### `computedDisks`<sup>Required</sup> <a name="computedDisks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.computedDisks"></a>

```typescript
public readonly computedDisks: VirtualMachineComputedDisksList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList

---

##### `computedNetworkInterfaces`<sup>Required</sup> <a name="computedNetworkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.computedNetworkInterfaces"></a>

```typescript
public readonly computedNetworkInterfaces: VirtualMachineComputedNetworkInterfacesList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList

---

##### `computedPciDevices`<sup>Required</sup> <a name="computedPciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.computedPciDevices"></a>

```typescript
public readonly computedPciDevices: VirtualMachineComputedPciDevicesList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList

---

##### `cpu`<sup>Required</sup> <a name="cpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cpu"></a>

```typescript
public readonly cpu: VirtualMachineCpuOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.disks"></a>

```typescript
public readonly disks: VirtualMachineDisksList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList

---

##### `iso`<sup>Required</sup> <a name="iso" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.iso"></a>

```typescript
public readonly iso: VirtualMachineIsoOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference

---

##### `memory`<sup>Required</sup> <a name="memory" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.memory"></a>

```typescript
public readonly memory: VirtualMachineMemoryOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference

---

##### `networkInterfaces`<sup>Required</sup> <a name="networkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.networkInterfaces"></a>

```typescript
public readonly networkInterfaces: VirtualMachineNetworkInterfacesList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList

---

##### `pciDevices`<sup>Required</sup> <a name="pciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.pciDevices"></a>

```typescript
public readonly pciDevices: VirtualMachinePciDevicesList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.timeouts"></a>

```typescript
public readonly timeouts: VirtualMachineTimeoutsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference

---

##### `agentInput`<sup>Optional</sup> <a name="agentInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.agentInput"></a>

```typescript
public readonly agentInput: VirtualMachineAgent | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent | cdktf.IResolvable

---

##### `biosInput`<sup>Optional</sup> <a name="biosInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.biosInput"></a>

```typescript
public readonly biosInput: string;
```

- *Type:* string

---

##### `cloneInput`<sup>Optional</sup> <a name="cloneInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cloneInput"></a>

```typescript
public readonly cloneInput: VirtualMachineClone | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone | cdktf.IResolvable

---

##### `cloudInitInput`<sup>Optional</sup> <a name="cloudInitInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cloudInitInput"></a>

```typescript
public readonly cloudInitInput: VirtualMachineCloudInit | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit | cdktf.IResolvable

---

##### `cpuInput`<sup>Optional</sup> <a name="cpuInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.cpuInput"></a>

```typescript
public readonly cpuInput: VirtualMachineCpu | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `disksInput`<sup>Optional</sup> <a name="disksInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.disksInput"></a>

```typescript
public readonly disksInput: IResolvable | VirtualMachineDisks[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.idInput"></a>

```typescript
public readonly idInput: number;
```

- *Type:* number

---

##### `isoInput`<sup>Optional</sup> <a name="isoInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.isoInput"></a>

```typescript
public readonly isoInput: VirtualMachineIso | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso | cdktf.IResolvable

---

##### `keyboardLayoutInput`<sup>Optional</sup> <a name="keyboardLayoutInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.keyboardLayoutInput"></a>

```typescript
public readonly keyboardLayoutInput: string;
```

- *Type:* string

---

##### `kvmArgumentsInput`<sup>Optional</sup> <a name="kvmArgumentsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.kvmArgumentsInput"></a>

```typescript
public readonly kvmArgumentsInput: string;
```

- *Type:* string

---

##### `machineTypeInput`<sup>Optional</sup> <a name="machineTypeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.machineTypeInput"></a>

```typescript
public readonly machineTypeInput: string;
```

- *Type:* string

---

##### `memoryInput`<sup>Optional</sup> <a name="memoryInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.memoryInput"></a>

```typescript
public readonly memoryInput: VirtualMachineMemory | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory | cdktf.IResolvable

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkInterfacesInput`<sup>Optional</sup> <a name="networkInterfacesInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.networkInterfacesInput"></a>

```typescript
public readonly networkInterfacesInput: IResolvable | VirtualMachineNetworkInterfaces[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `pciDevicesInput`<sup>Optional</sup> <a name="pciDevicesInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.pciDevicesInput"></a>

```typescript
public readonly pciDevicesInput: IResolvable | VirtualMachinePciDevices[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]

---

##### `resourcePoolInput`<sup>Optional</sup> <a name="resourcePoolInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.resourcePoolInput"></a>

```typescript
public readonly resourcePoolInput: string;
```

- *Type:* string

---

##### `startOnCreateInput`<sup>Optional</sup> <a name="startOnCreateInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnCreateInput"></a>

```typescript
public readonly startOnCreateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `startOnNodeBootInput`<sup>Optional</sup> <a name="startOnNodeBootInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnNodeBootInput"></a>

```typescript
public readonly startOnNodeBootInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `tagsInput`<sup>Optional</sup> <a name="tagsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.tagsInput"></a>

```typescript
public readonly tagsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: VirtualMachineTimeouts | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts | cdktf.IResolvable

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `bios`<sup>Required</sup> <a name="bios" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.bios"></a>

```typescript
public readonly bios: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.id"></a>

```typescript
public readonly id: number;
```

- *Type:* number

---

##### `keyboardLayout`<sup>Required</sup> <a name="keyboardLayout" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.keyboardLayout"></a>

```typescript
public readonly keyboardLayout: string;
```

- *Type:* string

---

##### `kvmArguments`<sup>Required</sup> <a name="kvmArguments" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.kvmArguments"></a>

```typescript
public readonly kvmArguments: string;
```

- *Type:* string

---

##### `machineType`<sup>Required</sup> <a name="machineType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.machineType"></a>

```typescript
public readonly machineType: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `resourcePool`<sup>Required</sup> <a name="resourcePool" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.resourcePool"></a>

```typescript
public readonly resourcePool: string;
```

- *Type:* string

---

##### `startOnCreate`<sup>Required</sup> <a name="startOnCreate" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnCreate"></a>

```typescript
public readonly startOnCreate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `startOnNodeBoot`<sup>Required</sup> <a name="startOnNodeBoot" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.startOnNodeBoot"></a>

```typescript
public readonly startOnNodeBoot: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `tags`<sup>Required</sup> <a name="tags" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachine.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ZfsPool <a name="ZfsPool" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool proxmox_zfs_pool}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer"></a>

```typescript
import { zfsPool } from '@awlsring/cdktf-proxmox'

new zfsPool.ZfsPool(scope: Construct, id: string, config: ZfsPoolConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isConstruct"></a>

```typescript
import { zfsPool } from '@awlsring/cdktf-proxmox'

zfsPool.ZfsPool.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isTerraformElement"></a>

```typescript
import { zfsPool } from '@awlsring/cdktf-proxmox'

zfsPool.ZfsPool.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isTerraformResource"></a>

```typescript
import { zfsPool } from '@awlsring/cdktf-proxmox'

zfsPool.ZfsPool.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.disksInput">disksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.nodeAttributeInput">nodeAttributeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.raidLevelInput">raidLevelInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.disks">disks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.raidLevel">raidLevel</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `health`<sup>Required</sup> <a name="health" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `disksInput`<sup>Optional</sup> <a name="disksInput" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.disksInput"></a>

```typescript
public readonly disksInput: string[];
```

- *Type:* string[]

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeAttributeInput`<sup>Optional</sup> <a name="nodeAttributeInput" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.nodeAttributeInput"></a>

```typescript
public readonly nodeAttributeInput: string;
```

- *Type:* string

---

##### `raidLevelInput`<sup>Optional</sup> <a name="raidLevelInput" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.raidLevelInput"></a>

```typescript
public readonly raidLevelInput: string;
```

- *Type:* string

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.disks"></a>

```typescript
public readonly disks: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `raidLevel`<sup>Required</sup> <a name="raidLevel" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.raidLevel"></a>

```typescript
public readonly raidLevel: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPool.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ZfsStorageClass <a name="ZfsStorageClass" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass"></a>

Represents a {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_storage_class proxmox_zfs_storage_class}.

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer"></a>

```typescript
import { zfsStorageClass } from '@awlsring/cdktf-proxmox'

new zfsStorageClass.ZfsStorageClass(scope: Construct, id: string, config: ZfsStorageClassConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer.parameter.config">config</a></code> | <code>@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.Initializer.parameter.config"></a>

- *Type:* @awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.resetContentTypes">resetContentTypes</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.resetNodes">resetNodes</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetContentTypes` <a name="resetContentTypes" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.resetContentTypes"></a>

```typescript
public resetContentTypes(): void
```

##### `resetNodes` <a name="resetNodes" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.resetNodes"></a>

```typescript
public resetNodes(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isTerraformElement">isTerraformElement</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isTerraformResource">isTerraformResource</a></code> | *No description.* |

---

##### `isConstruct` <a name="isConstruct" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isConstruct"></a>

```typescript
import { zfsStorageClass } from '@awlsring/cdktf-proxmox'

zfsStorageClass.ZfsStorageClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isTerraformElement` <a name="isTerraformElement" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isTerraformElement"></a>

```typescript
import { zfsStorageClass } from '@awlsring/cdktf-proxmox'

zfsStorageClass.ZfsStorageClass.isTerraformElement(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isTerraformElement.parameter.x"></a>

- *Type:* any

---

##### `isTerraformResource` <a name="isTerraformResource" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isTerraformResource"></a>

```typescript
import { zfsStorageClass } from '@awlsring/cdktf-proxmox'

zfsStorageClass.ZfsStorageClass.isTerraformResource(x: any)
```

###### `x`<sup>Required</sup> <a name="x" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.isTerraformResource.parameter.x"></a>

- *Type:* any

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.mount">mount</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.contentTypesInput">contentTypesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.nodesInput">nodesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.poolInput">poolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.pool">pool</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `mount`<sup>Required</sup> <a name="mount" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.mount"></a>

```typescript
public readonly mount: string;
```

- *Type:* string

---

##### `contentTypesInput`<sup>Optional</sup> <a name="contentTypesInput" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.contentTypesInput"></a>

```typescript
public readonly contentTypesInput: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nodesInput`<sup>Optional</sup> <a name="nodesInput" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.nodesInput"></a>

```typescript
public readonly nodesInput: string[];
```

- *Type:* string[]

---

##### `poolInput`<sup>Optional</sup> <a name="poolInput" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.poolInput"></a>

```typescript
public readonly poolInput: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `pool`<sup>Required</sup> <a name="pool" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClass.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

## Structs <a name="Structs" id="Structs"></a>

### DataProxmoxLvmsConfig <a name="DataProxmoxLvmsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmsConfig: dataProxmoxLvms.DataProxmoxLvmsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#filters DataProxmoxLvms#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxLvmsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#filters DataProxmoxLvms#filters}.

---

### DataProxmoxLvmsFilters <a name="DataProxmoxLvmsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmsFilters: dataProxmoxLvms.DataProxmoxLvmsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#name DataProxmoxLvms#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvms#values DataProxmoxLvms#values}

---

### DataProxmoxLvmsLvms <a name="DataProxmoxLvmsLvms" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvms"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvms.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmsLvms: dataProxmoxLvms.DataProxmoxLvmsLvms = { ... }
```


### DataProxmoxLvmStorageClassesConfig <a name="DataProxmoxLvmStorageClassesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmStorageClassesConfig: dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#filters DataProxmoxLvmStorageClasses#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxLvmStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#filters DataProxmoxLvmStorageClasses#filters}.

---

### DataProxmoxLvmStorageClassesFilters <a name="DataProxmoxLvmStorageClassesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmStorageClassesFilters: dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#name DataProxmoxLvmStorageClasses#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_storage_classes#values DataProxmoxLvmStorageClasses#values}

---

### DataProxmoxLvmStorageClassesLvmStorageClasses <a name="DataProxmoxLvmStorageClassesLvmStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClasses"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmStorageClassesLvmStorageClasses: dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClasses = { ... }
```


### DataProxmoxLvmThinpoolsConfig <a name="DataProxmoxLvmThinpoolsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmThinpoolsConfig: dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#filters DataProxmoxLvmThinpools#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxLvmThinpoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#filters DataProxmoxLvmThinpools#filters}.

---

### DataProxmoxLvmThinpoolsFilters <a name="DataProxmoxLvmThinpoolsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmThinpoolsFilters: dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#name DataProxmoxLvmThinpools#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpools#values DataProxmoxLvmThinpools#values}

---

### DataProxmoxLvmThinpoolsLvmThinpools <a name="DataProxmoxLvmThinpoolsLvmThinpools" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpools"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpools.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmThinpoolsLvmThinpools: dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpools = { ... }
```


### DataProxmoxLvmThinpoolStorageClassesConfig <a name="DataProxmoxLvmThinpoolStorageClassesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmThinpoolStorageClassesConfig: dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#filters DataProxmoxLvmThinpoolStorageClasses#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxLvmThinpoolStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#filters DataProxmoxLvmThinpoolStorageClasses#filters}.

---

### DataProxmoxLvmThinpoolStorageClassesFilters <a name="DataProxmoxLvmThinpoolStorageClassesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmThinpoolStorageClassesFilters: dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#name DataProxmoxLvmThinpoolStorageClasses#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/lvm_thinpool_storage_classes#values DataProxmoxLvmThinpoolStorageClasses#values}

---

### DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses <a name="DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses: dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses = { ... }
```


### DataProxmoxNetworkBondsConfig <a name="DataProxmoxNetworkBondsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBondsConfig: dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#filters DataProxmoxNetworkBonds#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNetworkBondsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#filters DataProxmoxNetworkBonds#filters}.

---

### DataProxmoxNetworkBondsFilters <a name="DataProxmoxNetworkBondsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBondsFilters: dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#name DataProxmoxNetworkBonds#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#values DataProxmoxNetworkBonds#values}

---

### DataProxmoxNetworkBondsNetworkBonds <a name="DataProxmoxNetworkBondsNetworkBonds" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBondsNetworkBonds: dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | The ipv4 gateway. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | The ipv6 gateway. |

---

##### `ipv4Gateway`<sup>Optional</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

The ipv4 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#ipv4_gateway DataProxmoxNetworkBonds#ipv4_gateway}

---

##### `ipv6Gateway`<sup>Optional</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

The ipv6 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bonds#ipv6_gateway DataProxmoxNetworkBonds#ipv6_gateway}

---

### DataProxmoxNetworkBondsNetworkBondsIpv4 <a name="DataProxmoxNetworkBondsNetworkBondsIpv4" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBondsNetworkBondsIpv4: dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4 = { ... }
```


### DataProxmoxNetworkBondsNetworkBondsIpv6 <a name="DataProxmoxNetworkBondsNetworkBondsIpv6" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBondsNetworkBondsIpv6: dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6 = { ... }
```


### DataProxmoxNetworkBridgesConfig <a name="DataProxmoxNetworkBridgesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBridgesConfig: dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#filters DataProxmoxNetworkBridges#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNetworkBridgesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#filters DataProxmoxNetworkBridges#filters}.

---

### DataProxmoxNetworkBridgesFilters <a name="DataProxmoxNetworkBridgesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBridgesFilters: dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#name DataProxmoxNetworkBridges#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#values DataProxmoxNetworkBridges#values}

---

### DataProxmoxNetworkBridgesNetworkBridges <a name="DataProxmoxNetworkBridgesNetworkBridges" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBridgesNetworkBridges: dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.property.comments">comments</a></code> | <code>string</code> | Comment in the bond. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | The ipv4 gateway. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | The ipv6 gateway. |

---

##### `comments`<sup>Optional</sup> <a name="comments" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

Comment in the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#comments DataProxmoxNetworkBridges#comments}

---

##### `ipv4Gateway`<sup>Optional</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

The ipv4 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#ipv4_gateway DataProxmoxNetworkBridges#ipv4_gateway}

---

##### `ipv6Gateway`<sup>Optional</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

The ipv6 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/network_bridges#ipv6_gateway DataProxmoxNetworkBridges#ipv6_gateway}

---

### DataProxmoxNetworkBridgesNetworkBridgesIpv4 <a name="DataProxmoxNetworkBridgesNetworkBridgesIpv4" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBridgesNetworkBridgesIpv4: dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4 = { ... }
```


### DataProxmoxNetworkBridgesNetworkBridgesIpv6 <a name="DataProxmoxNetworkBridgesNetworkBridgesIpv6" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

const dataProxmoxNetworkBridgesNetworkBridgesIpv6: dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6 = { ... }
```


### DataProxmoxNfsStorageClassesConfig <a name="DataProxmoxNfsStorageClassesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxNfsStorageClassesConfig: dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#filters DataProxmoxNfsStorageClasses#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNfsStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#filters DataProxmoxNfsStorageClasses#filters}.

---

### DataProxmoxNfsStorageClassesFilters <a name="DataProxmoxNfsStorageClassesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxNfsStorageClassesFilters: dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#name DataProxmoxNfsStorageClasses#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nfs_storage_classes#values DataProxmoxNfsStorageClasses#values}

---

### DataProxmoxNfsStorageClassesNfsStorageClasses <a name="DataProxmoxNfsStorageClassesNfsStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClasses"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxNfsStorageClassesNfsStorageClasses: dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClasses = { ... }
```


### DataProxmoxNodesConfig <a name="DataProxmoxNodesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodesConfig: dataProxmoxNodes.DataProxmoxNodesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#filters DataProxmoxNodes#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNodesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#filters DataProxmoxNodes#filters}.

---

### DataProxmoxNodesFilters <a name="DataProxmoxNodesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodesFilters: dataProxmoxNodes.DataProxmoxNodesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#name DataProxmoxNodes#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/nodes#values DataProxmoxNodes#values}

---

### DataProxmoxNodesNodes <a name="DataProxmoxNodesNodes" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodes"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodes.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodesNodes: dataProxmoxNodes.DataProxmoxNodesNodes = { ... }
```


### DataProxmoxNodesNodesDisks <a name="DataProxmoxNodesNodesDisks" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisks"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisks.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodesNodesDisks: dataProxmoxNodes.DataProxmoxNodesNodesDisks = { ... }
```


### DataProxmoxNodeStorageLvmsConfig <a name="DataProxmoxNodeStorageLvmsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageLvmsConfig: dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#filters DataProxmoxNodeStorageLvms#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNodeStorageLvmsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#filters DataProxmoxNodeStorageLvms#filters}.

---

### DataProxmoxNodeStorageLvmsFilters <a name="DataProxmoxNodeStorageLvmsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageLvmsFilters: dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#name DataProxmoxNodeStorageLvms#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvms#values DataProxmoxNodeStorageLvms#values}

---

### DataProxmoxNodeStorageLvmsNodeStorageLvms <a name="DataProxmoxNodeStorageLvmsNodeStorageLvms" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvms"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvms.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageLvmsNodeStorageLvms: dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvms = { ... }
```


### DataProxmoxNodeStorageLvmThinpoolsConfig <a name="DataProxmoxNodeStorageLvmThinpoolsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageLvmThinpoolsConfig: dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#filters DataProxmoxNodeStorageLvmThinpools#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNodeStorageLvmThinpoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#filters DataProxmoxNodeStorageLvmThinpools#filters}.

---

### DataProxmoxNodeStorageLvmThinpoolsFilters <a name="DataProxmoxNodeStorageLvmThinpoolsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageLvmThinpoolsFilters: dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#name DataProxmoxNodeStorageLvmThinpools#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_lvm_thinpools#values DataProxmoxNodeStorageLvmThinpools#values}

---

### DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools <a name="DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools: dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools = { ... }
```


### DataProxmoxNodeStorageNfsConfig <a name="DataProxmoxNodeStorageNfsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageNfsConfig: dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#filters DataProxmoxNodeStorageNfs#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNodeStorageNfsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#filters DataProxmoxNodeStorageNfs#filters}.

---

### DataProxmoxNodeStorageNfsFilters <a name="DataProxmoxNodeStorageNfsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageNfsFilters: dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#name DataProxmoxNodeStorageNfs#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_nfs#values DataProxmoxNodeStorageNfs#values}

---

### DataProxmoxNodeStorageNfsNodeStorageNfs <a name="DataProxmoxNodeStorageNfsNodeStorageNfs" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfs"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfs.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageNfsNodeStorageNfs: dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfs = { ... }
```


### DataProxmoxNodeStorageZfsConfig <a name="DataProxmoxNodeStorageZfsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageZfsConfig: dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_zfs#filters DataProxmoxNodeStorageZfs#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxNodeStorageZfsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_zfs#filters DataProxmoxNodeStorageZfs#filters}.

---

### DataProxmoxNodeStorageZfsFilters <a name="DataProxmoxNodeStorageZfsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageZfsFilters: dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_zfs#name DataProxmoxNodeStorageZfs#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/node_storage_zfs#values DataProxmoxNodeStorageZfs#values}

---

### DataProxmoxNodeStorageZfsNodeStorageZfs <a name="DataProxmoxNodeStorageZfsNodeStorageZfs" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfs"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfs.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

const dataProxmoxNodeStorageZfsNodeStorageZfs: dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfs = { ... }
```


### DataProxmoxResourcePoolsConfig <a name="DataProxmoxResourcePoolsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

const dataProxmoxResourcePoolsConfig: dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#filters DataProxmoxResourcePools#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxResourcePoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#filters DataProxmoxResourcePools#filters}.

---

### DataProxmoxResourcePoolsFilters <a name="DataProxmoxResourcePoolsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

const dataProxmoxResourcePoolsFilters: dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#name DataProxmoxResourcePools#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/resource_pools#values DataProxmoxResourcePools#values}

---

### DataProxmoxResourcePoolsResourcePools <a name="DataProxmoxResourcePoolsResourcePools" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePools"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePools.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

const dataProxmoxResourcePoolsResourcePools: dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePools = { ... }
```


### DataProxmoxResourcePoolsResourcePoolsMembers <a name="DataProxmoxResourcePoolsResourcePoolsMembers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembers"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembers.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

const dataProxmoxResourcePoolsResourcePoolsMembers: dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembers = { ... }
```


### DataProxmoxTemplateAgent <a name="DataProxmoxTemplateAgent" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgent"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgent.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateAgent: dataProxmoxTemplate.DataProxmoxTemplateAgent = { ... }
```


### DataProxmoxTemplateCloudInit <a name="DataProxmoxTemplateCloudInit" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInit"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInit.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCloudInit: dataProxmoxTemplate.DataProxmoxTemplateCloudInit = { ... }
```


### DataProxmoxTemplateCloudInitDns <a name="DataProxmoxTemplateCloudInitDns" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDns"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDns.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCloudInitDns: dataProxmoxTemplate.DataProxmoxTemplateCloudInitDns = { ... }
```


### DataProxmoxTemplateCloudInitIp <a name="DataProxmoxTemplateCloudInitIp" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIp"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIp.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCloudInitIp: dataProxmoxTemplate.DataProxmoxTemplateCloudInitIp = { ... }
```


### DataProxmoxTemplateCloudInitIpV4 <a name="DataProxmoxTemplateCloudInitIpV4" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCloudInitIpV4: dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4 = { ... }
```


### DataProxmoxTemplateCloudInitIpV6 <a name="DataProxmoxTemplateCloudInitIpV6" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCloudInitIpV6: dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6 = { ... }
```


### DataProxmoxTemplateCloudInitUser <a name="DataProxmoxTemplateCloudInitUser" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUser"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUser.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCloudInitUser: dataProxmoxTemplate.DataProxmoxTemplateCloudInitUser = { ... }
```


### DataProxmoxTemplateConfig <a name="DataProxmoxTemplateConfig" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateConfig: dataProxmoxTemplate.DataProxmoxTemplateConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node to create the template on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.id">id</a></code> | <code>number</code> | The identifier of the template. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.name">name</a></code> | <code>string</code> | The name of the template. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node to create the template on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/template#node DataProxmoxTemplate#node}

---

##### `id`<sup>Optional</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.id"></a>

```typescript
public readonly id: number;
```

- *Type:* number

The identifier of the template.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/template#id DataProxmoxTemplate#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the template.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/template#name DataProxmoxTemplate#name}

---

### DataProxmoxTemplateCpu <a name="DataProxmoxTemplateCpu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpu"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpu.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateCpu: dataProxmoxTemplate.DataProxmoxTemplateCpu = { ... }
```


### DataProxmoxTemplateDisks <a name="DataProxmoxTemplateDisks" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisks"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisks.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateDisks: dataProxmoxTemplate.DataProxmoxTemplateDisks = { ... }
```


### DataProxmoxTemplateDisksSpeedLimits <a name="DataProxmoxTemplateDisksSpeedLimits" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimits"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimits.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateDisksSpeedLimits: dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimits = { ... }
```


### DataProxmoxTemplateMemory <a name="DataProxmoxTemplateMemory" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemory"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemory.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateMemory: dataProxmoxTemplate.DataProxmoxTemplateMemory = { ... }
```


### DataProxmoxTemplateNetworkInterfaces <a name="DataProxmoxTemplateNetworkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfaces"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfaces.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplateNetworkInterfaces: dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfaces = { ... }
```


### DataProxmoxTemplatePciDevices <a name="DataProxmoxTemplatePciDevices" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevices"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevices.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatePciDevices: dataProxmoxTemplate.DataProxmoxTemplatePciDevices = { ... }
```


### DataProxmoxTemplatesConfig <a name="DataProxmoxTemplatesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesConfig: dataProxmoxTemplates.DataProxmoxTemplatesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#filters DataProxmoxTemplates#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxTemplatesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#filters DataProxmoxTemplates#filters}.

---

### DataProxmoxTemplatesFilters <a name="DataProxmoxTemplatesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesFilters: dataProxmoxTemplates.DataProxmoxTemplatesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#name DataProxmoxTemplates#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/templates#values DataProxmoxTemplates#values}

---

### DataProxmoxTemplatesTemplates <a name="DataProxmoxTemplatesTemplates" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplates"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplates.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplates: dataProxmoxTemplates.DataProxmoxTemplatesTemplates = { ... }
```


### DataProxmoxTemplatesTemplatesAgent <a name="DataProxmoxTemplatesTemplatesAgent" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgent"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgent.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesAgent: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgent = { ... }
```


### DataProxmoxTemplatesTemplatesCloudInit <a name="DataProxmoxTemplatesTemplatesCloudInit" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInit"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInit.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCloudInit: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInit = { ... }
```


### DataProxmoxTemplatesTemplatesCloudInitDns <a name="DataProxmoxTemplatesTemplatesCloudInitDns" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDns"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDns.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCloudInitDns: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDns = { ... }
```


### DataProxmoxTemplatesTemplatesCloudInitIp <a name="DataProxmoxTemplatesTemplatesCloudInitIp" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIp"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIp.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCloudInitIp: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIp = { ... }
```


### DataProxmoxTemplatesTemplatesCloudInitIpV4 <a name="DataProxmoxTemplatesTemplatesCloudInitIpV4" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCloudInitIpV4: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4 = { ... }
```


### DataProxmoxTemplatesTemplatesCloudInitIpV6 <a name="DataProxmoxTemplatesTemplatesCloudInitIpV6" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCloudInitIpV6: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6 = { ... }
```


### DataProxmoxTemplatesTemplatesCloudInitUser <a name="DataProxmoxTemplatesTemplatesCloudInitUser" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUser"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUser.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCloudInitUser: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUser = { ... }
```


### DataProxmoxTemplatesTemplatesCpu <a name="DataProxmoxTemplatesTemplatesCpu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpu"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpu.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesCpu: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpu = { ... }
```


### DataProxmoxTemplatesTemplatesDisks <a name="DataProxmoxTemplatesTemplatesDisks" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisks"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisks.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesDisks: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisks = { ... }
```


### DataProxmoxTemplatesTemplatesDisksSpeedLimits <a name="DataProxmoxTemplatesTemplatesDisksSpeedLimits" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimits"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimits.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesDisksSpeedLimits: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimits = { ... }
```


### DataProxmoxTemplatesTemplatesMemory <a name="DataProxmoxTemplatesTemplatesMemory" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemory"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemory.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesMemory: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemory = { ... }
```


### DataProxmoxTemplatesTemplatesNetworkInterfaces <a name="DataProxmoxTemplatesTemplatesNetworkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfaces"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfaces.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesNetworkInterfaces: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfaces = { ... }
```


### DataProxmoxTemplatesTemplatesPciDevices <a name="DataProxmoxTemplatesTemplatesPciDevices" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevices"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevices.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

const dataProxmoxTemplatesTemplatesPciDevices: dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevices = { ... }
```


### DataProxmoxVirtualMachinesConfig <a name="DataProxmoxVirtualMachinesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesConfig: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/virtual_machines#filters DataProxmoxVirtualMachines#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxVirtualMachinesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/virtual_machines#filters DataProxmoxVirtualMachines#filters}.

---

### DataProxmoxVirtualMachinesFilters <a name="DataProxmoxVirtualMachinesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesFilters: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/virtual_machines#name DataProxmoxVirtualMachines#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/virtual_machines#values DataProxmoxVirtualMachines#values}

---

### DataProxmoxVirtualMachinesVirtualMachines <a name="DataProxmoxVirtualMachinesVirtualMachines" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachines"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachines.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachines: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachines = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesAgent <a name="DataProxmoxVirtualMachinesVirtualMachinesAgent" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgent"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgent.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesAgent: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgent = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCloudInit <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInit" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInit"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInit.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCloudInit: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInit = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCloudInitDns: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCloudInitIp: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4 <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4 = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6 <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6 = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCloudInitUser: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesCpu <a name="DataProxmoxVirtualMachinesVirtualMachinesCpu" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpu"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpu.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesCpu: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpu = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesDisks <a name="DataProxmoxVirtualMachinesVirtualMachinesDisks" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisks"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisks.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesDisks: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisks = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits <a name="DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesMemory <a name="DataProxmoxVirtualMachinesVirtualMachinesMemory" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemory"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemory.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesMemory: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemory = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces <a name="DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces = { ... }
```


### DataProxmoxVirtualMachinesVirtualMachinesPciDevices <a name="DataProxmoxVirtualMachinesVirtualMachinesPciDevices" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevices"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevices.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

const dataProxmoxVirtualMachinesVirtualMachinesPciDevices: dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevices = { ... }
```


### DataProxmoxZfsPoolsConfig <a name="DataProxmoxZfsPoolsConfig" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

const dataProxmoxZfsPoolsConfig: dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#filters DataProxmoxZfsPools#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxZfsPoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#filters DataProxmoxZfsPools#filters}.

---

### DataProxmoxZfsPoolsFilters <a name="DataProxmoxZfsPoolsFilters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

const dataProxmoxZfsPoolsFilters: dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#name DataProxmoxZfsPools#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_pools#values DataProxmoxZfsPools#values}

---

### DataProxmoxZfsPoolsZfsPools <a name="DataProxmoxZfsPoolsZfsPools" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPools"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPools.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

const dataProxmoxZfsPoolsZfsPools: dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPools = { ... }
```


### DataProxmoxZfsStorageClassesConfig <a name="DataProxmoxZfsStorageClassesConfig" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxZfsStorageClassesConfig: dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.filters">filters</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#filters DataProxmoxZfsStorageClasses#filters}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `filters`<sup>Optional</sup> <a name="filters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesConfig.property.filters"></a>

```typescript
public readonly filters: IResolvable | DataProxmoxZfsStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#filters DataProxmoxZfsStorageClasses#filters}.

---

### DataProxmoxZfsStorageClassesFilters <a name="DataProxmoxZfsStorageClassesFilters" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxZfsStorageClassesFilters: dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters.property.name">name</a></code> | <code>string</code> | The name of the attribute to filter on. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters.property.values">values</a></code> | <code>string[]</code> | The value(s) to be used in the filter. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the attribute to filter on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#name DataProxmoxZfsStorageClasses#name}

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

The value(s) to be used in the filter.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/d/zfs_storage_classes#values DataProxmoxZfsStorageClasses#values}

---

### DataProxmoxZfsStorageClassesZfsStorageClasses <a name="DataProxmoxZfsStorageClassesZfsStorageClasses" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClasses"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClasses.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

const dataProxmoxZfsStorageClassesZfsStorageClasses: dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClasses = { ... }
```


### LvmConfig <a name="LvmConfig" id="@awlsring/cdktf-proxmox.lvm.LvmConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.Initializer"></a>

```typescript
import { lvm } from '@awlsring/cdktf-proxmox'

const lvmConfig: lvm.LvmConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.device">device</a></code> | <code>string</code> | Device the LVM is on. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.name">name</a></code> | <code>string</code> | The name of the LVM. |
| <code><a href="#@awlsring/cdktf-proxmox.lvm.LvmConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node the LVM is on. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

Device the LVM is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm#device Lvm#device}

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the LVM.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm#name Lvm#name}

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.lvm.LvmConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node the LVM is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm#node Lvm#node}

---

### LvmStorageClassConfig <a name="LvmStorageClassConfig" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.Initializer"></a>

```typescript
import { lvmStorageClass } from '@awlsring/cdktf-proxmox'

const lvmStorageClassConfig: lvmStorageClass.LvmStorageClassConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.id">id</a></code> | <code>string</code> | The identifier of the storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | The associated volume group. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | The content types that can be stored on this storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.nodes">nodes</a></code> | <code>string[]</code> | Nodes that implement this storage class. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The identifier of the storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_storage_class#id LvmStorageClass#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

The associated volume group.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_storage_class#volume_group LvmStorageClass#volume_group}

---

##### `contentTypes`<sup>Optional</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

The content types that can be stored on this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_storage_class#content_types LvmStorageClass#content_types}

---

##### `nodes`<sup>Optional</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.lvmStorageClass.LvmStorageClassConfig.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

Nodes that implement this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_storage_class#nodes LvmStorageClass#nodes}

---

### LvmThinpoolConfig <a name="LvmThinpoolConfig" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.Initializer"></a>

```typescript
import { lvmThinpool } from '@awlsring/cdktf-proxmox'

const lvmThinpoolConfig: lvmThinpool.LvmThinpoolConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.device">device</a></code> | <code>string</code> | The device to create the LVM thinpool on. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.name">name</a></code> | <code>string</code> | The name of the LVM thinpool. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node the LVM thinpool is on. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

The device to create the LVM thinpool on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool#device LvmThinpool#device}

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the LVM thinpool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool#name LvmThinpool#name}

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.lvmThinpool.LvmThinpoolConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node the LVM thinpool is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool#node LvmThinpool#node}

---

### LvmThinpoolStorageClassConfig <a name="LvmThinpoolStorageClassConfig" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.Initializer"></a>

```typescript
import { lvmThinpoolStorageClass } from '@awlsring/cdktf-proxmox'

const lvmThinpoolStorageClassConfig: lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.id">id</a></code> | <code>string</code> | The identifier of the storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.thinpool">thinpool</a></code> | <code>string</code> | The LVM thinpool that should be implemented by each node. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | The associated volume group. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | The content types that can be stored on this storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.nodes">nodes</a></code> | <code>string[]</code> | Nodes that implement this storage class. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The identifier of the storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool_storage_class#id LvmThinpoolStorageClass#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `thinpool`<sup>Required</sup> <a name="thinpool" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.thinpool"></a>

```typescript
public readonly thinpool: string;
```

- *Type:* string

The LVM thinpool that should be implemented by each node.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool_storage_class#thinpool LvmThinpoolStorageClass#thinpool}

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

The associated volume group.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool_storage_class#volume_group LvmThinpoolStorageClass#volume_group}

---

##### `contentTypes`<sup>Optional</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

The content types that can be stored on this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool_storage_class#content_types LvmThinpoolStorageClass#content_types}

---

##### `nodes`<sup>Optional</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.lvmThinpoolStorageClass.LvmThinpoolStorageClassConfig.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

Nodes that implement this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/lvm_thinpool_storage_class#nodes LvmThinpoolStorageClass#nodes}

---

### NetworkBondConfig <a name="NetworkBondConfig" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.Initializer"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

const networkBondConfig: networkBond.NetworkBondConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.interfaces">interfaces</a></code> | <code>string[]</code> | List of interfaces on the bond. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.mode">mode</a></code> | <code>string</code> | Mode of the bond. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node the bond is on. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.autostart">autostart</a></code> | <code>boolean \| cdktf.IResolvable</code> | If the bond is set to autostart. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.bondPrimary">bondPrimary</a></code> | <code>string</code> | Primary interface on the bond. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.comments">comments</a></code> | <code>string</code> | Comment in the bond. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.hashPolicy">hashPolicy</a></code> | <code>string</code> | Hash policy used on the bond. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv4">ipv4</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 \| cdktf.IResolvable</code> | Information of the ipv4 address. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | The ipv4 gateway. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv6">ipv6</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 \| cdktf.IResolvable</code> | Information of the ipv6 address. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | The ipv6 gateway. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.name">name</a></code> | <code>string</code> | The name of the bond. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `interfaces`<sup>Required</sup> <a name="interfaces" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.interfaces"></a>

```typescript
public readonly interfaces: string[];
```

- *Type:* string[]

List of interfaces on the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#interfaces NetworkBond#interfaces}

---

##### `mode`<sup>Required</sup> <a name="mode" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

Mode of the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#mode NetworkBond#mode}

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node the bond is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#node NetworkBond#node}

---

##### `autostart`<sup>Optional</sup> <a name="autostart" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.autostart"></a>

```typescript
public readonly autostart: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

If the bond is set to autostart.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#autostart NetworkBond#autostart}

---

##### `bondPrimary`<sup>Optional</sup> <a name="bondPrimary" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.bondPrimary"></a>

```typescript
public readonly bondPrimary: string;
```

- *Type:* string

Primary interface on the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#bond_primary NetworkBond#bond_primary}

---

##### `comments`<sup>Optional</sup> <a name="comments" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

Comment in the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#comments NetworkBond#comments}

---

##### `hashPolicy`<sup>Optional</sup> <a name="hashPolicy" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.hashPolicy"></a>

```typescript
public readonly hashPolicy: string;
```

- *Type:* string

Hash policy used on the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#hash_policy NetworkBond#hash_policy}

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv4"></a>

```typescript
public readonly ipv4: NetworkBondIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 | cdktf.IResolvable

Information of the ipv4 address.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#ipv4 NetworkBond#ipv4}

---

##### `ipv4Gateway`<sup>Optional</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

The ipv4 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#ipv4_gateway NetworkBond#ipv4_gateway}

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv6"></a>

```typescript
public readonly ipv6: NetworkBondIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 | cdktf.IResolvable

Information of the ipv6 address.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#ipv6 NetworkBond#ipv6}

---

##### `ipv6Gateway`<sup>Optional</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

The ipv6 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#ipv6_gateway NetworkBond#ipv6_gateway}

---

##### `name`<sup>Optional</sup> <a name="name" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the bond.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#name NetworkBond#name}

---

### NetworkBondIpv4 <a name="NetworkBondIpv4" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4.Initializer"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

const networkBondIpv4: networkBond.NetworkBondIpv4 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#address NetworkBond#address}. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4.property.netmask">netmask</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#netmask NetworkBond#netmask}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#address NetworkBond#address}.

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#netmask NetworkBond#netmask}.

---

### NetworkBondIpv6 <a name="NetworkBondIpv6" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6.Initializer"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

const networkBondIpv6: networkBond.NetworkBondIpv6 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#address NetworkBond#address}. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6.property.netmask">netmask</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#netmask NetworkBond#netmask}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#address NetworkBond#address}.

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bond#netmask NetworkBond#netmask}.

---

### NetworkBridgeConfig <a name="NetworkBridgeConfig" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.Initializer"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

const networkBridgeConfig: networkBridge.NetworkBridgeConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.interfaces">interfaces</a></code> | <code>string[]</code> | List of interfaces on the bridge. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node the bridge is on. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.autostart">autostart</a></code> | <code>boolean \| cdktf.IResolvable</code> | If the bridge is set to autostart. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.comments">comments</a></code> | <code>string</code> | Comment on the bridge. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv4">ipv4</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 \| cdktf.IResolvable</code> | Information of the ipv4 address. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | The ipv4 gateway. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv6">ipv6</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 \| cdktf.IResolvable</code> | Information of the ipv6 address. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | The ipv6 gateway. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.name">name</a></code> | <code>string</code> | The name of the bridge. Follows the scheme `vmbr<n>`. If not set, the next available name will be used. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.vlanAware">vlanAware</a></code> | <code>boolean \| cdktf.IResolvable</code> | If the bridge is vlan aware. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `interfaces`<sup>Required</sup> <a name="interfaces" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.interfaces"></a>

```typescript
public readonly interfaces: string[];
```

- *Type:* string[]

List of interfaces on the bridge.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#interfaces NetworkBridge#interfaces}

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node the bridge is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#node NetworkBridge#node}

---

##### `autostart`<sup>Optional</sup> <a name="autostart" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.autostart"></a>

```typescript
public readonly autostart: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

If the bridge is set to autostart.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#autostart NetworkBridge#autostart}

---

##### `comments`<sup>Optional</sup> <a name="comments" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

Comment on the bridge.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#comments NetworkBridge#comments}

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv4"></a>

```typescript
public readonly ipv4: NetworkBridgeIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 | cdktf.IResolvable

Information of the ipv4 address.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#ipv4 NetworkBridge#ipv4}

---

##### `ipv4Gateway`<sup>Optional</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

The ipv4 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#ipv4_gateway NetworkBridge#ipv4_gateway}

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv6"></a>

```typescript
public readonly ipv6: NetworkBridgeIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 | cdktf.IResolvable

Information of the ipv6 address.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#ipv6 NetworkBridge#ipv6}

---

##### `ipv6Gateway`<sup>Optional</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

The ipv6 gateway.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#ipv6_gateway NetworkBridge#ipv6_gateway}

---

##### `name`<sup>Optional</sup> <a name="name" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the bridge. Follows the scheme `vmbr<n>`. If not set, the next available name will be used.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#name NetworkBridge#name}

---

##### `vlanAware`<sup>Optional</sup> <a name="vlanAware" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeConfig.property.vlanAware"></a>

```typescript
public readonly vlanAware: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

If the bridge is vlan aware.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#vlan_aware NetworkBridge#vlan_aware}

---

### NetworkBridgeIpv4 <a name="NetworkBridgeIpv4" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4.Initializer"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

const networkBridgeIpv4: networkBridge.NetworkBridgeIpv4 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#address NetworkBridge#address}. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4.property.netmask">netmask</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#netmask NetworkBridge#netmask}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#address NetworkBridge#address}.

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#netmask NetworkBridge#netmask}.

---

### NetworkBridgeIpv6 <a name="NetworkBridgeIpv6" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6.Initializer"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

const networkBridgeIpv6: networkBridge.NetworkBridgeIpv6 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#address NetworkBridge#address}. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6.property.netmask">netmask</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#netmask NetworkBridge#netmask}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#address NetworkBridge#address}.

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/network_bridge#netmask NetworkBridge#netmask}.

---

### NfsStorageClassConfig <a name="NfsStorageClassConfig" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.Initializer"></a>

```typescript
import { nfsStorageClass } from '@awlsring/cdktf-proxmox'

const nfsStorageClassConfig: nfsStorageClass.NfsStorageClassConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.export">export</a></code> | <code>string</code> | The remote export path of the NFS server. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.id">id</a></code> | <code>string</code> | The identifier of the storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.server">server</a></code> | <code>string</code> | The NFS server used in the storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | The content types that can be stored on this storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.nodes">nodes</a></code> | <code>string[]</code> | Nodes that implement this storage class. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `export`<sup>Required</sup> <a name="export" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.export"></a>

```typescript
public readonly export: string;
```

- *Type:* string

The remote export path of the NFS server.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/nfs_storage_class#export NfsStorageClass#export}

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The identifier of the storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/nfs_storage_class#id NfsStorageClass#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `server`<sup>Required</sup> <a name="server" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* string

The NFS server used in the storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/nfs_storage_class#server NfsStorageClass#server}

---

##### `contentTypes`<sup>Optional</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

The content types that can be stored on this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/nfs_storage_class#content_types NfsStorageClass#content_types}

---

##### `nodes`<sup>Optional</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.nfsStorageClass.NfsStorageClassConfig.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

Nodes that implement this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/nfs_storage_class#nodes NfsStorageClass#nodes}

---

### ProxmoxProviderConfig <a name="ProxmoxProviderConfig" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.Initializer"></a>

```typescript
import { provider } from '@awlsring/cdktf-proxmox'

const proxmoxProviderConfig: provider.ProxmoxProviderConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.endpoint">endpoint</a></code> | <code>string</code> | Proxmox endpoint to connect with. **Ex `https://10.0.0.2:8006`**. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.alias">alias</a></code> | <code>string</code> | Alias name. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.apiKey">apiKey</a></code> | <code>string</code> | A proxmox api key. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.insecure">insecure</a></code> | <code>boolean \| cdktf.IResolvable</code> | Skip TLS verification. Defaults to true. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.password">password</a></code> | <code>string</code> | Password for specified user. |
| <code><a href="#@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.username">username</a></code> | <code>string</code> | The username to use for authentication. |

---

##### `endpoint`<sup>Required</sup> <a name="endpoint" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

Proxmox endpoint to connect with. **Ex `https://10.0.0.2:8006`**.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox#endpoint ProxmoxProvider#endpoint}

---

##### `alias`<sup>Optional</sup> <a name="alias" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

Alias name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox#alias ProxmoxProvider#alias}

---

##### `apiKey`<sup>Optional</sup> <a name="apiKey" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.apiKey"></a>

```typescript
public readonly apiKey: string;
```

- *Type:* string

A proxmox api key.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox#api_key ProxmoxProvider#api_key}

---

##### `insecure`<sup>Optional</sup> <a name="insecure" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.insecure"></a>

```typescript
public readonly insecure: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Skip TLS verification. Defaults to true.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox#insecure ProxmoxProvider#insecure}

---

##### `password`<sup>Optional</sup> <a name="password" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Password for specified user.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox#password ProxmoxProvider#password}

---

##### `username`<sup>Optional</sup> <a name="username" id="@awlsring/cdktf-proxmox.provider.ProxmoxProviderConfig.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

The username to use for authentication.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox#username ProxmoxProvider#username}

---

### ResourcePoolConfig <a name="ResourcePoolConfig" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.Initializer"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

const resourcePoolConfig: resourcePool.ResourcePoolConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.id">id</a></code> | <code>string</code> | The id of the resource pool. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.comment">comment</a></code> | <code>string</code> | Notes on the resource pool. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.members">members</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]</code> | Resources that are part of the resource pool. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The id of the resource pool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/resource_pool#id ResourcePool#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `comment`<sup>Optional</sup> <a name="comment" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

Notes on the resource pool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/resource_pool#comment ResourcePool#comment}

---

##### `members`<sup>Optional</sup> <a name="members" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolConfig.property.members"></a>

```typescript
public readonly members: IResolvable | ResourcePoolMembers[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]

Resources that are part of the resource pool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/resource_pool#members ResourcePool#members}

---

### ResourcePoolMembers <a name="ResourcePoolMembers" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers.Initializer"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

const resourcePoolMembers: resourcePool.ResourcePoolMembers = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers.property.id">id</a></code> | <code>string</code> | The id of the resource. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers.property.type">type</a></code> | <code>string</code> | The type of the resource. |

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The id of the resource.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/resource_pool#id ResourcePool#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

The type of the resource.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/resource_pool#type ResourcePool#type}

---

### VirtualMachineAgent <a name="VirtualMachineAgent" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineAgent: virtualMachine.VirtualMachineAgent = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the agent is enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.property.type">type</a></code> | <code>string</code> | The guest agent type. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.property.useFstrim">useFstrim</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use fstrim. |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the agent is enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#enabled VirtualMachine#enabled}

---

##### `type`<sup>Optional</sup> <a name="type" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

The guest agent type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#type VirtualMachine#type}

---

##### `useFstrim`<sup>Optional</sup> <a name="useFstrim" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent.property.useFstrim"></a>

```typescript
public readonly useFstrim: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use fstrim.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#use_fstrim VirtualMachine#use_fstrim}

---

### VirtualMachineClone <a name="VirtualMachineClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineClone: virtualMachine.VirtualMachineClone = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.property.source">source</a></code> | <code>number</code> | The identifier of the virtual machine or template to clone. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.property.fullClone">fullClone</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to clone as a full or linked clone. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.property.storage">storage</a></code> | <code>string</code> | The storage to place the clone on. |

---

##### `source`<sup>Required</sup> <a name="source" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.property.source"></a>

```typescript
public readonly source: number;
```

- *Type:* number

The identifier of the virtual machine or template to clone.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#source VirtualMachine#source}

---

##### `fullClone`<sup>Optional</sup> <a name="fullClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.property.fullClone"></a>

```typescript
public readonly fullClone: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to clone as a full or linked clone.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#full_clone VirtualMachine#full_clone}

---

##### `storage`<sup>Optional</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

The storage to place the clone on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#storage VirtualMachine#storage}

---

### VirtualMachineCloudInit <a name="VirtualMachineCloudInit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCloudInit: virtualMachine.VirtualMachineCloudInit = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.property.dns">dns</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#dns VirtualMachine#dns}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.property.ip">ip</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#ip VirtualMachine#ip}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.property.user">user</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#user VirtualMachine#user}. |

---

##### `dns`<sup>Optional</sup> <a name="dns" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.property.dns"></a>

```typescript
public readonly dns: VirtualMachineCloudInitDns | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#dns VirtualMachine#dns}.

---

##### `ip`<sup>Optional</sup> <a name="ip" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.property.ip"></a>

```typescript
public readonly ip: IResolvable | VirtualMachineCloudInitIp[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#ip VirtualMachine#ip}.

---

##### `user`<sup>Optional</sup> <a name="user" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit.property.user"></a>

```typescript
public readonly user: VirtualMachineCloudInitUser | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#user VirtualMachine#user}.

---

### VirtualMachineCloudInitDns <a name="VirtualMachineCloudInitDns" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCloudInitDns: virtualMachine.VirtualMachineCloudInitDns = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns.property.domain">domain</a></code> | <code>string</code> | The domain to use for the machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns.property.nameserver">nameserver</a></code> | <code>string</code> | The nameserver to use for the machine. |

---

##### `domain`<sup>Optional</sup> <a name="domain" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

The domain to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#domain VirtualMachine#domain}

---

##### `nameserver`<sup>Optional</sup> <a name="nameserver" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns.property.nameserver"></a>

```typescript
public readonly nameserver: string;
```

- *Type:* string

The nameserver to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#nameserver VirtualMachine#nameserver}

---

### VirtualMachineCloudInitIp <a name="VirtualMachineCloudInitIp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCloudInitIp: virtualMachine.VirtualMachineCloudInitIp = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.property.position">position</a></code> | <code>number</code> | The position of the network interface in the VM as an int. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.property.v4">v4</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#v4 VirtualMachine#v4}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.property.v6">v6</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#v6 VirtualMachine#v6}. |

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

The position of the network interface in the VM as an int.

Used to determine the interface name (net0, net1, etc).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#position VirtualMachine#position}

---

##### `v4`<sup>Optional</sup> <a name="v4" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.property.v4"></a>

```typescript
public readonly v4: VirtualMachineCloudInitIpV4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#v4 VirtualMachine#v4}.

---

##### `v6`<sup>Optional</sup> <a name="v6" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp.property.v6"></a>

```typescript
public readonly v6: VirtualMachineCloudInitIpV6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#v6 VirtualMachine#v6}.

---

### VirtualMachineCloudInitIpV4 <a name="VirtualMachineCloudInitIpV4" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCloudInitIpV4: virtualMachine.VirtualMachineCloudInitIpV4 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.address">address</a></code> | <code>string</code> | The IP address to use for the machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.dhcp">dhcp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use DHCP to get the IP address. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.gateway">gateway</a></code> | <code>string</code> | The gateway to use for the machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.netmask">netmask</a></code> | <code>string</code> | The IP address netmask to use for the machine. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

The IP address to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#address VirtualMachine#address}

---

##### `dhcp`<sup>Optional</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.dhcp"></a>

```typescript
public readonly dhcp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use DHCP to get the IP address.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#dhcp VirtualMachine#dhcp}

---

##### `gateway`<sup>Optional</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

The gateway to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#gateway VirtualMachine#gateway}

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

The IP address netmask to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#netmask VirtualMachine#netmask}

---

### VirtualMachineCloudInitIpV6 <a name="VirtualMachineCloudInitIpV6" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCloudInitIpV6: virtualMachine.VirtualMachineCloudInitIpV6 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.address">address</a></code> | <code>string</code> | The IP address to use for the machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.dhcp">dhcp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use DHCP to get the IP address. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.gateway">gateway</a></code> | <code>string</code> | The gateway to use for the machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.netmask">netmask</a></code> | <code>string</code> | The IP address netmask to use for the machine. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

The IP address to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#address VirtualMachine#address}

---

##### `dhcp`<sup>Optional</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.dhcp"></a>

```typescript
public readonly dhcp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use DHCP to get the IP address.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#dhcp VirtualMachine#dhcp}

---

##### `gateway`<sup>Optional</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

The gateway to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#gateway VirtualMachine#gateway}

---

##### `netmask`<sup>Optional</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

The IP address netmask to use for the machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#netmask VirtualMachine#netmask}

---

### VirtualMachineCloudInitUser <a name="VirtualMachineCloudInitUser" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCloudInitUser: virtualMachine.VirtualMachineCloudInitUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.property.name">name</a></code> | <code>string</code> | The name of the user. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.property.password">password</a></code> | <code>string</code> | The password of the user. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.property.publicKeys">publicKeys</a></code> | <code>string[]</code> | The public ssh keys of the user. |

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the user.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#name VirtualMachine#name}

---

##### `password`<sup>Optional</sup> <a name="password" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

The password of the user.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#password VirtualMachine#password}

---

##### `publicKeys`<sup>Optional</sup> <a name="publicKeys" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser.property.publicKeys"></a>

```typescript
public readonly publicKeys: string[];
```

- *Type:* string[]

The public ssh keys of the user.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#public_keys VirtualMachine#public_keys}

---

### VirtualMachineComputedDisks <a name="VirtualMachineComputedDisks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineComputedDisks: virtualMachine.VirtualMachineComputedDisks = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.interfaceType">interfaceType</a></code> | <code>string</code> | The type of the disk. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.position">position</a></code> | <code>number</code> | The position of the disk. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.size">size</a></code> | <code>number</code> | The size of the disk in GiB. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.storage">storage</a></code> | <code>string</code> | The storage the disk is on. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.discard">discard</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the disk has discard enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.fileFormat">fileFormat</a></code> | <code>string</code> | The file format of the disk. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits \| cdktf.IResolvable</code> | The speed limits of the disk. If not set, no speed limitations are applied. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.ssdEmulation">ssdEmulation</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use SSD emulation. conflicts with virtio disk type. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.useIothread">useIothread</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use an iothread for the disk. |

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

The type of the disk.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#interface_type VirtualMachine#interface_type}

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

The position of the disk.

(0, 1, 2, etc.) This is combined with the `interface_type` to determine the disk name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#position VirtualMachine#position}

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

The size of the disk in GiB.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#size VirtualMachine#size}

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

The storage the disk is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#storage VirtualMachine#storage}

---

##### `discard`<sup>Optional</sup> <a name="discard" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.discard"></a>

```typescript
public readonly discard: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the disk has discard enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#discard VirtualMachine#discard}

---

##### `fileFormat`<sup>Optional</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

The file format of the disk.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#file_format VirtualMachine#file_format}

---

##### `speedLimits`<sup>Optional</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.speedLimits"></a>

```typescript
public readonly speedLimits: VirtualMachineComputedDisksSpeedLimits | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits | cdktf.IResolvable

The speed limits of the disk. If not set, no speed limitations are applied.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#speed_limits VirtualMachine#speed_limits}

---

##### `ssdEmulation`<sup>Optional</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use SSD emulation. conflicts with virtio disk type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#ssd_emulation VirtualMachine#ssd_emulation}

---

##### `useIothread`<sup>Optional</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks.property.useIothread"></a>

```typescript
public readonly useIothread: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use an iothread for the disk.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#use_iothread VirtualMachine#use_iothread}

---

### VirtualMachineComputedDisksSpeedLimits <a name="VirtualMachineComputedDisksSpeedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineComputedDisksSpeedLimits: virtualMachine.VirtualMachineComputedDisksSpeedLimits = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.read">read</a></code> | <code>number</code> | The read speed limit in bytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.readBurstable">readBurstable</a></code> | <code>number</code> | The read burstable speed limit in bytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.write">write</a></code> | <code>number</code> | The write speed limit in bytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | The write burstable speed limit in bytes per second. |

---

##### `read`<sup>Optional</sup> <a name="read" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

The read speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#read VirtualMachine#read}

---

##### `readBurstable`<sup>Optional</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

The read burstable speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#read_burstable VirtualMachine#read_burstable}

---

##### `write`<sup>Optional</sup> <a name="write" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

The write speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#write VirtualMachine#write}

---

##### `writeBurstable`<sup>Optional</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

The write burstable speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#write_burstable VirtualMachine#write_burstable}

---

### VirtualMachineComputedNetworkInterfaces <a name="VirtualMachineComputedNetworkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineComputedNetworkInterfaces: virtualMachine.VirtualMachineComputedNetworkInterfaces = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.bridge">bridge</a></code> | <code>string</code> | The bridge the network interface is on. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.position">position</a></code> | <code>number</code> | The position of the network interface in the VM as an int. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the network interface is enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.macAddress">macAddress</a></code> | <code>string</code> | The MAC address of the network interface. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.model">model</a></code> | <code>string</code> | The model of the network interface. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.mtu">mtu</a></code> | <code>number</code> | The MTU of the network interface. Only valid for virtio. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.rateLimit">rateLimit</a></code> | <code>number</code> | The rate limit of the network interface in megabytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.useFirewall">useFirewall</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the firewall for the network interface is enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.vlan">vlan</a></code> | <code>number</code> | The VLAN tag of the network interface. |

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

The bridge the network interface is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#bridge VirtualMachine#bridge}

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

The position of the network interface in the VM as an int.

Used to determine the interface name (net0, net1, etc).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#position VirtualMachine#position}

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the network interface is enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#enabled VirtualMachine#enabled}

---

##### `macAddress`<sup>Optional</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

The MAC address of the network interface.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#mac_address VirtualMachine#mac_address}

---

##### `model`<sup>Optional</sup> <a name="model" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

The model of the network interface.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#model VirtualMachine#model}

---

##### `mtu`<sup>Optional</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

The MTU of the network interface. Only valid for virtio.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#mtu VirtualMachine#mtu}

---

##### `rateLimit`<sup>Optional</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

The rate limit of the network interface in megabytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#rate_limit VirtualMachine#rate_limit}

---

##### `useFirewall`<sup>Optional</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.useFirewall"></a>

```typescript
public readonly useFirewall: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the firewall for the network interface is enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#use_firewall VirtualMachine#use_firewall}

---

##### `vlan`<sup>Optional</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

The VLAN tag of the network interface.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#vlan VirtualMachine#vlan}

---

### VirtualMachineComputedPciDevices <a name="VirtualMachineComputedPciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineComputedPciDevices: virtualMachine.VirtualMachineComputedPciDevices = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.id">id</a></code> | <code>string</code> | The device ID of the PCI device. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.name">name</a></code> | <code>string</code> | The device name of the PCI device. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.mdev">mdev</a></code> | <code>string</code> | The mediated device name. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.pcie">pcie</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the PCI device is PCIe. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.primaryGpu">primaryGpu</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the PCI device is the primary GPU. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.rombar">rombar</a></code> | <code>boolean \| cdktf.IResolvable</code> | Make the firmware room visible to the VM. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.romFile">romFile</a></code> | <code>string</code> | The relative path to the ROM for the device. |

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The device ID of the PCI device.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#id VirtualMachine#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The device name of the PCI device.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#name VirtualMachine#name}

---

##### `mdev`<sup>Optional</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

The mediated device name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#mdev VirtualMachine#mdev}

---

##### `pcie`<sup>Optional</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.pcie"></a>

```typescript
public readonly pcie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the PCI device is PCIe.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#pcie VirtualMachine#pcie}

---

##### `primaryGpu`<sup>Optional</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the PCI device is the primary GPU.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#primary_gpu VirtualMachine#primary_gpu}

---

##### `rombar`<sup>Optional</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.rombar"></a>

```typescript
public readonly rombar: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Make the firmware room visible to the VM.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#rombar VirtualMachine#rombar}

---

##### `romFile`<sup>Optional</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

The relative path to the ROM for the device.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#rom_file VirtualMachine#rom_file}

---

### VirtualMachineConfig <a name="VirtualMachineConfig" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineConfig: virtualMachine.VirtualMachineConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node to create the virtual machine on. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.agent">agent</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent \| cdktf.IResolvable</code> | The agent configuration. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.bios">bios</a></code> | <code>string</code> | The BIOS type. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.clone">clone</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#clone VirtualMachine#clone}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.cloudInit">cloudInit</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#cloud_init VirtualMachine#cloud_init}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.cpu">cpu</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu \| cdktf.IResolvable</code> | The CPU configuration. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.description">description</a></code> | <code>string</code> | The virtual machine description. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.disks">disks</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]</code> | The terrafrom generated disks attached to the VM. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.id">id</a></code> | <code>number</code> | The identifier of the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.iso">iso</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso \| cdktf.IResolvable</code> | The operating system configuration. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.keyboardLayout">keyboardLayout</a></code> | <code>string</code> | The keyboard layout. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.kvmArguments">kvmArguments</a></code> | <code>string</code> | The arguments to pass to KVM. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.machineType">machineType</a></code> | <code>string</code> | The machine type. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.memory">memory</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#memory VirtualMachine#memory}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.name">name</a></code> | <code>string</code> | The name of the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.networkInterfaces">networkInterfaces</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#network_interfaces VirtualMachine#network_interfaces}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.pciDevices">pciDevices</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]</code> | PCI devices passed through to the VM. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.resourcePool">resourcePool</a></code> | <code>string</code> | The resource pool the virtual machine is in. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.startOnCreate">startOnCreate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to start the virtual machine on creation. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.startOnNodeBoot">startOnNodeBoot</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to start the virtual machine on node boot. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.tags">tags</a></code> | <code>string[]</code> | The tags of the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.timeouts">timeouts</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#timeouts VirtualMachine#timeouts}. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.type">type</a></code> | <code>string</code> | The operating system type. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node to create the virtual machine on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#node VirtualMachine#node}

---

##### `agent`<sup>Optional</sup> <a name="agent" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.agent"></a>

```typescript
public readonly agent: VirtualMachineAgent | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent | cdktf.IResolvable

The agent configuration.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#agent VirtualMachine#agent}

---

##### `bios`<sup>Optional</sup> <a name="bios" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.bios"></a>

```typescript
public readonly bios: string;
```

- *Type:* string

The BIOS type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#bios VirtualMachine#bios}

---

##### `clone`<sup>Optional</sup> <a name="clone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.clone"></a>

```typescript
public readonly clone: VirtualMachineClone | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#clone VirtualMachine#clone}.

---

##### `cloudInit`<sup>Optional</sup> <a name="cloudInit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.cloudInit"></a>

```typescript
public readonly cloudInit: VirtualMachineCloudInit | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#cloud_init VirtualMachine#cloud_init}.

---

##### `cpu`<sup>Optional</sup> <a name="cpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.cpu"></a>

```typescript
public readonly cpu: VirtualMachineCpu | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu | cdktf.IResolvable

The CPU configuration.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#cpu VirtualMachine#cpu}

---

##### `description`<sup>Optional</sup> <a name="description" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The virtual machine description.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#description VirtualMachine#description}

---

##### `disks`<sup>Optional</sup> <a name="disks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.disks"></a>

```typescript
public readonly disks: IResolvable | VirtualMachineDisks[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]

The terrafrom generated disks attached to the VM.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#disks VirtualMachine#disks}

---

##### `id`<sup>Optional</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.id"></a>

```typescript
public readonly id: number;
```

- *Type:* number

The identifier of the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#id VirtualMachine#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `iso`<sup>Optional</sup> <a name="iso" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.iso"></a>

```typescript
public readonly iso: VirtualMachineIso | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso | cdktf.IResolvable

The operating system configuration.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#iso VirtualMachine#iso}

---

##### `keyboardLayout`<sup>Optional</sup> <a name="keyboardLayout" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.keyboardLayout"></a>

```typescript
public readonly keyboardLayout: string;
```

- *Type:* string

The keyboard layout.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#keyboard_layout VirtualMachine#keyboard_layout}

---

##### `kvmArguments`<sup>Optional</sup> <a name="kvmArguments" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.kvmArguments"></a>

```typescript
public readonly kvmArguments: string;
```

- *Type:* string

The arguments to pass to KVM.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#kvm_arguments VirtualMachine#kvm_arguments}

---

##### `machineType`<sup>Optional</sup> <a name="machineType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.machineType"></a>

```typescript
public readonly machineType: string;
```

- *Type:* string

The machine type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#machine_type VirtualMachine#machine_type}

---

##### `memory`<sup>Optional</sup> <a name="memory" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.memory"></a>

```typescript
public readonly memory: VirtualMachineMemory | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#memory VirtualMachine#memory}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#name VirtualMachine#name}

---

##### `networkInterfaces`<sup>Optional</sup> <a name="networkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.networkInterfaces"></a>

```typescript
public readonly networkInterfaces: IResolvable | VirtualMachineNetworkInterfaces[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#network_interfaces VirtualMachine#network_interfaces}.

---

##### `pciDevices`<sup>Optional</sup> <a name="pciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.pciDevices"></a>

```typescript
public readonly pciDevices: IResolvable | VirtualMachinePciDevices[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]

PCI devices passed through to the VM.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#pci_devices VirtualMachine#pci_devices}

---

##### `resourcePool`<sup>Optional</sup> <a name="resourcePool" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.resourcePool"></a>

```typescript
public readonly resourcePool: string;
```

- *Type:* string

The resource pool the virtual machine is in.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#resource_pool VirtualMachine#resource_pool}

---

##### `startOnCreate`<sup>Optional</sup> <a name="startOnCreate" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.startOnCreate"></a>

```typescript
public readonly startOnCreate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to start the virtual machine on creation.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#start_on_create VirtualMachine#start_on_create}

---

##### `startOnNodeBoot`<sup>Optional</sup> <a name="startOnNodeBoot" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.startOnNodeBoot"></a>

```typescript
public readonly startOnNodeBoot: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to start the virtual machine on node boot.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#start_on_node_boot VirtualMachine#start_on_node_boot}

---

##### `tags`<sup>Optional</sup> <a name="tags" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

The tags of the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#tags VirtualMachine#tags}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VirtualMachineTimeouts | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#timeouts VirtualMachine#timeouts}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineConfig.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

The operating system type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#type VirtualMachine#type}

---

### VirtualMachineCpu <a name="VirtualMachineCpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineCpu: virtualMachine.VirtualMachineCpu = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.architecture">architecture</a></code> | <code>string</code> | The CPU architecture. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.cores">cores</a></code> | <code>number</code> | The number of CPU cores. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.cpuUnits">cpuUnits</a></code> | <code>number</code> | The CPU units. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.emulatedType">emulatedType</a></code> | <code>string</code> | The emulated CPU type. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.sockets">sockets</a></code> | <code>number</code> | The number of CPU sockets. |

---

##### `architecture`<sup>Optional</sup> <a name="architecture" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.architecture"></a>

```typescript
public readonly architecture: string;
```

- *Type:* string

The CPU architecture.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#architecture VirtualMachine#architecture}

---

##### `cores`<sup>Optional</sup> <a name="cores" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

The number of CPU cores.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#cores VirtualMachine#cores}

---

##### `cpuUnits`<sup>Optional</sup> <a name="cpuUnits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.cpuUnits"></a>

```typescript
public readonly cpuUnits: number;
```

- *Type:* number

The CPU units.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#cpu_units VirtualMachine#cpu_units}

---

##### `emulatedType`<sup>Optional</sup> <a name="emulatedType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.emulatedType"></a>

```typescript
public readonly emulatedType: string;
```

- *Type:* string

The emulated CPU type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#emulated_type VirtualMachine#emulated_type}

---

##### `sockets`<sup>Optional</sup> <a name="sockets" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* number

The number of CPU sockets.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#sockets VirtualMachine#sockets}

---

### VirtualMachineDisks <a name="VirtualMachineDisks" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineDisks: virtualMachine.VirtualMachineDisks = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.interfaceType">interfaceType</a></code> | <code>string</code> | The type of the disk. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.position">position</a></code> | <code>number</code> | The position of the disk. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.size">size</a></code> | <code>number</code> | The size of the disk in GiB. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.storage">storage</a></code> | <code>string</code> | The storage the disk is on. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.discard">discard</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the disk has discard enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.fileFormat">fileFormat</a></code> | <code>string</code> | The file format of the disk. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits \| cdktf.IResolvable</code> | The speed limits of the disk. If not set, no speed limitations are applied. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.ssdEmulation">ssdEmulation</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use SSD emulation. conflicts with virtio disk type. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.useIothread">useIothread</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether to use an iothread for the disk. |

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

The type of the disk.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#interface_type VirtualMachine#interface_type}

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

The position of the disk.

(0, 1, 2, etc.) This is combined with the `interface_type` to determine the disk name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#position VirtualMachine#position}

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

The size of the disk in GiB.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#size VirtualMachine#size}

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

The storage the disk is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#storage VirtualMachine#storage}

---

##### `discard`<sup>Optional</sup> <a name="discard" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.discard"></a>

```typescript
public readonly discard: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the disk has discard enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#discard VirtualMachine#discard}

---

##### `fileFormat`<sup>Optional</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

The file format of the disk.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#file_format VirtualMachine#file_format}

---

##### `speedLimits`<sup>Optional</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.speedLimits"></a>

```typescript
public readonly speedLimits: VirtualMachineDisksSpeedLimits | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits | cdktf.IResolvable

The speed limits of the disk. If not set, no speed limitations are applied.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#speed_limits VirtualMachine#speed_limits}

---

##### `ssdEmulation`<sup>Optional</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use SSD emulation. conflicts with virtio disk type.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#ssd_emulation VirtualMachine#ssd_emulation}

---

##### `useIothread`<sup>Optional</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks.property.useIothread"></a>

```typescript
public readonly useIothread: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether to use an iothread for the disk.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#use_iothread VirtualMachine#use_iothread}

---

### VirtualMachineDisksSpeedLimits <a name="VirtualMachineDisksSpeedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineDisksSpeedLimits: virtualMachine.VirtualMachineDisksSpeedLimits = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.read">read</a></code> | <code>number</code> | The read speed limit in bytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.readBurstable">readBurstable</a></code> | <code>number</code> | The read burstable speed limit in bytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.write">write</a></code> | <code>number</code> | The write speed limit in bytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | The write burstable speed limit in bytes per second. |

---

##### `read`<sup>Optional</sup> <a name="read" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

The read speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#read VirtualMachine#read}

---

##### `readBurstable`<sup>Optional</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

The read burstable speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#read_burstable VirtualMachine#read_burstable}

---

##### `write`<sup>Optional</sup> <a name="write" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

The write speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#write VirtualMachine#write}

---

##### `writeBurstable`<sup>Optional</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

The write burstable speed limit in bytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#write_burstable VirtualMachine#write_burstable}

---

### VirtualMachineIso <a name="VirtualMachineIso" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineIso: virtualMachine.VirtualMachineIso = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso.property.image">image</a></code> | <code>string</code> | The image to use for install media. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso.property.storage">storage</a></code> | <code>string</code> | The storage to place install media on. |

---

##### `image`<sup>Required</sup> <a name="image" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

The image to use for install media.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#image VirtualMachine#image}

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

The storage to place install media on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#storage VirtualMachine#storage}

---

### VirtualMachineMemory <a name="VirtualMachineMemory" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineMemory: virtualMachine.VirtualMachineMemory = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.property.dedicated">dedicated</a></code> | <code>number</code> | The size of the memory in MB. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.property.floating">floating</a></code> | <code>number</code> | The floating memory in MB. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.property.shared">shared</a></code> | <code>number</code> | The shared memory in MB. |

---

##### `dedicated`<sup>Optional</sup> <a name="dedicated" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.property.dedicated"></a>

```typescript
public readonly dedicated: number;
```

- *Type:* number

The size of the memory in MB.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#dedicated VirtualMachine#dedicated}

---

##### `floating`<sup>Optional</sup> <a name="floating" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.property.floating"></a>

```typescript
public readonly floating: number;
```

- *Type:* number

The floating memory in MB.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#floating VirtualMachine#floating}

---

##### `shared`<sup>Optional</sup> <a name="shared" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory.property.shared"></a>

```typescript
public readonly shared: number;
```

- *Type:* number

The shared memory in MB.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#shared VirtualMachine#shared}

---

### VirtualMachineNetworkInterfaces <a name="VirtualMachineNetworkInterfaces" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineNetworkInterfaces: virtualMachine.VirtualMachineNetworkInterfaces = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.bridge">bridge</a></code> | <code>string</code> | The bridge the network interface is on. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.position">position</a></code> | <code>number</code> | The position of the network interface in the VM as an int. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the network interface is enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.macAddress">macAddress</a></code> | <code>string</code> | The MAC address of the network interface. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.model">model</a></code> | <code>string</code> | The model of the network interface. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.mtu">mtu</a></code> | <code>number</code> | The MTU of the network interface. Only valid for virtio. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.rateLimit">rateLimit</a></code> | <code>number</code> | The rate limit of the network interface in megabytes per second. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.useFirewall">useFirewall</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the firewall for the network interface is enabled. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.vlan">vlan</a></code> | <code>number</code> | The VLAN tag of the network interface. |

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

The bridge the network interface is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#bridge VirtualMachine#bridge}

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

The position of the network interface in the VM as an int.

Used to determine the interface name (net0, net1, etc).

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#position VirtualMachine#position}

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the network interface is enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#enabled VirtualMachine#enabled}

---

##### `macAddress`<sup>Optional</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

The MAC address of the network interface.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#mac_address VirtualMachine#mac_address}

---

##### `model`<sup>Optional</sup> <a name="model" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

The model of the network interface.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#model VirtualMachine#model}

---

##### `mtu`<sup>Optional</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

The MTU of the network interface. Only valid for virtio.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#mtu VirtualMachine#mtu}

---

##### `rateLimit`<sup>Optional</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

The rate limit of the network interface in megabytes per second.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#rate_limit VirtualMachine#rate_limit}

---

##### `useFirewall`<sup>Optional</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.useFirewall"></a>

```typescript
public readonly useFirewall: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the firewall for the network interface is enabled.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#use_firewall VirtualMachine#use_firewall}

---

##### `vlan`<sup>Optional</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

The VLAN tag of the network interface.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#vlan VirtualMachine#vlan}

---

### VirtualMachinePciDevices <a name="VirtualMachinePciDevices" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachinePciDevices: virtualMachine.VirtualMachinePciDevices = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.id">id</a></code> | <code>string</code> | The device ID of the PCI device. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.name">name</a></code> | <code>string</code> | The device name of the PCI device. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.mdev">mdev</a></code> | <code>string</code> | The mediated device name. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.pcie">pcie</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the PCI device is PCIe. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.primaryGpu">primaryGpu</a></code> | <code>boolean \| cdktf.IResolvable</code> | Whether the PCI device is the primary GPU. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.rombar">rombar</a></code> | <code>boolean \| cdktf.IResolvable</code> | Make the firmware room visible to the VM. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.romFile">romFile</a></code> | <code>string</code> | The relative path to the ROM for the device. |

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The device ID of the PCI device.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#id VirtualMachine#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The device name of the PCI device.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#name VirtualMachine#name}

---

##### `mdev`<sup>Optional</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

The mediated device name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#mdev VirtualMachine#mdev}

---

##### `pcie`<sup>Optional</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.pcie"></a>

```typescript
public readonly pcie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the PCI device is PCIe.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#pcie VirtualMachine#pcie}

---

##### `primaryGpu`<sup>Optional</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Whether the PCI device is the primary GPU.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#primary_gpu VirtualMachine#primary_gpu}

---

##### `rombar`<sup>Optional</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.rombar"></a>

```typescript
public readonly rombar: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Make the firmware room visible to the VM.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#rombar VirtualMachine#rombar}

---

##### `romFile`<sup>Optional</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

The relative path to the ROM for the device.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#rom_file VirtualMachine#rom_file}

---

### VirtualMachineTimeouts <a name="VirtualMachineTimeouts" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

const virtualMachineTimeouts: virtualMachine.VirtualMachineTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.clone">clone</a></code> | <code>number</code> | The timeout for cloning the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.configure">configure</a></code> | <code>number</code> | The timeout for configuring the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.create">create</a></code> | <code>number</code> | The timeout for creating the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.delete">delete</a></code> | <code>number</code> | The timeout for deleting the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.reboot">reboot</a></code> | <code>number</code> | The timeout for rebooting the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.resizeDisk">resizeDisk</a></code> | <code>number</code> | The timeout for resizing disk the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.shutdown">shutdown</a></code> | <code>number</code> | The timeout for shutting down the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.start">start</a></code> | <code>number</code> | The timeout for starting the virtual machine. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.stop">stop</a></code> | <code>number</code> | The timeout for stopping the virtual machine. |

---

##### `clone`<sup>Optional</sup> <a name="clone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.clone"></a>

```typescript
public readonly clone: number;
```

- *Type:* number

The timeout for cloning the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#clone VirtualMachine#clone}

---

##### `configure`<sup>Optional</sup> <a name="configure" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.configure"></a>

```typescript
public readonly configure: number;
```

- *Type:* number

The timeout for configuring the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#configure VirtualMachine#configure}

---

##### `create`<sup>Optional</sup> <a name="create" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.create"></a>

```typescript
public readonly create: number;
```

- *Type:* number

The timeout for creating the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#create VirtualMachine#create}

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.delete"></a>

```typescript
public readonly delete: number;
```

- *Type:* number

The timeout for deleting the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#delete VirtualMachine#delete}

---

##### `reboot`<sup>Optional</sup> <a name="reboot" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.reboot"></a>

```typescript
public readonly reboot: number;
```

- *Type:* number

The timeout for rebooting the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#reboot VirtualMachine#reboot}

---

##### `resizeDisk`<sup>Optional</sup> <a name="resizeDisk" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.resizeDisk"></a>

```typescript
public readonly resizeDisk: number;
```

- *Type:* number

The timeout for resizing disk the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#resize_disk VirtualMachine#resize_disk}

---

##### `shutdown`<sup>Optional</sup> <a name="shutdown" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.shutdown"></a>

```typescript
public readonly shutdown: number;
```

- *Type:* number

The timeout for shutting down the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#shutdown VirtualMachine#shutdown}

---

##### `start`<sup>Optional</sup> <a name="start" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.start"></a>

```typescript
public readonly start: number;
```

- *Type:* number

The timeout for starting the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#start VirtualMachine#start}

---

##### `stop`<sup>Optional</sup> <a name="stop" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts.property.stop"></a>

```typescript
public readonly stop: number;
```

- *Type:* number

The timeout for stopping the virtual machine.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/virtual_machine#stop VirtualMachine#stop}

---

### ZfsPoolConfig <a name="ZfsPoolConfig" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.Initializer"></a>

```typescript
import { zfsPool } from '@awlsring/cdktf-proxmox'

const zfsPoolConfig: zfsPool.ZfsPoolConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.disks">disks</a></code> | <code>string[]</code> | List of disks that make the ZFS pool. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.name">name</a></code> | <code>string</code> | The name of the ZFS pool. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | The node the ZFS pool is on. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.raidLevel">raidLevel</a></code> | <code>string</code> | The RAID level of the ZFS pool. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.disks"></a>

```typescript
public readonly disks: string[];
```

- *Type:* string[]

List of disks that make the ZFS pool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#disks ZfsPool#disks}

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the ZFS pool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#name ZfsPool#name}

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

The node the ZFS pool is on.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#node ZfsPool#node}

---

##### `raidLevel`<sup>Required</sup> <a name="raidLevel" id="@awlsring/cdktf-proxmox.zfsPool.ZfsPoolConfig.property.raidLevel"></a>

```typescript
public readonly raidLevel: string;
```

- *Type:* string

The RAID level of the ZFS pool.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_pool#raid_level ZfsPool#raid_level}

---

### ZfsStorageClassConfig <a name="ZfsStorageClassConfig" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig"></a>

#### Initializer <a name="Initializer" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.Initializer"></a>

```typescript
import { zfsStorageClass } from '@awlsring/cdktf-proxmox'

const zfsStorageClassConfig: zfsStorageClass.ZfsStorageClassConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.connection">connection</a></code> | <code>cdktf.SSHProvisionerConnection \| cdktf.WinrmProvisionerConnection</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.forEach">forEach</a></code> | <code>cdktf.ITerraformIterator</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.provisioners">provisioners</a></code> | <code>cdktf.FileProvisioner \| cdktf.LocalExecProvisioner \| cdktf.RemoteExecProvisioner[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.id">id</a></code> | <code>string</code> | The id of the ZFS storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.pool">pool</a></code> | <code>string</code> | The ZFS pool of the storage. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | The content types that can be stored on this storage class. |
| <code><a href="#@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.nodes">nodes</a></code> | <code>string[]</code> | Nodes that implement this storage class. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.connection"></a>

```typescript
public readonly connection: SSHProvisionerConnection | WinrmProvisionerConnection;
```

- *Type:* cdktf.SSHProvisionerConnection | cdktf.WinrmProvisionerConnection

---

##### `count`<sup>Optional</sup> <a name="count" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `forEach`<sup>Optional</sup> <a name="forEach" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.forEach"></a>

```typescript
public readonly forEach: ITerraformIterator;
```

- *Type:* cdktf.ITerraformIterator

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `provisioners`<sup>Optional</sup> <a name="provisioners" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.provisioners"></a>

```typescript
public readonly provisioners: FileProvisioner | LocalExecProvisioner | RemoteExecProvisioner[];
```

- *Type:* cdktf.FileProvisioner | cdktf.LocalExecProvisioner | cdktf.RemoteExecProvisioner[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

The id of the ZFS storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_storage_class#id ZfsStorageClass#id}

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `pool`<sup>Required</sup> <a name="pool" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string

The ZFS pool of the storage.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_storage_class#pool ZfsStorageClass#pool}

---

##### `contentTypes`<sup>Optional</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

The content types that can be stored on this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_storage_class#content_types ZfsStorageClass#content_types}

---

##### `nodes`<sup>Optional</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.zfsStorageClass.ZfsStorageClassConfig.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

Nodes that implement this storage class.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/proxmox/r/zfs_storage_class#nodes ZfsStorageClass#nodes}

---

## Classes <a name="Classes" id="Classes"></a>

### DataProxmoxLvmsFiltersList <a name="DataProxmoxLvmsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvms.DataProxmoxLvmsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxLvmsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters[]

---


### DataProxmoxLvmsFiltersOutputReference <a name="DataProxmoxLvmsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsFilters | cdktf.IResolvable

---


### DataProxmoxLvmsLvmsList <a name="DataProxmoxLvmsLvmsList" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvms.DataProxmoxLvmsLvmsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmsLvmsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxLvmsLvmsOutputReference <a name="DataProxmoxLvmsLvmsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.device">device</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvms</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvmsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmsLvms;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvms.DataProxmoxLvmsLvms

---


### DataProxmoxLvmStorageClassesFiltersList <a name="DataProxmoxLvmStorageClassesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmStorageClassesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxLvmStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters[]

---


### DataProxmoxLvmStorageClassesFiltersOutputReference <a name="DataProxmoxLvmStorageClassesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmStorageClassesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesFilters | cdktf.IResolvable

---


### DataProxmoxLvmStorageClassesLvmStorageClassesList <a name="DataProxmoxLvmStorageClassesLvmStorageClassesList" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference <a name="DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvmStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClasses</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClassesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmStorageClassesLvmStorageClasses;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmStorageClasses.DataProxmoxLvmStorageClassesLvmStorageClasses

---


### DataProxmoxLvmThinpoolsFiltersList <a name="DataProxmoxLvmThinpoolsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmThinpoolsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxLvmThinpoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters[]

---


### DataProxmoxLvmThinpoolsFiltersOutputReference <a name="DataProxmoxLvmThinpoolsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmThinpoolsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsFilters | cdktf.IResolvable

---


### DataProxmoxLvmThinpoolsLvmThinpoolsList <a name="DataProxmoxLvmThinpoolsLvmThinpoolsList" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference <a name="DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.device">device</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.metadataSize">metadataSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpools</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `metadataSize`<sup>Required</sup> <a name="metadataSize" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.metadataSize"></a>

```typescript
public readonly metadataSize: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpoolsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmThinpoolsLvmThinpools;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpools.DataProxmoxLvmThinpoolsLvmThinpools

---


### DataProxmoxLvmThinpoolStorageClassesFiltersList <a name="DataProxmoxLvmThinpoolStorageClassesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxLvmThinpoolStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters[]

---


### DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference <a name="DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmThinpoolStorageClassesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesFilters | cdktf.IResolvable

---


### DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList <a name="DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.get"></a>

```typescript
public get(index: number): DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference <a name="DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxLvmThinpoolStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.thinpool">thinpool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `thinpool`<sup>Required</sup> <a name="thinpool" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.thinpool"></a>

```typescript
public readonly thinpool: string;
```

- *Type:* string

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClassesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxLvmThinpoolStorageClasses.DataProxmoxLvmThinpoolStorageClassesLvmThinpoolStorageClasses

---


### DataProxmoxNetworkBondsFiltersList <a name="DataProxmoxNetworkBondsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNetworkBondsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNetworkBondsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters[]

---


### DataProxmoxNetworkBondsFiltersOutputReference <a name="DataProxmoxNetworkBondsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBondsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsFilters | cdktf.IResolvable

---


### DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference <a name="DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBondsNetworkBondsIpv4;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv4

---


### DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference <a name="DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBondsNetworkBondsIpv6;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsIpv6

---


### DataProxmoxNetworkBondsNetworkBondsList <a name="DataProxmoxNetworkBondsNetworkBondsList" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.get"></a>

```typescript
public get(index: number): DataProxmoxNetworkBondsNetworkBondsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNetworkBondsNetworkBonds[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds[]

---


### DataProxmoxNetworkBondsNetworkBondsOutputReference <a name="DataProxmoxNetworkBondsNetworkBondsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBonds } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resetIpv4Gateway">resetIpv4Gateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resetIpv6Gateway">resetIpv6Gateway</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetIpv4Gateway` <a name="resetIpv4Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resetIpv4Gateway"></a>

```typescript
public resetIpv4Gateway(): void
```

##### `resetIpv6Gateway` <a name="resetIpv6Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.resetIpv6Gateway"></a>

```typescript
public resetIpv6Gateway(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.active">active</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.autostart">autostart</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.bondPrimary">bondPrimary</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.comments">comments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.hashPolicy">hashPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.interfaces">interfaces</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.miiMon">miiMon</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv4GatewayInput">ipv4GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv6GatewayInput">ipv6GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `active`<sup>Required</sup> <a name="active" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.active"></a>

```typescript
public readonly active: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `autostart`<sup>Required</sup> <a name="autostart" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.autostart"></a>

```typescript
public readonly autostart: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `bondPrimary`<sup>Required</sup> <a name="bondPrimary" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.bondPrimary"></a>

```typescript
public readonly bondPrimary: string;
```

- *Type:* string

---

##### `comments`<sup>Required</sup> <a name="comments" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

---

##### `hashPolicy`<sup>Required</sup> <a name="hashPolicy" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.hashPolicy"></a>

```typescript
public readonly hashPolicy: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `interfaces`<sup>Required</sup> <a name="interfaces" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.interfaces"></a>

```typescript
public readonly interfaces: string[];
```

- *Type:* string[]

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `miiMon`<sup>Required</sup> <a name="miiMon" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.miiMon"></a>

```typescript
public readonly miiMon: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `ipv4GatewayInput`<sup>Optional</sup> <a name="ipv4GatewayInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv4GatewayInput"></a>

```typescript
public readonly ipv4GatewayInput: string;
```

- *Type:* string

---

##### `ipv6GatewayInput`<sup>Optional</sup> <a name="ipv6GatewayInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv6GatewayInput"></a>

```typescript
public readonly ipv6GatewayInput: string;
```

- *Type:* string

---

##### `ipv4Gateway`<sup>Required</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

---

##### `ipv6Gateway`<sup>Required</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBondsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBondsNetworkBonds;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBonds.DataProxmoxNetworkBondsNetworkBonds

---


### DataProxmoxNetworkBridgesFiltersList <a name="DataProxmoxNetworkBridgesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNetworkBridgesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNetworkBridgesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters[]

---


### DataProxmoxNetworkBridgesFiltersOutputReference <a name="DataProxmoxNetworkBridgesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBridgesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesFilters | cdktf.IResolvable

---


### DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference <a name="DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBridgesNetworkBridgesIpv4;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv4

---


### DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference <a name="DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBridgesNetworkBridgesIpv6;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesIpv6

---


### DataProxmoxNetworkBridgesNetworkBridgesList <a name="DataProxmoxNetworkBridgesNetworkBridgesList" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.get"></a>

```typescript
public get(index: number): DataProxmoxNetworkBridgesNetworkBridgesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNetworkBridgesNetworkBridges[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges[]

---


### DataProxmoxNetworkBridgesNetworkBridgesOutputReference <a name="DataProxmoxNetworkBridgesNetworkBridgesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNetworkBridges } from '@awlsring/cdktf-proxmox'

new dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resetComments">resetComments</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resetIpv4Gateway">resetIpv4Gateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resetIpv6Gateway">resetIpv6Gateway</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetComments` <a name="resetComments" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resetComments"></a>

```typescript
public resetComments(): void
```

##### `resetIpv4Gateway` <a name="resetIpv4Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resetIpv4Gateway"></a>

```typescript
public resetIpv4Gateway(): void
```

##### `resetIpv6Gateway` <a name="resetIpv6Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.resetIpv6Gateway"></a>

```typescript
public resetIpv6Gateway(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.active">active</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.autostart">autostart</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.interfaces">interfaces</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.vlanAware">vlanAware</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.commentsInput">commentsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv4GatewayInput">ipv4GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv6GatewayInput">ipv6GatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.comments">comments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv4Gateway">ipv4Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv6Gateway">ipv6Gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `active`<sup>Required</sup> <a name="active" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.active"></a>

```typescript
public readonly active: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `autostart`<sup>Required</sup> <a name="autostart" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.autostart"></a>

```typescript
public readonly autostart: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `interfaces`<sup>Required</sup> <a name="interfaces" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.interfaces"></a>

```typescript
public readonly interfaces: string[];
```

- *Type:* string[]

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `vlanAware`<sup>Required</sup> <a name="vlanAware" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.vlanAware"></a>

```typescript
public readonly vlanAware: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `commentsInput`<sup>Optional</sup> <a name="commentsInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.commentsInput"></a>

```typescript
public readonly commentsInput: string;
```

- *Type:* string

---

##### `ipv4GatewayInput`<sup>Optional</sup> <a name="ipv4GatewayInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv4GatewayInput"></a>

```typescript
public readonly ipv4GatewayInput: string;
```

- *Type:* string

---

##### `ipv6GatewayInput`<sup>Optional</sup> <a name="ipv6GatewayInput" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv6GatewayInput"></a>

```typescript
public readonly ipv6GatewayInput: string;
```

- *Type:* string

---

##### `comments`<sup>Required</sup> <a name="comments" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.comments"></a>

```typescript
public readonly comments: string;
```

- *Type:* string

---

##### `ipv4Gateway`<sup>Required</sup> <a name="ipv4Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv4Gateway"></a>

```typescript
public readonly ipv4Gateway: string;
```

- *Type:* string

---

##### `ipv6Gateway`<sup>Required</sup> <a name="ipv6Gateway" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.ipv6Gateway"></a>

```typescript
public readonly ipv6Gateway: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridgesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNetworkBridgesNetworkBridges;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNetworkBridges.DataProxmoxNetworkBridgesNetworkBridges

---


### DataProxmoxNfsStorageClassesFiltersList <a name="DataProxmoxNfsStorageClassesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNfsStorageClassesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNfsStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters[]

---


### DataProxmoxNfsStorageClassesFiltersOutputReference <a name="DataProxmoxNfsStorageClassesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNfsStorageClassesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesFilters | cdktf.IResolvable

---


### DataProxmoxNfsStorageClassesNfsStorageClassesList <a name="DataProxmoxNfsStorageClassesNfsStorageClassesList" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.get"></a>

```typescript
public get(index: number): DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference <a name="DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.export">export</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.mount">mount</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.server">server</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClasses</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `export`<sup>Required</sup> <a name="export" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.export"></a>

```typescript
public readonly export: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mount`<sup>Required</sup> <a name="mount" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.mount"></a>

```typescript
public readonly mount: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `server`<sup>Required</sup> <a name="server" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClassesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNfsStorageClassesNfsStorageClasses;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNfsStorageClasses.DataProxmoxNfsStorageClassesNfsStorageClasses

---


### DataProxmoxNodesFiltersList <a name="DataProxmoxNodesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNodesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNodesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters[]

---


### DataProxmoxNodesFiltersOutputReference <a name="DataProxmoxNodesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesFilters | cdktf.IResolvable

---


### DataProxmoxNodesNodesDisksList <a name="DataProxmoxNodesNodesDisksList" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodesNodesDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.get"></a>

```typescript
public get(index: number): DataProxmoxNodesNodesDisksOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNodesNodesDisksOutputReference <a name="DataProxmoxNodesNodesDisksOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.device">device</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.idLink">idLink</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.model">model</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.serial">serial</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.vendor">vendor</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisks</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `device`<sup>Required</sup> <a name="device" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.device"></a>

```typescript
public readonly device: string;
```

- *Type:* string

---

##### `idLink`<sup>Required</sup> <a name="idLink" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.idLink"></a>

```typescript
public readonly idLink: string;
```

- *Type:* string

---

##### `model`<sup>Required</sup> <a name="model" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

---

##### `serial`<sup>Required</sup> <a name="serial" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.serial"></a>

```typescript
public readonly serial: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `vendor`<sup>Required</sup> <a name="vendor" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.vendor"></a>

```typescript
public readonly vendor: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodesNodesDisks;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisks

---


### DataProxmoxNodesNodesList <a name="DataProxmoxNodesNodesList" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodesNodesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.get"></a>

```typescript
public get(index: number): DataProxmoxNodesNodesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNodesNodesOutputReference <a name="DataProxmoxNodesNodesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodes } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodes.DataProxmoxNodesNodesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.disks">disks</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.networkInterfaces">networkInterfaces</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.sslFingerprint">sslFingerprint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodes</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cores`<sup>Required</sup> <a name="cores" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.disks"></a>

```typescript
public readonly disks: DataProxmoxNodesNodesDisksList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesDisksList

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `memory`<sup>Required</sup> <a name="memory" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `networkInterfaces`<sup>Required</sup> <a name="networkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.networkInterfaces"></a>

```typescript
public readonly networkInterfaces: string[];
```

- *Type:* string[]

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `sslFingerprint`<sup>Required</sup> <a name="sslFingerprint" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.sslFingerprint"></a>

```typescript
public readonly sslFingerprint: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodesNodes;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodes.DataProxmoxNodesNodes

---


### DataProxmoxNodeStorageLvmsFiltersList <a name="DataProxmoxNodeStorageLvmsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageLvmsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNodeStorageLvmsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters[]

---


### DataProxmoxNodeStorageLvmsFiltersOutputReference <a name="DataProxmoxNodeStorageLvmsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageLvmsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsFilters | cdktf.IResolvable

---


### DataProxmoxNodeStorageLvmsNodeStorageLvmsList <a name="DataProxmoxNodeStorageLvmsNodeStorageLvmsList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference <a name="DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvms } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvms</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvmsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageLvmsNodeStorageLvms;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvms.DataProxmoxNodeStorageLvmsNodeStorageLvms

---


### DataProxmoxNodeStorageLvmThinpoolsFiltersList <a name="DataProxmoxNodeStorageLvmThinpoolsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNodeStorageLvmThinpoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters[]

---


### DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference <a name="DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageLvmThinpoolsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsFilters | cdktf.IResolvable

---


### DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList <a name="DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference <a name="DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageLvmThinpools } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.thinpool">thinpool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.volumeGroup">volumeGroup</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `thinpool`<sup>Required</sup> <a name="thinpool" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.thinpool"></a>

```typescript
public readonly thinpool: string;
```

- *Type:* string

---

##### `volumeGroup`<sup>Required</sup> <a name="volumeGroup" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.volumeGroup"></a>

```typescript
public readonly volumeGroup: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpoolsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageLvmThinpools.DataProxmoxNodeStorageLvmThinpoolsNodeStorageLvmThinpools

---


### DataProxmoxNodeStorageNfsFiltersList <a name="DataProxmoxNodeStorageNfsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageNfsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNodeStorageNfsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters[]

---


### DataProxmoxNodeStorageNfsFiltersOutputReference <a name="DataProxmoxNodeStorageNfsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageNfsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsFilters | cdktf.IResolvable

---


### DataProxmoxNodeStorageNfsNodeStorageNfsList <a name="DataProxmoxNodeStorageNfsNodeStorageNfsList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference <a name="DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageNfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.export">export</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.mount">mount</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.server">server</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfs</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `export`<sup>Required</sup> <a name="export" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.export"></a>

```typescript
public readonly export: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mount`<sup>Required</sup> <a name="mount" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.mount"></a>

```typescript
public readonly mount: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `server`<sup>Required</sup> <a name="server" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageNfsNodeStorageNfs;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageNfs.DataProxmoxNodeStorageNfsNodeStorageNfs

---


### DataProxmoxNodeStorageZfsFiltersList <a name="DataProxmoxNodeStorageZfsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageZfsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxNodeStorageZfsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters[]

---


### DataProxmoxNodeStorageZfsFiltersOutputReference <a name="DataProxmoxNodeStorageZfsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageZfsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsFilters | cdktf.IResolvable

---


### DataProxmoxNodeStorageZfsNodeStorageZfsList <a name="DataProxmoxNodeStorageZfsNodeStorageZfsList" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.get"></a>

```typescript
public get(index: number): DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference <a name="DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxNodeStorageZfs } from '@awlsring/cdktf-proxmox'

new dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.mount">mount</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.pool">pool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfs</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mount`<sup>Required</sup> <a name="mount" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.mount"></a>

```typescript
public readonly mount: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `pool`<sup>Required</sup> <a name="pool" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxNodeStorageZfsNodeStorageZfs;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxNodeStorageZfs.DataProxmoxNodeStorageZfsNodeStorageZfs

---


### DataProxmoxResourcePoolsFiltersList <a name="DataProxmoxResourcePoolsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxResourcePoolsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxResourcePoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters[]

---


### DataProxmoxResourcePoolsFiltersOutputReference <a name="DataProxmoxResourcePoolsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxResourcePoolsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsFilters | cdktf.IResolvable

---


### DataProxmoxResourcePoolsResourcePoolsList <a name="DataProxmoxResourcePoolsResourcePoolsList" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.get"></a>

```typescript
public get(index: number): DataProxmoxResourcePoolsResourcePoolsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxResourcePoolsResourcePoolsMembersList <a name="DataProxmoxResourcePoolsResourcePoolsMembersList" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.get"></a>

```typescript
public get(index: number): DataProxmoxResourcePoolsResourcePoolsMembersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxResourcePoolsResourcePoolsMembersOutputReference <a name="DataProxmoxResourcePoolsResourcePoolsMembersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembers</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxResourcePoolsResourcePoolsMembers;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembers

---


### DataProxmoxResourcePoolsResourcePoolsOutputReference <a name="DataProxmoxResourcePoolsResourcePoolsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxResourcePools } from '@awlsring/cdktf-proxmox'

new dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.comment">comment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.members">members</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePools</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `comment`<sup>Required</sup> <a name="comment" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.comment"></a>

```typescript
public readonly comment: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.members"></a>

```typescript
public readonly members: DataProxmoxResourcePoolsResourcePoolsMembersList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsMembersList

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePoolsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxResourcePoolsResourcePools;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxResourcePools.DataProxmoxResourcePoolsResourcePools

---


### DataProxmoxTemplateAgentOutputReference <a name="DataProxmoxTemplateAgentOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.useFstrim">useFstrim</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgent</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `useFstrim`<sup>Required</sup> <a name="useFstrim" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.useFstrim"></a>

```typescript
public readonly useFstrim: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateAgent;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateAgent

---


### DataProxmoxTemplateCloudInitDnsOutputReference <a name="DataProxmoxTemplateCloudInitDnsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.domain">domain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.nameserver">nameserver</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDns</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `domain`<sup>Required</sup> <a name="domain" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

---

##### `nameserver`<sup>Required</sup> <a name="nameserver" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.nameserver"></a>

```typescript
public readonly nameserver: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCloudInitDns;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDns

---


### DataProxmoxTemplateCloudInitIpList <a name="DataProxmoxTemplateCloudInitIpList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplateCloudInitIpOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplateCloudInitIpOutputReference <a name="DataProxmoxTemplateCloudInitIpOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.v4">v4</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.v6">v6</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIp</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `v4`<sup>Required</sup> <a name="v4" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.v4"></a>

```typescript
public readonly v4: DataProxmoxTemplateCloudInitIpV4OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference

---

##### `v6`<sup>Required</sup> <a name="v6" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.v6"></a>

```typescript
public readonly v6: DataProxmoxTemplateCloudInitIpV6OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCloudInitIp;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIp

---


### DataProxmoxTemplateCloudInitIpV4OutputReference <a name="DataProxmoxTemplateCloudInitIpV4OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.dhcp">dhcp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCloudInitIpV4;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV4

---


### DataProxmoxTemplateCloudInitIpV6OutputReference <a name="DataProxmoxTemplateCloudInitIpV6OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.dhcp">dhcp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCloudInitIpV6;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpV6

---


### DataProxmoxTemplateCloudInitOutputReference <a name="DataProxmoxTemplateCloudInitOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.dns">dns</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.ip">ip</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.user">user</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInit</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dns`<sup>Required</sup> <a name="dns" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.dns"></a>

```typescript
public readonly dns: DataProxmoxTemplateCloudInitDnsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitDnsOutputReference

---

##### `ip`<sup>Required</sup> <a name="ip" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.ip"></a>

```typescript
public readonly ip: DataProxmoxTemplateCloudInitIpList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitIpList

---

##### `user`<sup>Required</sup> <a name="user" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.user"></a>

```typescript
public readonly user: DataProxmoxTemplateCloudInitUserOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCloudInit;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInit

---


### DataProxmoxTemplateCloudInitUserOutputReference <a name="DataProxmoxTemplateCloudInitUserOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.publicKeys">publicKeys</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUser</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `publicKeys`<sup>Required</sup> <a name="publicKeys" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.publicKeys"></a>

```typescript
public readonly publicKeys: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCloudInitUser;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCloudInitUser

---


### DataProxmoxTemplateCpuOutputReference <a name="DataProxmoxTemplateCpuOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.architecture">architecture</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.cpuUnits">cpuUnits</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.emulatedType">emulatedType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.sockets">sockets</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpu</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `architecture`<sup>Required</sup> <a name="architecture" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.architecture"></a>

```typescript
public readonly architecture: string;
```

- *Type:* string

---

##### `cores`<sup>Required</sup> <a name="cores" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `cpuUnits`<sup>Required</sup> <a name="cpuUnits" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.cpuUnits"></a>

```typescript
public readonly cpuUnits: number;
```

- *Type:* number

---

##### `emulatedType`<sup>Required</sup> <a name="emulatedType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.emulatedType"></a>

```typescript
public readonly emulatedType: string;
```

- *Type:* string

---

##### `sockets`<sup>Required</sup> <a name="sockets" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpuOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateCpu;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateCpu

---


### DataProxmoxTemplateDisksList <a name="DataProxmoxTemplateDisksList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplateDisksOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplateDisksOutputReference <a name="DataProxmoxTemplateDisksOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.discard">discard</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.fileFormat">fileFormat</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.interfaceType">interfaceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.ssdEmulation">ssdEmulation</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.useIothread">useIothread</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisks</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `discard`<sup>Required</sup> <a name="discard" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.discard"></a>

```typescript
public readonly discard: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fileFormat`<sup>Required</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `speedLimits`<sup>Required</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.speedLimits"></a>

```typescript
public readonly speedLimits: DataProxmoxTemplateDisksSpeedLimitsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference

---

##### `ssdEmulation`<sup>Required</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `useIothread`<sup>Required</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.useIothread"></a>

```typescript
public readonly useIothread: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateDisks;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisks

---


### DataProxmoxTemplateDisksSpeedLimitsOutputReference <a name="DataProxmoxTemplateDisksSpeedLimitsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.read">read</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.readBurstable">readBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.write">write</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimits</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

---

##### `readBurstable`<sup>Required</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

---

##### `write`<sup>Required</sup> <a name="write" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

---

##### `writeBurstable`<sup>Required</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateDisksSpeedLimits;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateDisksSpeedLimits

---


### DataProxmoxTemplateMemoryOutputReference <a name="DataProxmoxTemplateMemoryOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.dedicated">dedicated</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.floating">floating</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.shared">shared</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemory</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dedicated`<sup>Required</sup> <a name="dedicated" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.dedicated"></a>

```typescript
public readonly dedicated: number;
```

- *Type:* number

---

##### `floating`<sup>Required</sup> <a name="floating" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.floating"></a>

```typescript
public readonly floating: number;
```

- *Type:* number

---

##### `shared`<sup>Required</sup> <a name="shared" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.shared"></a>

```typescript
public readonly shared: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemoryOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateMemory;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateMemory

---


### DataProxmoxTemplateNetworkInterfacesList <a name="DataProxmoxTemplateNetworkInterfacesList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplateNetworkInterfacesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplateNetworkInterfacesOutputReference <a name="DataProxmoxTemplateNetworkInterfacesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.bridge">bridge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.model">model</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.mtu">mtu</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.rateLimit">rateLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.useFirewall">useFirewall</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.vlan">vlan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfaces</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `model`<sup>Required</sup> <a name="model" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

---

##### `mtu`<sup>Required</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `rateLimit`<sup>Required</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

---

##### `useFirewall`<sup>Required</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.useFirewall"></a>

```typescript
public readonly useFirewall: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `vlan`<sup>Required</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfacesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplateNetworkInterfaces;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplateNetworkInterfaces

---


### DataProxmoxTemplatePciDevicesList <a name="DataProxmoxTemplatePciDevicesList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatePciDevicesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplatePciDevicesOutputReference <a name="DataProxmoxTemplatePciDevicesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplate } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.mdev">mdev</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.pcie">pcie</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.primaryGpu">primaryGpu</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.rombar">rombar</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.romFile">romFile</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevices</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mdev`<sup>Required</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `pcie`<sup>Required</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.pcie"></a>

```typescript
public readonly pcie: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `primaryGpu`<sup>Required</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `rombar`<sup>Required</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.rombar"></a>

```typescript
public readonly rombar: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `romFile`<sup>Required</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevicesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatePciDevices;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplate.DataProxmoxTemplatePciDevices

---


### DataProxmoxTemplatesFiltersList <a name="DataProxmoxTemplatesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxTemplatesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters[]

---


### DataProxmoxTemplatesFiltersOutputReference <a name="DataProxmoxTemplatesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesFilters | cdktf.IResolvable

---


### DataProxmoxTemplatesTemplatesAgentOutputReference <a name="DataProxmoxTemplatesTemplatesAgentOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.useFstrim">useFstrim</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgent</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `useFstrim`<sup>Required</sup> <a name="useFstrim" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.useFstrim"></a>

```typescript
public readonly useFstrim: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesAgent;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgent

---


### DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference <a name="DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.domain">domain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.nameserver">nameserver</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDns</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `domain`<sup>Required</sup> <a name="domain" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

---

##### `nameserver`<sup>Required</sup> <a name="nameserver" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.nameserver"></a>

```typescript
public readonly nameserver: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCloudInitDns;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDns

---


### DataProxmoxTemplatesTemplatesCloudInitIpList <a name="DataProxmoxTemplatesTemplatesCloudInitIpList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatesTemplatesCloudInitIpOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplatesTemplatesCloudInitIpOutputReference <a name="DataProxmoxTemplatesTemplatesCloudInitIpOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.v4">v4</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.v6">v6</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIp</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `v4`<sup>Required</sup> <a name="v4" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.v4"></a>

```typescript
public readonly v4: DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference

---

##### `v6`<sup>Required</sup> <a name="v6" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.v6"></a>

```typescript
public readonly v6: DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCloudInitIp;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIp

---


### DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference <a name="DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.dhcp">dhcp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCloudInitIpV4;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV4

---


### DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference <a name="DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.dhcp">dhcp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCloudInitIpV6;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpV6

---


### DataProxmoxTemplatesTemplatesCloudInitOutputReference <a name="DataProxmoxTemplatesTemplatesCloudInitOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.dns">dns</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.ip">ip</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.user">user</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInit</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dns`<sup>Required</sup> <a name="dns" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.dns"></a>

```typescript
public readonly dns: DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitDnsOutputReference

---

##### `ip`<sup>Required</sup> <a name="ip" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.ip"></a>

```typescript
public readonly ip: DataProxmoxTemplatesTemplatesCloudInitIpList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitIpList

---

##### `user`<sup>Required</sup> <a name="user" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.user"></a>

```typescript
public readonly user: DataProxmoxTemplatesTemplatesCloudInitUserOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCloudInit;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInit

---


### DataProxmoxTemplatesTemplatesCloudInitUserOutputReference <a name="DataProxmoxTemplatesTemplatesCloudInitUserOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.publicKeys">publicKeys</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUser</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `publicKeys`<sup>Required</sup> <a name="publicKeys" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.publicKeys"></a>

```typescript
public readonly publicKeys: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCloudInitUser;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitUser

---


### DataProxmoxTemplatesTemplatesCpuOutputReference <a name="DataProxmoxTemplatesTemplatesCpuOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.architecture">architecture</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.cpuUnits">cpuUnits</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.emulatedType">emulatedType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.sockets">sockets</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpu</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `architecture`<sup>Required</sup> <a name="architecture" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.architecture"></a>

```typescript
public readonly architecture: string;
```

- *Type:* string

---

##### `cores`<sup>Required</sup> <a name="cores" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `cpuUnits`<sup>Required</sup> <a name="cpuUnits" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.cpuUnits"></a>

```typescript
public readonly cpuUnits: number;
```

- *Type:* number

---

##### `emulatedType`<sup>Required</sup> <a name="emulatedType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.emulatedType"></a>

```typescript
public readonly emulatedType: string;
```

- *Type:* string

---

##### `sockets`<sup>Required</sup> <a name="sockets" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesCpu;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpu

---


### DataProxmoxTemplatesTemplatesDisksList <a name="DataProxmoxTemplatesTemplatesDisksList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatesTemplatesDisksOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplatesTemplatesDisksOutputReference <a name="DataProxmoxTemplatesTemplatesDisksOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.discard">discard</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.fileFormat">fileFormat</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.interfaceType">interfaceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.ssdEmulation">ssdEmulation</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.useIothread">useIothread</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisks</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `discard`<sup>Required</sup> <a name="discard" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.discard"></a>

```typescript
public readonly discard: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fileFormat`<sup>Required</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `speedLimits`<sup>Required</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.speedLimits"></a>

```typescript
public readonly speedLimits: DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference

---

##### `ssdEmulation`<sup>Required</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `useIothread`<sup>Required</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.useIothread"></a>

```typescript
public readonly useIothread: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesDisks;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisks

---


### DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference <a name="DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.read">read</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.readBurstable">readBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.write">write</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimits</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

---

##### `readBurstable`<sup>Required</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

---

##### `write`<sup>Required</sup> <a name="write" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

---

##### `writeBurstable`<sup>Required</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesDisksSpeedLimits;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksSpeedLimits

---


### DataProxmoxTemplatesTemplatesList <a name="DataProxmoxTemplatesTemplatesList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatesTemplatesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplatesTemplatesMemoryOutputReference <a name="DataProxmoxTemplatesTemplatesMemoryOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.dedicated">dedicated</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.floating">floating</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.shared">shared</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemory</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dedicated`<sup>Required</sup> <a name="dedicated" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.dedicated"></a>

```typescript
public readonly dedicated: number;
```

- *Type:* number

---

##### `floating`<sup>Required</sup> <a name="floating" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.floating"></a>

```typescript
public readonly floating: number;
```

- *Type:* number

---

##### `shared`<sup>Required</sup> <a name="shared" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.shared"></a>

```typescript
public readonly shared: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesMemory;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemory

---


### DataProxmoxTemplatesTemplatesNetworkInterfacesList <a name="DataProxmoxTemplatesTemplatesNetworkInterfacesList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference <a name="DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.bridge">bridge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.model">model</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.mtu">mtu</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.rateLimit">rateLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.useFirewall">useFirewall</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.vlan">vlan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfaces</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `model`<sup>Required</sup> <a name="model" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

---

##### `mtu`<sup>Required</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `rateLimit`<sup>Required</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

---

##### `useFirewall`<sup>Required</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.useFirewall"></a>

```typescript
public readonly useFirewall: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `vlan`<sup>Required</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesNetworkInterfaces;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfaces

---


### DataProxmoxTemplatesTemplatesOutputReference <a name="DataProxmoxTemplatesTemplatesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.agent">agent</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.bios">bios</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.cloudInit">cloudInit</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.cpu">cpu</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.disks">disks</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.id">id</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.keyboardLayout">keyboardLayout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.kvmArguments">kvmArguments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.machineType">machineType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.memory">memory</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.networkInterfaces">networkInterfaces</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.pciDevices">pciDevices</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.resourcePool">resourcePool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.startOnNodeBoot">startOnNodeBoot</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.tags">tags</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplates</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `agent`<sup>Required</sup> <a name="agent" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.agent"></a>

```typescript
public readonly agent: DataProxmoxTemplatesTemplatesAgentOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesAgentOutputReference

---

##### `bios`<sup>Required</sup> <a name="bios" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.bios"></a>

```typescript
public readonly bios: string;
```

- *Type:* string

---

##### `cloudInit`<sup>Required</sup> <a name="cloudInit" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.cloudInit"></a>

```typescript
public readonly cloudInit: DataProxmoxTemplatesTemplatesCloudInitOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCloudInitOutputReference

---

##### `cpu`<sup>Required</sup> <a name="cpu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.cpu"></a>

```typescript
public readonly cpu: DataProxmoxTemplatesTemplatesCpuOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesCpuOutputReference

---

##### `description`<sup>Required</sup> <a name="description" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.disks"></a>

```typescript
public readonly disks: DataProxmoxTemplatesTemplatesDisksList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesDisksList

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.id"></a>

```typescript
public readonly id: number;
```

- *Type:* number

---

##### `keyboardLayout`<sup>Required</sup> <a name="keyboardLayout" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.keyboardLayout"></a>

```typescript
public readonly keyboardLayout: string;
```

- *Type:* string

---

##### `kvmArguments`<sup>Required</sup> <a name="kvmArguments" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.kvmArguments"></a>

```typescript
public readonly kvmArguments: string;
```

- *Type:* string

---

##### `machineType`<sup>Required</sup> <a name="machineType" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.machineType"></a>

```typescript
public readonly machineType: string;
```

- *Type:* string

---

##### `memory`<sup>Required</sup> <a name="memory" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.memory"></a>

```typescript
public readonly memory: DataProxmoxTemplatesTemplatesMemoryOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesMemoryOutputReference

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkInterfaces`<sup>Required</sup> <a name="networkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.networkInterfaces"></a>

```typescript
public readonly networkInterfaces: DataProxmoxTemplatesTemplatesNetworkInterfacesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesNetworkInterfacesList

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `pciDevices`<sup>Required</sup> <a name="pciDevices" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.pciDevices"></a>

```typescript
public readonly pciDevices: DataProxmoxTemplatesTemplatesPciDevicesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList

---

##### `resourcePool`<sup>Required</sup> <a name="resourcePool" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.resourcePool"></a>

```typescript
public readonly resourcePool: string;
```

- *Type:* string

---

##### `startOnNodeBoot`<sup>Required</sup> <a name="startOnNodeBoot" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.startOnNodeBoot"></a>

```typescript
public readonly startOnNodeBoot: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `tags`<sup>Required</sup> <a name="tags" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplates;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplates

---


### DataProxmoxTemplatesTemplatesPciDevicesList <a name="DataProxmoxTemplatesTemplatesPciDevicesList" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.get"></a>

```typescript
public get(index: number): DataProxmoxTemplatesTemplatesPciDevicesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxTemplatesTemplatesPciDevicesOutputReference <a name="DataProxmoxTemplatesTemplatesPciDevicesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxTemplates } from '@awlsring/cdktf-proxmox'

new dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.mdev">mdev</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.pcie">pcie</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.primaryGpu">primaryGpu</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.rombar">rombar</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.romFile">romFile</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevices</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mdev`<sup>Required</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `pcie`<sup>Required</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.pcie"></a>

```typescript
public readonly pcie: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `primaryGpu`<sup>Required</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `rombar`<sup>Required</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.rombar"></a>

```typescript
public readonly rombar: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `romFile`<sup>Required</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevicesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxTemplatesTemplatesPciDevices;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxTemplates.DataProxmoxTemplatesTemplatesPciDevices

---


### DataProxmoxVirtualMachinesFiltersList <a name="DataProxmoxVirtualMachinesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxVirtualMachinesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxVirtualMachinesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters[]

---


### DataProxmoxVirtualMachinesFiltersOutputReference <a name="DataProxmoxVirtualMachinesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesFilters | cdktf.IResolvable

---


### DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.useFstrim">useFstrim</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgent</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `useFstrim`<sup>Required</sup> <a name="useFstrim" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.useFstrim"></a>

```typescript
public readonly useFstrim: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesAgent;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgent

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.domain">domain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.nameserver">nameserver</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `domain`<sup>Required</sup> <a name="domain" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

---

##### `nameserver`<sup>Required</sup> <a name="nameserver" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.nameserver"></a>

```typescript
public readonly nameserver: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDns

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.get"></a>

```typescript
public get(index: number): DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.v4">v4</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.v6">v6</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `v4`<sup>Required</sup> <a name="v4" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.v4"></a>

```typescript
public readonly v4: DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference

---

##### `v6`<sup>Required</sup> <a name="v6" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.v6"></a>

```typescript
public readonly v6: DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIp

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.dhcp">dhcp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV4

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.dhcp">dhcp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpV6

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.dns">dns</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.ip">ip</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.user">user</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInit</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dns`<sup>Required</sup> <a name="dns" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.dns"></a>

```typescript
public readonly dns: DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitDnsOutputReference

---

##### `ip`<sup>Required</sup> <a name="ip" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.ip"></a>

```typescript
public readonly ip: DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitIpList

---

##### `user`<sup>Required</sup> <a name="user" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.user"></a>

```typescript
public readonly user: DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCloudInit;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInit

---


### DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.publicKeys">publicKeys</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `publicKeys`<sup>Required</sup> <a name="publicKeys" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.publicKeys"></a>

```typescript
public readonly publicKeys: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitUser

---


### DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.architecture">architecture</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.cpuUnits">cpuUnits</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.emulatedType">emulatedType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.sockets">sockets</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpu</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `architecture`<sup>Required</sup> <a name="architecture" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.architecture"></a>

```typescript
public readonly architecture: string;
```

- *Type:* string

---

##### `cores`<sup>Required</sup> <a name="cores" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `cpuUnits`<sup>Required</sup> <a name="cpuUnits" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.cpuUnits"></a>

```typescript
public readonly cpuUnits: number;
```

- *Type:* number

---

##### `emulatedType`<sup>Required</sup> <a name="emulatedType" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.emulatedType"></a>

```typescript
public readonly emulatedType: string;
```

- *Type:* string

---

##### `sockets`<sup>Required</sup> <a name="sockets" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesCpu;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpu

---


### DataProxmoxVirtualMachinesVirtualMachinesDisksList <a name="DataProxmoxVirtualMachinesVirtualMachinesDisksList" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.get"></a>

```typescript
public get(index: number): DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.discard">discard</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.fileFormat">fileFormat</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.interfaceType">interfaceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.ssdEmulation">ssdEmulation</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.useIothread">useIothread</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisks</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `discard`<sup>Required</sup> <a name="discard" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.discard"></a>

```typescript
public readonly discard: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fileFormat`<sup>Required</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `speedLimits`<sup>Required</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.speedLimits"></a>

```typescript
public readonly speedLimits: DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference

---

##### `ssdEmulation`<sup>Required</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `useIothread`<sup>Required</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.useIothread"></a>

```typescript
public readonly useIothread: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesDisks;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisks

---


### DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.read">read</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.readBurstable">readBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.write">write</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

---

##### `readBurstable`<sup>Required</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

---

##### `write`<sup>Required</sup> <a name="write" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

---

##### `writeBurstable`<sup>Required</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksSpeedLimits

---


### DataProxmoxVirtualMachinesVirtualMachinesList <a name="DataProxmoxVirtualMachinesVirtualMachinesList" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.get"></a>

```typescript
public get(index: number): DataProxmoxVirtualMachinesVirtualMachinesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.dedicated">dedicated</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.floating">floating</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.shared">shared</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemory</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dedicated`<sup>Required</sup> <a name="dedicated" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.dedicated"></a>

```typescript
public readonly dedicated: number;
```

- *Type:* number

---

##### `floating`<sup>Required</sup> <a name="floating" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.floating"></a>

```typescript
public readonly floating: number;
```

- *Type:* number

---

##### `shared`<sup>Required</sup> <a name="shared" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.shared"></a>

```typescript
public readonly shared: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesMemory;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemory

---


### DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList <a name="DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.get"></a>

```typescript
public get(index: number): DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.bridge">bridge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.model">model</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.mtu">mtu</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.rateLimit">rateLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.useFirewall">useFirewall</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.vlan">vlan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `model`<sup>Required</sup> <a name="model" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

---

##### `mtu`<sup>Required</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `rateLimit`<sup>Required</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

---

##### `useFirewall`<sup>Required</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.useFirewall"></a>

```typescript
public readonly useFirewall: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `vlan`<sup>Required</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfaces

---


### DataProxmoxVirtualMachinesVirtualMachinesOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.agent">agent</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.bios">bios</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.cloudInit">cloudInit</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.cpu">cpu</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.disks">disks</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.id">id</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.keyboardLayout">keyboardLayout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.kvmArguments">kvmArguments</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.machineType">machineType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.memory">memory</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.networkInterfaces">networkInterfaces</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.pciDevices">pciDevices</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.resourcePool">resourcePool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.startOnNodeBoot">startOnNodeBoot</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.tags">tags</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachines</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `agent`<sup>Required</sup> <a name="agent" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.agent"></a>

```typescript
public readonly agent: DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesAgentOutputReference

---

##### `bios`<sup>Required</sup> <a name="bios" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.bios"></a>

```typescript
public readonly bios: string;
```

- *Type:* string

---

##### `cloudInit`<sup>Required</sup> <a name="cloudInit" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.cloudInit"></a>

```typescript
public readonly cloudInit: DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCloudInitOutputReference

---

##### `cpu`<sup>Required</sup> <a name="cpu" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.cpu"></a>

```typescript
public readonly cpu: DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesCpuOutputReference

---

##### `description`<sup>Required</sup> <a name="description" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.disks"></a>

```typescript
public readonly disks: DataProxmoxVirtualMachinesVirtualMachinesDisksList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesDisksList

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.id"></a>

```typescript
public readonly id: number;
```

- *Type:* number

---

##### `keyboardLayout`<sup>Required</sup> <a name="keyboardLayout" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.keyboardLayout"></a>

```typescript
public readonly keyboardLayout: string;
```

- *Type:* string

---

##### `kvmArguments`<sup>Required</sup> <a name="kvmArguments" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.kvmArguments"></a>

```typescript
public readonly kvmArguments: string;
```

- *Type:* string

---

##### `machineType`<sup>Required</sup> <a name="machineType" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.machineType"></a>

```typescript
public readonly machineType: string;
```

- *Type:* string

---

##### `memory`<sup>Required</sup> <a name="memory" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.memory"></a>

```typescript
public readonly memory: DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesMemoryOutputReference

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkInterfaces`<sup>Required</sup> <a name="networkInterfaces" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.networkInterfaces"></a>

```typescript
public readonly networkInterfaces: DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesNetworkInterfacesList

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `pciDevices`<sup>Required</sup> <a name="pciDevices" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.pciDevices"></a>

```typescript
public readonly pciDevices: DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList

---

##### `resourcePool`<sup>Required</sup> <a name="resourcePool" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.resourcePool"></a>

```typescript
public readonly resourcePool: string;
```

- *Type:* string

---

##### `startOnNodeBoot`<sup>Required</sup> <a name="startOnNodeBoot" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.startOnNodeBoot"></a>

```typescript
public readonly startOnNodeBoot: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `tags`<sup>Required</sup> <a name="tags" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachines;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachines

---


### DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList <a name="DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.get"></a>

```typescript
public get(index: number): DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference <a name="DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxVirtualMachines } from '@awlsring/cdktf-proxmox'

new dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.mdev">mdev</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.pcie">pcie</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.primaryGpu">primaryGpu</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.rombar">rombar</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.romFile">romFile</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevices</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mdev`<sup>Required</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `pcie`<sup>Required</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.pcie"></a>

```typescript
public readonly pcie: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `primaryGpu`<sup>Required</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `rombar`<sup>Required</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.rombar"></a>

```typescript
public readonly rombar: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `romFile`<sup>Required</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevicesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxVirtualMachinesVirtualMachinesPciDevices;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxVirtualMachines.DataProxmoxVirtualMachinesVirtualMachinesPciDevices

---


### DataProxmoxZfsPoolsFiltersList <a name="DataProxmoxZfsPoolsFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxZfsPoolsFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxZfsPoolsFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters[]

---


### DataProxmoxZfsPoolsFiltersOutputReference <a name="DataProxmoxZfsPoolsFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxZfsPoolsFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsFilters | cdktf.IResolvable

---


### DataProxmoxZfsPoolsZfsPoolsList <a name="DataProxmoxZfsPoolsZfsPoolsList" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.get"></a>

```typescript
public get(index: number): DataProxmoxZfsPoolsZfsPoolsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxZfsPoolsZfsPoolsOutputReference <a name="DataProxmoxZfsPoolsZfsPoolsOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer"></a>

```typescript
import { dataProxmoxZfsPools } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.disks">disks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.nodeAttribute">nodeAttribute</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.raidLevel">raidLevel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPools</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disks`<sup>Required</sup> <a name="disks" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.disks"></a>

```typescript
public readonly disks: string[];
```

- *Type:* string[]

---

##### `health`<sup>Required</sup> <a name="health" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeAttribute`<sup>Required</sup> <a name="nodeAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.nodeAttribute"></a>

```typescript
public readonly nodeAttribute: string;
```

- *Type:* string

---

##### `raidLevel`<sup>Required</sup> <a name="raidLevel" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.raidLevel"></a>

```typescript
public readonly raidLevel: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPoolsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxZfsPoolsZfsPools;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsPools.DataProxmoxZfsPoolsZfsPools

---


### DataProxmoxZfsStorageClassesFiltersList <a name="DataProxmoxZfsStorageClassesFiltersList" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.get"></a>

```typescript
public get(index: number): DataProxmoxZfsStorageClassesFiltersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataProxmoxZfsStorageClassesFilters[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters[]

---


### DataProxmoxZfsStorageClassesFiltersOutputReference <a name="DataProxmoxZfsStorageClassesFiltersOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFiltersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxZfsStorageClassesFilters | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesFilters | cdktf.IResolvable

---


### DataProxmoxZfsStorageClassesZfsStorageClassesList <a name="DataProxmoxZfsStorageClassesZfsStorageClassesList" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.get"></a>

```typescript
public get(index: number): DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference <a name="DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer"></a>

```typescript
import { dataProxmoxZfsStorageClasses } from '@awlsring/cdktf-proxmox'

new dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.contentTypes">contentTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.mount">mount</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.nodes">nodes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.pool">pool</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClasses</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `contentTypes`<sup>Required</sup> <a name="contentTypes" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.contentTypes"></a>

```typescript
public readonly contentTypes: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mount`<sup>Required</sup> <a name="mount" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.mount"></a>

```typescript
public readonly mount: string;
```

- *Type:* string

---

##### `nodes`<sup>Required</sup> <a name="nodes" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.nodes"></a>

```typescript
public readonly nodes: string[];
```

- *Type:* string[]

---

##### `pool`<sup>Required</sup> <a name="pool" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClassesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataProxmoxZfsStorageClassesZfsStorageClasses;
```

- *Type:* @awlsring/cdktf-proxmox.dataProxmoxZfsStorageClasses.DataProxmoxZfsStorageClassesZfsStorageClasses

---


### NetworkBondIpv4OutputReference <a name="NetworkBondIpv4OutputReference" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.Initializer"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

new networkBond.NetworkBondIpv4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resetNetmask">resetNetmask</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetNetmask` <a name="resetNetmask" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.resetNetmask"></a>

```typescript
public resetNetmask(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.netmaskInput">netmaskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `netmaskInput`<sup>Optional</sup> <a name="netmaskInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.netmaskInput"></a>

```typescript
public readonly netmaskInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: NetworkBondIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv4 | cdktf.IResolvable

---


### NetworkBondIpv6OutputReference <a name="NetworkBondIpv6OutputReference" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.Initializer"></a>

```typescript
import { networkBond } from '@awlsring/cdktf-proxmox'

new networkBond.NetworkBondIpv6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resetNetmask">resetNetmask</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetNetmask` <a name="resetNetmask" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.resetNetmask"></a>

```typescript
public resetNetmask(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.netmaskInput">netmaskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `netmaskInput`<sup>Optional</sup> <a name="netmaskInput" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.netmaskInput"></a>

```typescript
public readonly netmaskInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: NetworkBondIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBond.NetworkBondIpv6 | cdktf.IResolvable

---


### NetworkBridgeIpv4OutputReference <a name="NetworkBridgeIpv4OutputReference" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.Initializer"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

new networkBridge.NetworkBridgeIpv4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resetNetmask">resetNetmask</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetNetmask` <a name="resetNetmask" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.resetNetmask"></a>

```typescript
public resetNetmask(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.netmaskInput">netmaskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `netmaskInput`<sup>Optional</sup> <a name="netmaskInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.netmaskInput"></a>

```typescript
public readonly netmaskInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: NetworkBridgeIpv4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv4 | cdktf.IResolvable

---


### NetworkBridgeIpv6OutputReference <a name="NetworkBridgeIpv6OutputReference" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.Initializer"></a>

```typescript
import { networkBridge } from '@awlsring/cdktf-proxmox'

new networkBridge.NetworkBridgeIpv6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resetNetmask">resetNetmask</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetNetmask` <a name="resetNetmask" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.resetNetmask"></a>

```typescript
public resetNetmask(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.netmaskInput">netmaskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `netmaskInput`<sup>Optional</sup> <a name="netmaskInput" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.netmaskInput"></a>

```typescript
public readonly netmaskInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: NetworkBridgeIpv6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.networkBridge.NetworkBridgeIpv6 | cdktf.IResolvable

---


### ResourcePoolMembersList <a name="ResourcePoolMembersList" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

new resourcePool.ResourcePoolMembersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.get"></a>

```typescript
public get(index: number): ResourcePoolMembersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ResourcePoolMembers[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers[]

---


### ResourcePoolMembersOutputReference <a name="ResourcePoolMembersOutputReference" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer"></a>

```typescript
import { resourcePool } from '@awlsring/cdktf-proxmox'

new resourcePool.ResourcePoolMembersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ResourcePoolMembers | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.resourcePool.ResourcePoolMembers | cdktf.IResolvable

---


### VirtualMachineAgentOutputReference <a name="VirtualMachineAgentOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineAgentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resetType">resetType</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resetUseFstrim">resetUseFstrim</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetEnabled` <a name="resetEnabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```

##### `resetType` <a name="resetType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resetType"></a>

```typescript
public resetType(): void
```

##### `resetUseFstrim` <a name="resetUseFstrim" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.resetUseFstrim"></a>

```typescript
public resetUseFstrim(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.useFstrimInput">useFstrimInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.useFstrim">useFstrim</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `useFstrimInput`<sup>Optional</sup> <a name="useFstrimInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.useFstrimInput"></a>

```typescript
public readonly useFstrimInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `type`<sup>Required</sup> <a name="type" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `useFstrim`<sup>Required</sup> <a name="useFstrim" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.useFstrim"></a>

```typescript
public readonly useFstrim: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineAgent | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineAgent | cdktf.IResolvable

---


### VirtualMachineCloneOutputReference <a name="VirtualMachineCloneOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloneOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resetFullClone">resetFullClone</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resetStorage">resetStorage</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetFullClone` <a name="resetFullClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resetFullClone"></a>

```typescript
public resetFullClone(): void
```

##### `resetStorage` <a name="resetStorage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.resetStorage"></a>

```typescript
public resetStorage(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.fullCloneInput">fullCloneInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.sourceInput">sourceInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.storageInput">storageInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.fullClone">fullClone</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.source">source</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fullCloneInput`<sup>Optional</sup> <a name="fullCloneInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.fullCloneInput"></a>

```typescript
public readonly fullCloneInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sourceInput`<sup>Optional</sup> <a name="sourceInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.sourceInput"></a>

```typescript
public readonly sourceInput: number;
```

- *Type:* number

---

##### `storageInput`<sup>Optional</sup> <a name="storageInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.storageInput"></a>

```typescript
public readonly storageInput: string;
```

- *Type:* string

---

##### `fullClone`<sup>Required</sup> <a name="fullClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.fullClone"></a>

```typescript
public readonly fullClone: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `source`<sup>Required</sup> <a name="source" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.source"></a>

```typescript
public readonly source: number;
```

- *Type:* number

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloneOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineClone | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineClone | cdktf.IResolvable

---


### VirtualMachineCloudInitDnsOutputReference <a name="VirtualMachineCloudInitDnsOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitDnsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resetDomain">resetDomain</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resetNameserver">resetNameserver</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDomain` <a name="resetDomain" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resetDomain"></a>

```typescript
public resetDomain(): void
```

##### `resetNameserver` <a name="resetNameserver" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.resetNameserver"></a>

```typescript
public resetNameserver(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.domainInput">domainInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.nameserverInput">nameserverInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.domain">domain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.nameserver">nameserver</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `domainInput`<sup>Optional</sup> <a name="domainInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.domainInput"></a>

```typescript
public readonly domainInput: string;
```

- *Type:* string

---

##### `nameserverInput`<sup>Optional</sup> <a name="nameserverInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.nameserverInput"></a>

```typescript
public readonly nameserverInput: string;
```

- *Type:* string

---

##### `domain`<sup>Required</sup> <a name="domain" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

---

##### `nameserver`<sup>Required</sup> <a name="nameserver" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.nameserver"></a>

```typescript
public readonly nameserver: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCloudInitDns | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns | cdktf.IResolvable

---


### VirtualMachineCloudInitIpList <a name="VirtualMachineCloudInitIpList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitIpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.get"></a>

```typescript
public get(index: number): VirtualMachineCloudInitIpOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachineCloudInitIp[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]

---


### VirtualMachineCloudInitIpOutputReference <a name="VirtualMachineCloudInitIpOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitIpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.putV4">putV4</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.putV6">putV6</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resetV4">resetV4</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resetV6">resetV6</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putV4` <a name="putV4" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.putV4"></a>

```typescript
public putV4(value: VirtualMachineCloudInitIpV4 | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.putV4.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 | cdktf.IResolvable

---

##### `putV6` <a name="putV6" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.putV6"></a>

```typescript
public putV6(value: VirtualMachineCloudInitIpV6 | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.putV6.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 | cdktf.IResolvable

---

##### `resetV4` <a name="resetV4" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resetV4"></a>

```typescript
public resetV4(): void
```

##### `resetV6` <a name="resetV6" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.resetV6"></a>

```typescript
public resetV6(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v4">v4</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v6">v6</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.positionInput">positionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v4Input">v4Input</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v6Input">v6Input</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `v4`<sup>Required</sup> <a name="v4" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v4"></a>

```typescript
public readonly v4: VirtualMachineCloudInitIpV4OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference

---

##### `v6`<sup>Required</sup> <a name="v6" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v6"></a>

```typescript
public readonly v6: VirtualMachineCloudInitIpV6OutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference

---

##### `positionInput`<sup>Optional</sup> <a name="positionInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* number

---

##### `v4Input`<sup>Optional</sup> <a name="v4Input" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v4Input"></a>

```typescript
public readonly v4Input: VirtualMachineCloudInitIpV4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 | cdktf.IResolvable

---

##### `v6Input`<sup>Optional</sup> <a name="v6Input" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.v6Input"></a>

```typescript
public readonly v6Input: VirtualMachineCloudInitIpV6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 | cdktf.IResolvable

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCloudInitIp | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp | cdktf.IResolvable

---


### VirtualMachineCloudInitIpV4OutputReference <a name="VirtualMachineCloudInitIpV4OutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitIpV4OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetDhcp">resetDhcp</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetGateway">resetGateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetNetmask">resetNetmask</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetDhcp` <a name="resetDhcp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetDhcp"></a>

```typescript
public resetDhcp(): void
```

##### `resetGateway` <a name="resetGateway" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetGateway"></a>

```typescript
public resetGateway(): void
```

##### `resetNetmask` <a name="resetNetmask" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.resetNetmask"></a>

```typescript
public resetNetmask(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.dhcpInput">dhcpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.gatewayInput">gatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.netmaskInput">netmaskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.dhcp">dhcp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `dhcpInput`<sup>Optional</sup> <a name="dhcpInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.dhcpInput"></a>

```typescript
public readonly dhcpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gatewayInput`<sup>Optional</sup> <a name="gatewayInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.gatewayInput"></a>

```typescript
public readonly gatewayInput: string;
```

- *Type:* string

---

##### `netmaskInput`<sup>Optional</sup> <a name="netmaskInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.netmaskInput"></a>

```typescript
public readonly netmaskInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCloudInitIpV4 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV4 | cdktf.IResolvable

---


### VirtualMachineCloudInitIpV6OutputReference <a name="VirtualMachineCloudInitIpV6OutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitIpV6OutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetDhcp">resetDhcp</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetGateway">resetGateway</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetNetmask">resetNetmask</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetDhcp` <a name="resetDhcp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetDhcp"></a>

```typescript
public resetDhcp(): void
```

##### `resetGateway` <a name="resetGateway" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetGateway"></a>

```typescript
public resetGateway(): void
```

##### `resetNetmask` <a name="resetNetmask" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.resetNetmask"></a>

```typescript
public resetNetmask(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.dhcpInput">dhcpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.gatewayInput">gatewayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.netmaskInput">netmaskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.dhcp">dhcp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.gateway">gateway</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.netmask">netmask</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `dhcpInput`<sup>Optional</sup> <a name="dhcpInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.dhcpInput"></a>

```typescript
public readonly dhcpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gatewayInput`<sup>Optional</sup> <a name="gatewayInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.gatewayInput"></a>

```typescript
public readonly gatewayInput: string;
```

- *Type:* string

---

##### `netmaskInput`<sup>Optional</sup> <a name="netmaskInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.netmaskInput"></a>

```typescript
public readonly netmaskInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `dhcp`<sup>Required</sup> <a name="dhcp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.dhcp"></a>

```typescript
public readonly dhcp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

---

##### `netmask`<sup>Required</sup> <a name="netmask" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.netmask"></a>

```typescript
public readonly netmask: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6OutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCloudInitIpV6 | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpV6 | cdktf.IResolvable

---


### VirtualMachineCloudInitOutputReference <a name="VirtualMachineCloudInitOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putDns">putDns</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putIp">putIp</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resetDns">resetDns</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resetIp">resetIp</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resetUser">resetUser</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDns` <a name="putDns" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putDns"></a>

```typescript
public putDns(value: VirtualMachineCloudInitDns | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putDns.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns | cdktf.IResolvable

---

##### `putIp` <a name="putIp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putIp"></a>

```typescript
public putIp(value: IResolvable | VirtualMachineCloudInitIp[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putIp.parameter.value"></a>

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]

---

##### `putUser` <a name="putUser" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putUser"></a>

```typescript
public putUser(value: VirtualMachineCloudInitUser | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.putUser.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser | cdktf.IResolvable

---

##### `resetDns` <a name="resetDns" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resetDns"></a>

```typescript
public resetDns(): void
```

##### `resetIp` <a name="resetIp" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resetIp"></a>

```typescript
public resetIp(): void
```

##### `resetUser` <a name="resetUser" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.resetUser"></a>

```typescript
public resetUser(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.dns">dns</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.ip">ip</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.user">user</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.dnsInput">dnsInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.ipInput">ipInput</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.userInput">userInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dns`<sup>Required</sup> <a name="dns" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.dns"></a>

```typescript
public readonly dns: VirtualMachineCloudInitDnsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDnsOutputReference

---

##### `ip`<sup>Required</sup> <a name="ip" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.ip"></a>

```typescript
public readonly ip: VirtualMachineCloudInitIpList;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIpList

---

##### `user`<sup>Required</sup> <a name="user" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.user"></a>

```typescript
public readonly user: VirtualMachineCloudInitUserOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference

---

##### `dnsInput`<sup>Optional</sup> <a name="dnsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.dnsInput"></a>

```typescript
public readonly dnsInput: VirtualMachineCloudInitDns | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitDns | cdktf.IResolvable

---

##### `ipInput`<sup>Optional</sup> <a name="ipInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.ipInput"></a>

```typescript
public readonly ipInput: IResolvable | VirtualMachineCloudInitIp[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitIp[]

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.userInput"></a>

```typescript
public readonly userInput: VirtualMachineCloudInitUser | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCloudInit | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInit | cdktf.IResolvable

---


### VirtualMachineCloudInitUserOutputReference <a name="VirtualMachineCloudInitUserOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCloudInitUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resetPublicKeys">resetPublicKeys</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPassword` <a name="resetPassword" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetPublicKeys` <a name="resetPublicKeys" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.resetPublicKeys"></a>

```typescript
public resetPublicKeys(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.publicKeysInput">publicKeysInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.publicKeys">publicKeys</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `publicKeysInput`<sup>Optional</sup> <a name="publicKeysInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.publicKeysInput"></a>

```typescript
public readonly publicKeysInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `publicKeys`<sup>Required</sup> <a name="publicKeys" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.publicKeys"></a>

```typescript
public readonly publicKeys: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCloudInitUser | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCloudInitUser | cdktf.IResolvable

---


### VirtualMachineComputedDisksList <a name="VirtualMachineComputedDisksList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.get"></a>

```typescript
public get(index: number): VirtualMachineComputedDisksOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachineComputedDisks[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks[]

---


### VirtualMachineComputedDisksOutputReference <a name="VirtualMachineComputedDisksOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.putSpeedLimits">putSpeedLimits</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetDiscard">resetDiscard</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetFileFormat">resetFileFormat</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetSpeedLimits">resetSpeedLimits</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetSsdEmulation">resetSsdEmulation</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetUseIothread">resetUseIothread</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putSpeedLimits` <a name="putSpeedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.putSpeedLimits"></a>

```typescript
public putSpeedLimits(value: VirtualMachineComputedDisksSpeedLimits | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.putSpeedLimits.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits | cdktf.IResolvable

---

##### `resetDiscard` <a name="resetDiscard" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetDiscard"></a>

```typescript
public resetDiscard(): void
```

##### `resetFileFormat` <a name="resetFileFormat" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetFileFormat"></a>

```typescript
public resetFileFormat(): void
```

##### `resetSpeedLimits` <a name="resetSpeedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetSpeedLimits"></a>

```typescript
public resetSpeedLimits(): void
```

##### `resetSsdEmulation` <a name="resetSsdEmulation" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetSsdEmulation"></a>

```typescript
public resetSsdEmulation(): void
```

##### `resetUseIothread` <a name="resetUseIothread" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.resetUseIothread"></a>

```typescript
public resetUseIothread(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.discardInput">discardInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.fileFormatInput">fileFormatInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.interfaceTypeInput">interfaceTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.positionInput">positionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.speedLimitsInput">speedLimitsInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.ssdEmulationInput">ssdEmulationInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.storageInput">storageInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.useIothreadInput">useIothreadInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.discard">discard</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.fileFormat">fileFormat</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.interfaceType">interfaceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.ssdEmulation">ssdEmulation</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.useIothread">useIothread</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `speedLimits`<sup>Required</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.speedLimits"></a>

```typescript
public readonly speedLimits: VirtualMachineComputedDisksSpeedLimitsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference

---

##### `discardInput`<sup>Optional</sup> <a name="discardInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.discardInput"></a>

```typescript
public readonly discardInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `fileFormatInput`<sup>Optional</sup> <a name="fileFormatInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.fileFormatInput"></a>

```typescript
public readonly fileFormatInput: string;
```

- *Type:* string

---

##### `interfaceTypeInput`<sup>Optional</sup> <a name="interfaceTypeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.interfaceTypeInput"></a>

```typescript
public readonly interfaceTypeInput: string;
```

- *Type:* string

---

##### `positionInput`<sup>Optional</sup> <a name="positionInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* number

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `speedLimitsInput`<sup>Optional</sup> <a name="speedLimitsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.speedLimitsInput"></a>

```typescript
public readonly speedLimitsInput: VirtualMachineComputedDisksSpeedLimits | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits | cdktf.IResolvable

---

##### `ssdEmulationInput`<sup>Optional</sup> <a name="ssdEmulationInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.ssdEmulationInput"></a>

```typescript
public readonly ssdEmulationInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `storageInput`<sup>Optional</sup> <a name="storageInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.storageInput"></a>

```typescript
public readonly storageInput: string;
```

- *Type:* string

---

##### `useIothreadInput`<sup>Optional</sup> <a name="useIothreadInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.useIothreadInput"></a>

```typescript
public readonly useIothreadInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `discard`<sup>Required</sup> <a name="discard" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.discard"></a>

```typescript
public readonly discard: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `fileFormat`<sup>Required</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `ssdEmulation`<sup>Required</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `useIothread`<sup>Required</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.useIothread"></a>

```typescript
public readonly useIothread: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineComputedDisks;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisks

---


### VirtualMachineComputedDisksSpeedLimitsOutputReference <a name="VirtualMachineComputedDisksSpeedLimitsOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetReadBurstable">resetReadBurstable</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetWrite">resetWrite</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetWriteBurstable">resetWriteBurstable</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRead` <a name="resetRead" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetReadBurstable` <a name="resetReadBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetReadBurstable"></a>

```typescript
public resetReadBurstable(): void
```

##### `resetWrite` <a name="resetWrite" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetWrite"></a>

```typescript
public resetWrite(): void
```

##### `resetWriteBurstable` <a name="resetWriteBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.resetWriteBurstable"></a>

```typescript
public resetWriteBurstable(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.readBurstableInput">readBurstableInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.readInput">readInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.writeBurstableInput">writeBurstableInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.writeInput">writeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.read">read</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.readBurstable">readBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.write">write</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `readBurstableInput`<sup>Optional</sup> <a name="readBurstableInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.readBurstableInput"></a>

```typescript
public readonly readBurstableInput: number;
```

- *Type:* number

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: number;
```

- *Type:* number

---

##### `writeBurstableInput`<sup>Optional</sup> <a name="writeBurstableInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.writeBurstableInput"></a>

```typescript
public readonly writeBurstableInput: number;
```

- *Type:* number

---

##### `writeInput`<sup>Optional</sup> <a name="writeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.writeInput"></a>

```typescript
public readonly writeInput: number;
```

- *Type:* number

---

##### `read`<sup>Required</sup> <a name="read" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

---

##### `readBurstable`<sup>Required</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

---

##### `write`<sup>Required</sup> <a name="write" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

---

##### `writeBurstable`<sup>Required</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineComputedDisksSpeedLimits | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedDisksSpeedLimits | cdktf.IResolvable

---


### VirtualMachineComputedNetworkInterfacesList <a name="VirtualMachineComputedNetworkInterfacesList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedNetworkInterfacesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.get"></a>

```typescript
public get(index: number): VirtualMachineComputedNetworkInterfacesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachineComputedNetworkInterfaces[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces[]

---


### VirtualMachineComputedNetworkInterfacesOutputReference <a name="VirtualMachineComputedNetworkInterfacesOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetMacAddress">resetMacAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetModel">resetModel</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetMtu">resetMtu</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetRateLimit">resetRateLimit</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetUseFirewall">resetUseFirewall</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetVlan">resetVlan</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetEnabled` <a name="resetEnabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```

##### `resetMacAddress` <a name="resetMacAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetMacAddress"></a>

```typescript
public resetMacAddress(): void
```

##### `resetModel` <a name="resetModel" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetModel"></a>

```typescript
public resetModel(): void
```

##### `resetMtu` <a name="resetMtu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetMtu"></a>

```typescript
public resetMtu(): void
```

##### `resetRateLimit` <a name="resetRateLimit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetRateLimit"></a>

```typescript
public resetRateLimit(): void
```

##### `resetUseFirewall` <a name="resetUseFirewall" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetUseFirewall"></a>

```typescript
public resetUseFirewall(): void
```

##### `resetVlan` <a name="resetVlan" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.resetVlan"></a>

```typescript
public resetVlan(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.bridgeInput">bridgeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.macAddressInput">macAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.modelInput">modelInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.mtuInput">mtuInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.positionInput">positionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.rateLimitInput">rateLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.useFirewallInput">useFirewallInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.vlanInput">vlanInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.bridge">bridge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.model">model</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.mtu">mtu</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.rateLimit">rateLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.useFirewall">useFirewall</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.vlan">vlan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bridgeInput`<sup>Optional</sup> <a name="bridgeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.bridgeInput"></a>

```typescript
public readonly bridgeInput: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `macAddressInput`<sup>Optional</sup> <a name="macAddressInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.macAddressInput"></a>

```typescript
public readonly macAddressInput: string;
```

- *Type:* string

---

##### `modelInput`<sup>Optional</sup> <a name="modelInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.modelInput"></a>

```typescript
public readonly modelInput: string;
```

- *Type:* string

---

##### `mtuInput`<sup>Optional</sup> <a name="mtuInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.mtuInput"></a>

```typescript
public readonly mtuInput: number;
```

- *Type:* number

---

##### `positionInput`<sup>Optional</sup> <a name="positionInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* number

---

##### `rateLimitInput`<sup>Optional</sup> <a name="rateLimitInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.rateLimitInput"></a>

```typescript
public readonly rateLimitInput: number;
```

- *Type:* number

---

##### `useFirewallInput`<sup>Optional</sup> <a name="useFirewallInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.useFirewallInput"></a>

```typescript
public readonly useFirewallInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `vlanInput`<sup>Optional</sup> <a name="vlanInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.vlanInput"></a>

```typescript
public readonly vlanInput: number;
```

- *Type:* number

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `model`<sup>Required</sup> <a name="model" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

---

##### `mtu`<sup>Required</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `rateLimit`<sup>Required</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

---

##### `useFirewall`<sup>Required</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.useFirewall"></a>

```typescript
public readonly useFirewall: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `vlan`<sup>Required</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfacesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineComputedNetworkInterfaces;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedNetworkInterfaces

---


### VirtualMachineComputedPciDevicesList <a name="VirtualMachineComputedPciDevicesList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedPciDevicesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.get"></a>

```typescript
public get(index: number): VirtualMachineComputedPciDevicesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachineComputedPciDevices[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices[]

---


### VirtualMachineComputedPciDevicesOutputReference <a name="VirtualMachineComputedPciDevicesOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineComputedPciDevicesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetMdev">resetMdev</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetPcie">resetPcie</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetPrimaryGpu">resetPrimaryGpu</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetRombar">resetRombar</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetRomFile">resetRomFile</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMdev` <a name="resetMdev" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetMdev"></a>

```typescript
public resetMdev(): void
```

##### `resetPcie` <a name="resetPcie" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetPcie"></a>

```typescript
public resetPcie(): void
```

##### `resetPrimaryGpu` <a name="resetPrimaryGpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetPrimaryGpu"></a>

```typescript
public resetPrimaryGpu(): void
```

##### `resetRombar` <a name="resetRombar" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetRombar"></a>

```typescript
public resetRombar(): void
```

##### `resetRomFile` <a name="resetRomFile" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.resetRomFile"></a>

```typescript
public resetRomFile(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.mdevInput">mdevInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.pcieInput">pcieInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.primaryGpuInput">primaryGpuInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.rombarInput">rombarInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.romFileInput">romFileInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.mdev">mdev</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.pcie">pcie</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.primaryGpu">primaryGpu</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.rombar">rombar</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.romFile">romFile</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `mdevInput`<sup>Optional</sup> <a name="mdevInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.mdevInput"></a>

```typescript
public readonly mdevInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `pcieInput`<sup>Optional</sup> <a name="pcieInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.pcieInput"></a>

```typescript
public readonly pcieInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `primaryGpuInput`<sup>Optional</sup> <a name="primaryGpuInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.primaryGpuInput"></a>

```typescript
public readonly primaryGpuInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `rombarInput`<sup>Optional</sup> <a name="rombarInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.rombarInput"></a>

```typescript
public readonly rombarInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `romFileInput`<sup>Optional</sup> <a name="romFileInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.romFileInput"></a>

```typescript
public readonly romFileInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mdev`<sup>Required</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `pcie`<sup>Required</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.pcie"></a>

```typescript
public readonly pcie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `primaryGpu`<sup>Required</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `rombar`<sup>Required</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.rombar"></a>

```typescript
public readonly rombar: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `romFile`<sup>Required</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevicesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineComputedPciDevices;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineComputedPciDevices

---


### VirtualMachineCpuOutputReference <a name="VirtualMachineCpuOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineCpuOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetArchitecture">resetArchitecture</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetCores">resetCores</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetCpuUnits">resetCpuUnits</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetEmulatedType">resetEmulatedType</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetSockets">resetSockets</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetArchitecture` <a name="resetArchitecture" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetArchitecture"></a>

```typescript
public resetArchitecture(): void
```

##### `resetCores` <a name="resetCores" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetCores"></a>

```typescript
public resetCores(): void
```

##### `resetCpuUnits` <a name="resetCpuUnits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetCpuUnits"></a>

```typescript
public resetCpuUnits(): void
```

##### `resetEmulatedType` <a name="resetEmulatedType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetEmulatedType"></a>

```typescript
public resetEmulatedType(): void
```

##### `resetSockets` <a name="resetSockets" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.resetSockets"></a>

```typescript
public resetSockets(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.architectureInput">architectureInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.coresInput">coresInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.cpuUnitsInput">cpuUnitsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.emulatedTypeInput">emulatedTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.socketsInput">socketsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.architecture">architecture</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.cpuUnits">cpuUnits</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.emulatedType">emulatedType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.sockets">sockets</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `architectureInput`<sup>Optional</sup> <a name="architectureInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.architectureInput"></a>

```typescript
public readonly architectureInput: string;
```

- *Type:* string

---

##### `coresInput`<sup>Optional</sup> <a name="coresInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.coresInput"></a>

```typescript
public readonly coresInput: number;
```

- *Type:* number

---

##### `cpuUnitsInput`<sup>Optional</sup> <a name="cpuUnitsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.cpuUnitsInput"></a>

```typescript
public readonly cpuUnitsInput: number;
```

- *Type:* number

---

##### `emulatedTypeInput`<sup>Optional</sup> <a name="emulatedTypeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.emulatedTypeInput"></a>

```typescript
public readonly emulatedTypeInput: string;
```

- *Type:* string

---

##### `socketsInput`<sup>Optional</sup> <a name="socketsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.socketsInput"></a>

```typescript
public readonly socketsInput: number;
```

- *Type:* number

---

##### `architecture`<sup>Required</sup> <a name="architecture" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.architecture"></a>

```typescript
public readonly architecture: string;
```

- *Type:* string

---

##### `cores`<sup>Required</sup> <a name="cores" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `cpuUnits`<sup>Required</sup> <a name="cpuUnits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.cpuUnits"></a>

```typescript
public readonly cpuUnits: number;
```

- *Type:* number

---

##### `emulatedType`<sup>Required</sup> <a name="emulatedType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.emulatedType"></a>

```typescript
public readonly emulatedType: string;
```

- *Type:* string

---

##### `sockets`<sup>Required</sup> <a name="sockets" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.sockets"></a>

```typescript
public readonly sockets: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpuOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineCpu | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineCpu | cdktf.IResolvable

---


### VirtualMachineDisksList <a name="VirtualMachineDisksList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineDisksList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.get"></a>

```typescript
public get(index: number): VirtualMachineDisksOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachineDisks[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks[]

---


### VirtualMachineDisksOutputReference <a name="VirtualMachineDisksOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineDisksOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.putSpeedLimits">putSpeedLimits</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetDiscard">resetDiscard</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetFileFormat">resetFileFormat</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetSpeedLimits">resetSpeedLimits</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetSsdEmulation">resetSsdEmulation</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetUseIothread">resetUseIothread</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putSpeedLimits` <a name="putSpeedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.putSpeedLimits"></a>

```typescript
public putSpeedLimits(value: VirtualMachineDisksSpeedLimits | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.putSpeedLimits.parameter.value"></a>

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits | cdktf.IResolvable

---

##### `resetDiscard` <a name="resetDiscard" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetDiscard"></a>

```typescript
public resetDiscard(): void
```

##### `resetFileFormat` <a name="resetFileFormat" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetFileFormat"></a>

```typescript
public resetFileFormat(): void
```

##### `resetSpeedLimits` <a name="resetSpeedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetSpeedLimits"></a>

```typescript
public resetSpeedLimits(): void
```

##### `resetSsdEmulation` <a name="resetSsdEmulation" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetSsdEmulation"></a>

```typescript
public resetSsdEmulation(): void
```

##### `resetUseIothread` <a name="resetUseIothread" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.resetUseIothread"></a>

```typescript
public resetUseIothread(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.speedLimits">speedLimits</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.discardInput">discardInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.fileFormatInput">fileFormatInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.interfaceTypeInput">interfaceTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.positionInput">positionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.speedLimitsInput">speedLimitsInput</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.ssdEmulationInput">ssdEmulationInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.storageInput">storageInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.useIothreadInput">useIothreadInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.discard">discard</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.fileFormat">fileFormat</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.interfaceType">interfaceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.ssdEmulation">ssdEmulation</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.useIothread">useIothread</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `speedLimits`<sup>Required</sup> <a name="speedLimits" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.speedLimits"></a>

```typescript
public readonly speedLimits: VirtualMachineDisksSpeedLimitsOutputReference;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference

---

##### `discardInput`<sup>Optional</sup> <a name="discardInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.discardInput"></a>

```typescript
public readonly discardInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `fileFormatInput`<sup>Optional</sup> <a name="fileFormatInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.fileFormatInput"></a>

```typescript
public readonly fileFormatInput: string;
```

- *Type:* string

---

##### `interfaceTypeInput`<sup>Optional</sup> <a name="interfaceTypeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.interfaceTypeInput"></a>

```typescript
public readonly interfaceTypeInput: string;
```

- *Type:* string

---

##### `positionInput`<sup>Optional</sup> <a name="positionInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* number

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `speedLimitsInput`<sup>Optional</sup> <a name="speedLimitsInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.speedLimitsInput"></a>

```typescript
public readonly speedLimitsInput: VirtualMachineDisksSpeedLimits | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits | cdktf.IResolvable

---

##### `ssdEmulationInput`<sup>Optional</sup> <a name="ssdEmulationInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.ssdEmulationInput"></a>

```typescript
public readonly ssdEmulationInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `storageInput`<sup>Optional</sup> <a name="storageInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.storageInput"></a>

```typescript
public readonly storageInput: string;
```

- *Type:* string

---

##### `useIothreadInput`<sup>Optional</sup> <a name="useIothreadInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.useIothreadInput"></a>

```typescript
public readonly useIothreadInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `discard`<sup>Required</sup> <a name="discard" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.discard"></a>

```typescript
public readonly discard: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `fileFormat`<sup>Required</sup> <a name="fileFormat" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.fileFormat"></a>

```typescript
public readonly fileFormat: string;
```

- *Type:* string

---

##### `interfaceType`<sup>Required</sup> <a name="interfaceType" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.interfaceType"></a>

```typescript
public readonly interfaceType: string;
```

- *Type:* string

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `ssdEmulation`<sup>Required</sup> <a name="ssdEmulation" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.ssdEmulation"></a>

```typescript
public readonly ssdEmulation: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `useIothread`<sup>Required</sup> <a name="useIothread" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.useIothread"></a>

```typescript
public readonly useIothread: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineDisks | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisks | cdktf.IResolvable

---


### VirtualMachineDisksSpeedLimitsOutputReference <a name="VirtualMachineDisksSpeedLimitsOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetReadBurstable">resetReadBurstable</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetWrite">resetWrite</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetWriteBurstable">resetWriteBurstable</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRead` <a name="resetRead" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetReadBurstable` <a name="resetReadBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetReadBurstable"></a>

```typescript
public resetReadBurstable(): void
```

##### `resetWrite` <a name="resetWrite" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetWrite"></a>

```typescript
public resetWrite(): void
```

##### `resetWriteBurstable` <a name="resetWriteBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.resetWriteBurstable"></a>

```typescript
public resetWriteBurstable(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.readBurstableInput">readBurstableInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.readInput">readInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.writeBurstableInput">writeBurstableInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.writeInput">writeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.read">read</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.readBurstable">readBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.write">write</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.writeBurstable">writeBurstable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `readBurstableInput`<sup>Optional</sup> <a name="readBurstableInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.readBurstableInput"></a>

```typescript
public readonly readBurstableInput: number;
```

- *Type:* number

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: number;
```

- *Type:* number

---

##### `writeBurstableInput`<sup>Optional</sup> <a name="writeBurstableInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.writeBurstableInput"></a>

```typescript
public readonly writeBurstableInput: number;
```

- *Type:* number

---

##### `writeInput`<sup>Optional</sup> <a name="writeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.writeInput"></a>

```typescript
public readonly writeInput: number;
```

- *Type:* number

---

##### `read`<sup>Required</sup> <a name="read" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.read"></a>

```typescript
public readonly read: number;
```

- *Type:* number

---

##### `readBurstable`<sup>Required</sup> <a name="readBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.readBurstable"></a>

```typescript
public readonly readBurstable: number;
```

- *Type:* number

---

##### `write`<sup>Required</sup> <a name="write" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.write"></a>

```typescript
public readonly write: number;
```

- *Type:* number

---

##### `writeBurstable`<sup>Required</sup> <a name="writeBurstable" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.writeBurstable"></a>

```typescript
public readonly writeBurstable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineDisksSpeedLimits | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineDisksSpeedLimits | cdktf.IResolvable

---


### VirtualMachineIsoOutputReference <a name="VirtualMachineIsoOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineIsoOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.imageInput">imageInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.storageInput">storageInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.image">image</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.storage">storage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `imageInput`<sup>Optional</sup> <a name="imageInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.imageInput"></a>

```typescript
public readonly imageInput: string;
```

- *Type:* string

---

##### `storageInput`<sup>Optional</sup> <a name="storageInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.storageInput"></a>

```typescript
public readonly storageInput: string;
```

- *Type:* string

---

##### `image`<sup>Required</sup> <a name="image" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

---

##### `storage`<sup>Required</sup> <a name="storage" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.storage"></a>

```typescript
public readonly storage: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIsoOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineIso | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineIso | cdktf.IResolvable

---


### VirtualMachineMemoryOutputReference <a name="VirtualMachineMemoryOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineMemoryOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resetDedicated">resetDedicated</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resetFloating">resetFloating</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resetShared">resetShared</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDedicated` <a name="resetDedicated" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resetDedicated"></a>

```typescript
public resetDedicated(): void
```

##### `resetFloating` <a name="resetFloating" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resetFloating"></a>

```typescript
public resetFloating(): void
```

##### `resetShared` <a name="resetShared" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.resetShared"></a>

```typescript
public resetShared(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.dedicatedInput">dedicatedInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.floatingInput">floatingInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.sharedInput">sharedInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.dedicated">dedicated</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.floating">floating</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.shared">shared</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dedicatedInput`<sup>Optional</sup> <a name="dedicatedInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.dedicatedInput"></a>

```typescript
public readonly dedicatedInput: number;
```

- *Type:* number

---

##### `floatingInput`<sup>Optional</sup> <a name="floatingInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.floatingInput"></a>

```typescript
public readonly floatingInput: number;
```

- *Type:* number

---

##### `sharedInput`<sup>Optional</sup> <a name="sharedInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.sharedInput"></a>

```typescript
public readonly sharedInput: number;
```

- *Type:* number

---

##### `dedicated`<sup>Required</sup> <a name="dedicated" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.dedicated"></a>

```typescript
public readonly dedicated: number;
```

- *Type:* number

---

##### `floating`<sup>Required</sup> <a name="floating" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.floating"></a>

```typescript
public readonly floating: number;
```

- *Type:* number

---

##### `shared`<sup>Required</sup> <a name="shared" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.shared"></a>

```typescript
public readonly shared: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemoryOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineMemory | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineMemory | cdktf.IResolvable

---


### VirtualMachineNetworkInterfacesList <a name="VirtualMachineNetworkInterfacesList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineNetworkInterfacesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.get"></a>

```typescript
public get(index: number): VirtualMachineNetworkInterfacesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachineNetworkInterfaces[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces[]

---


### VirtualMachineNetworkInterfacesOutputReference <a name="VirtualMachineNetworkInterfacesOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineNetworkInterfacesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetMacAddress">resetMacAddress</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetModel">resetModel</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetMtu">resetMtu</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetRateLimit">resetRateLimit</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetUseFirewall">resetUseFirewall</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetVlan">resetVlan</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetEnabled` <a name="resetEnabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```

##### `resetMacAddress` <a name="resetMacAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetMacAddress"></a>

```typescript
public resetMacAddress(): void
```

##### `resetModel` <a name="resetModel" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetModel"></a>

```typescript
public resetModel(): void
```

##### `resetMtu` <a name="resetMtu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetMtu"></a>

```typescript
public resetMtu(): void
```

##### `resetRateLimit` <a name="resetRateLimit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetRateLimit"></a>

```typescript
public resetRateLimit(): void
```

##### `resetUseFirewall` <a name="resetUseFirewall" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetUseFirewall"></a>

```typescript
public resetUseFirewall(): void
```

##### `resetVlan` <a name="resetVlan" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.resetVlan"></a>

```typescript
public resetVlan(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.bridgeInput">bridgeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.macAddressInput">macAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.modelInput">modelInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.mtuInput">mtuInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.positionInput">positionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.rateLimitInput">rateLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.useFirewallInput">useFirewallInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.vlanInput">vlanInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.bridge">bridge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.model">model</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.mtu">mtu</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.position">position</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.rateLimit">rateLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.useFirewall">useFirewall</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.vlan">vlan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bridgeInput`<sup>Optional</sup> <a name="bridgeInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.bridgeInput"></a>

```typescript
public readonly bridgeInput: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `macAddressInput`<sup>Optional</sup> <a name="macAddressInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.macAddressInput"></a>

```typescript
public readonly macAddressInput: string;
```

- *Type:* string

---

##### `modelInput`<sup>Optional</sup> <a name="modelInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.modelInput"></a>

```typescript
public readonly modelInput: string;
```

- *Type:* string

---

##### `mtuInput`<sup>Optional</sup> <a name="mtuInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.mtuInput"></a>

```typescript
public readonly mtuInput: number;
```

- *Type:* number

---

##### `positionInput`<sup>Optional</sup> <a name="positionInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.positionInput"></a>

```typescript
public readonly positionInput: number;
```

- *Type:* number

---

##### `rateLimitInput`<sup>Optional</sup> <a name="rateLimitInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.rateLimitInput"></a>

```typescript
public readonly rateLimitInput: number;
```

- *Type:* number

---

##### `useFirewallInput`<sup>Optional</sup> <a name="useFirewallInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.useFirewallInput"></a>

```typescript
public readonly useFirewallInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `vlanInput`<sup>Optional</sup> <a name="vlanInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.vlanInput"></a>

```typescript
public readonly vlanInput: number;
```

- *Type:* number

---

##### `bridge`<sup>Required</sup> <a name="bridge" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.bridge"></a>

```typescript
public readonly bridge: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `model`<sup>Required</sup> <a name="model" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.model"></a>

```typescript
public readonly model: string;
```

- *Type:* string

---

##### `mtu`<sup>Required</sup> <a name="mtu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.mtu"></a>

```typescript
public readonly mtu: number;
```

- *Type:* number

---

##### `position`<sup>Required</sup> <a name="position" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.position"></a>

```typescript
public readonly position: number;
```

- *Type:* number

---

##### `rateLimit`<sup>Required</sup> <a name="rateLimit" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.rateLimit"></a>

```typescript
public readonly rateLimit: number;
```

- *Type:* number

---

##### `useFirewall`<sup>Required</sup> <a name="useFirewall" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.useFirewall"></a>

```typescript
public readonly useFirewall: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `vlan`<sup>Required</sup> <a name="vlan" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.vlan"></a>

```typescript
public readonly vlan: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfacesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineNetworkInterfaces | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineNetworkInterfaces | cdktf.IResolvable

---


### VirtualMachinePciDevicesList <a name="VirtualMachinePciDevicesList" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachinePciDevicesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.get"></a>

```typescript
public get(index: number): VirtualMachinePciDevicesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VirtualMachinePciDevices[];
```

- *Type:* cdktf.IResolvable | @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices[]

---


### VirtualMachinePciDevicesOutputReference <a name="VirtualMachinePciDevicesOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachinePciDevicesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetMdev">resetMdev</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetPcie">resetPcie</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetPrimaryGpu">resetPrimaryGpu</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetRombar">resetRombar</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetRomFile">resetRomFile</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMdev` <a name="resetMdev" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetMdev"></a>

```typescript
public resetMdev(): void
```

##### `resetPcie` <a name="resetPcie" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetPcie"></a>

```typescript
public resetPcie(): void
```

##### `resetPrimaryGpu` <a name="resetPrimaryGpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetPrimaryGpu"></a>

```typescript
public resetPrimaryGpu(): void
```

##### `resetRombar` <a name="resetRombar" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetRombar"></a>

```typescript
public resetRombar(): void
```

##### `resetRomFile` <a name="resetRomFile" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.resetRomFile"></a>

```typescript
public resetRomFile(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.mdevInput">mdevInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.pcieInput">pcieInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.primaryGpuInput">primaryGpuInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.rombarInput">rombarInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.romFileInput">romFileInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.mdev">mdev</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.pcie">pcie</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.primaryGpu">primaryGpu</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.rombar">rombar</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.romFile">romFile</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `mdevInput`<sup>Optional</sup> <a name="mdevInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.mdevInput"></a>

```typescript
public readonly mdevInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `pcieInput`<sup>Optional</sup> <a name="pcieInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.pcieInput"></a>

```typescript
public readonly pcieInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `primaryGpuInput`<sup>Optional</sup> <a name="primaryGpuInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.primaryGpuInput"></a>

```typescript
public readonly primaryGpuInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `rombarInput`<sup>Optional</sup> <a name="rombarInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.rombarInput"></a>

```typescript
public readonly rombarInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `romFileInput`<sup>Optional</sup> <a name="romFileInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.romFileInput"></a>

```typescript
public readonly romFileInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `mdev`<sup>Required</sup> <a name="mdev" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.mdev"></a>

```typescript
public readonly mdev: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `pcie`<sup>Required</sup> <a name="pcie" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.pcie"></a>

```typescript
public readonly pcie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `primaryGpu`<sup>Required</sup> <a name="primaryGpu" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.primaryGpu"></a>

```typescript
public readonly primaryGpu: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `rombar`<sup>Required</sup> <a name="rombar" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.rombar"></a>

```typescript
public readonly rombar: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `romFile`<sup>Required</sup> <a name="romFile" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.romFile"></a>

```typescript
public readonly romFile: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevicesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachinePciDevices | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachinePciDevices | cdktf.IResolvable

---


### VirtualMachineTimeoutsOutputReference <a name="VirtualMachineTimeoutsOutputReference" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.Initializer"></a>

```typescript
import { virtualMachine } from '@awlsring/cdktf-proxmox'

new virtualMachine.VirtualMachineTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetClone">resetClone</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetConfigure">resetConfigure</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetReboot">resetReboot</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetResizeDisk">resetResizeDisk</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetShutdown">resetShutdown</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetStart">resetStart</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetStop">resetStop</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetClone` <a name="resetClone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetClone"></a>

```typescript
public resetClone(): void
```

##### `resetConfigure` <a name="resetConfigure" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetConfigure"></a>

```typescript
public resetConfigure(): void
```

##### `resetCreate` <a name="resetCreate" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetReboot` <a name="resetReboot" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetReboot"></a>

```typescript
public resetReboot(): void
```

##### `resetResizeDisk` <a name="resetResizeDisk" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetResizeDisk"></a>

```typescript
public resetResizeDisk(): void
```

##### `resetShutdown` <a name="resetShutdown" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetShutdown"></a>

```typescript
public resetShutdown(): void
```

##### `resetStart` <a name="resetStart" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetStart"></a>

```typescript
public resetStart(): void
```

##### `resetStop` <a name="resetStop" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.resetStop"></a>

```typescript
public resetStop(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.cloneInput">cloneInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.configureInput">configureInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.rebootInput">rebootInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.resizeDiskInput">resizeDiskInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.shutdownInput">shutdownInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.startInput">startInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.stopInput">stopInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.clone">clone</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.configure">configure</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.create">create</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.delete">delete</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.reboot">reboot</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.resizeDisk">resizeDisk</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.shutdown">shutdown</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.start">start</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.stop">stop</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cloneInput`<sup>Optional</sup> <a name="cloneInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.cloneInput"></a>

```typescript
public readonly cloneInput: number;
```

- *Type:* number

---

##### `configureInput`<sup>Optional</sup> <a name="configureInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.configureInput"></a>

```typescript
public readonly configureInput: number;
```

- *Type:* number

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: number;
```

- *Type:* number

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: number;
```

- *Type:* number

---

##### `rebootInput`<sup>Optional</sup> <a name="rebootInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.rebootInput"></a>

```typescript
public readonly rebootInput: number;
```

- *Type:* number

---

##### `resizeDiskInput`<sup>Optional</sup> <a name="resizeDiskInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.resizeDiskInput"></a>

```typescript
public readonly resizeDiskInput: number;
```

- *Type:* number

---

##### `shutdownInput`<sup>Optional</sup> <a name="shutdownInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.shutdownInput"></a>

```typescript
public readonly shutdownInput: number;
```

- *Type:* number

---

##### `startInput`<sup>Optional</sup> <a name="startInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.startInput"></a>

```typescript
public readonly startInput: number;
```

- *Type:* number

---

##### `stopInput`<sup>Optional</sup> <a name="stopInput" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.stopInput"></a>

```typescript
public readonly stopInput: number;
```

- *Type:* number

---

##### `clone`<sup>Required</sup> <a name="clone" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.clone"></a>

```typescript
public readonly clone: number;
```

- *Type:* number

---

##### `configure`<sup>Required</sup> <a name="configure" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.configure"></a>

```typescript
public readonly configure: number;
```

- *Type:* number

---

##### `create`<sup>Required</sup> <a name="create" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: number;
```

- *Type:* number

---

##### `delete`<sup>Required</sup> <a name="delete" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: number;
```

- *Type:* number

---

##### `reboot`<sup>Required</sup> <a name="reboot" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.reboot"></a>

```typescript
public readonly reboot: number;
```

- *Type:* number

---

##### `resizeDisk`<sup>Required</sup> <a name="resizeDisk" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.resizeDisk"></a>

```typescript
public readonly resizeDisk: number;
```

- *Type:* number

---

##### `shutdown`<sup>Required</sup> <a name="shutdown" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.shutdown"></a>

```typescript
public readonly shutdown: number;
```

- *Type:* number

---

##### `start`<sup>Required</sup> <a name="start" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.start"></a>

```typescript
public readonly start: number;
```

- *Type:* number

---

##### `stop`<sup>Required</sup> <a name="stop" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.stop"></a>

```typescript
public readonly stop: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VirtualMachineTimeouts | IResolvable;
```

- *Type:* @awlsring/cdktf-proxmox.virtualMachine.VirtualMachineTimeouts | cdktf.IResolvable

---



## Enums <a name="Enums" id="Enums"></a>

### AgentType <a name="AgentType" id="@awlsring/cdktf-proxmox.AgentType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.AgentType.VIRTIO">VIRTIO</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.AgentType.ISA">ISA</a></code> | *No description.* |

---

##### `VIRTIO` <a name="VIRTIO" id="@awlsring/cdktf-proxmox.AgentType.VIRTIO"></a>

---


##### `ISA` <a name="ISA" id="@awlsring/cdktf-proxmox.AgentType.ISA"></a>

---


### Architecture <a name="Architecture" id="@awlsring/cdktf-proxmox.Architecture"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.Architecture.X86_64">X86_64</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.Architecture.AARCH64">AARCH64</a></code> | *No description.* |

---

##### `X86_64` <a name="X86_64" id="@awlsring/cdktf-proxmox.Architecture.X86_64"></a>

---


##### `AARCH64` <a name="AARCH64" id="@awlsring/cdktf-proxmox.Architecture.AARCH64"></a>

---


### Bios <a name="Bios" id="@awlsring/cdktf-proxmox.Bios"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.Bios.SEABIOS">SEABIOS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.Bios.OVMF">OVMF</a></code> | *No description.* |

---

##### `SEABIOS` <a name="SEABIOS" id="@awlsring/cdktf-proxmox.Bios.SEABIOS"></a>

---


##### `OVMF` <a name="OVMF" id="@awlsring/cdktf-proxmox.Bios.OVMF"></a>

---


### DiskInterface <a name="DiskInterface" id="@awlsring/cdktf-proxmox.DiskInterface"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.DiskInterface.SCSI">SCSI</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.DiskInterface.SATA">SATA</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.DiskInterface.VIRTIO">VIRTIO</a></code> | *No description.* |

---

##### `SCSI` <a name="SCSI" id="@awlsring/cdktf-proxmox.DiskInterface.SCSI"></a>

---


##### `SATA` <a name="SATA" id="@awlsring/cdktf-proxmox.DiskInterface.SATA"></a>

---


##### `VIRTIO` <a name="VIRTIO" id="@awlsring/cdktf-proxmox.DiskInterface.VIRTIO"></a>

---


### EmulatedType <a name="EmulatedType" id="@awlsring/cdktf-proxmox.EmulatedType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType._486">_486</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.BROADWELL">BROADWELL</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.BROADWELL_IBRS">BROADWELL_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.BROADWELL_NO_TSX">BROADWELL_NO_TSX</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.BROADWELL_NO_TSX_IBRS">BROADWELL_NO_TSX_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.CASCADELAKE_SERVER">CASCADELAKE_SERVER</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.CONROE">CONROE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.EPYC">EPYC</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.EPYC_IBPB">EPYC_IBPB</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.EPYC_ROME">EPYC_ROME</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.EPYC_MILAN">EPYC_MILAN</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.HASWELL">HASWELL</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.HASWELL_IBRS">HASWELL_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.HASWELL_NO_TSX">HASWELL_NO_TSX</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.HASWELL_NO_TSX_IBRS">HASWELL_NO_TSX_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.HOST">HOST</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.IVY_BRIDGE">IVY_BRIDGE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.IVY_BRIDGE_IBRS">IVY_BRIDGE_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.KNIGHTS_MILL">KNIGHTS_MILL</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.NEHALEM">NEHALEM</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.NEHALEM_IBRS">NEHALEM_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G1">OPTERON_G1</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G2">OPTERON_G2</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G3">OPTERON_G3</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G4">OPTERON_G4</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G5">OPTERON_G5</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.PENRYN">PENRYN</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_CLIENT">SKYLAKE_CLIENT</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_CLIENT_IBRS">SKYLAKE_CLIENT_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_SERVER">SKYLAKE_SERVER</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_SERVER_IBRS">SKYLAKE_SERVER_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.SANDY_BRIDGE">SANDY_BRIDGE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.SANDY_BRIDGE_IBRS">SANDY_BRIDGE_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.WESTMERE">WESTMERE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.WESTMERE_IBRS">WESTMERE_IBRS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.ATHLON">ATHLON</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.CORE2DUO">CORE2DUO</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.COREDUO">COREDUO</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.KVM32">KVM32</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.KVM64">KVM64</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.MAX">MAX</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.PENTIUM">PENTIUM</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.PENTIUM2">PENTIUM2</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.PENTIUM3">PENTIUM3</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.PHENOM">PHENOM</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.QEMU32">QEMU32</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.EmulatedType.QEMU64">QEMU64</a></code> | *No description.* |

---

##### `_486` <a name="_486" id="@awlsring/cdktf-proxmox.EmulatedType._486"></a>

---


##### `BROADWELL` <a name="BROADWELL" id="@awlsring/cdktf-proxmox.EmulatedType.BROADWELL"></a>

---


##### `BROADWELL_IBRS` <a name="BROADWELL_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.BROADWELL_IBRS"></a>

---


##### `BROADWELL_NO_TSX` <a name="BROADWELL_NO_TSX" id="@awlsring/cdktf-proxmox.EmulatedType.BROADWELL_NO_TSX"></a>

---


##### `BROADWELL_NO_TSX_IBRS` <a name="BROADWELL_NO_TSX_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.BROADWELL_NO_TSX_IBRS"></a>

---


##### `CASCADELAKE_SERVER` <a name="CASCADELAKE_SERVER" id="@awlsring/cdktf-proxmox.EmulatedType.CASCADELAKE_SERVER"></a>

---


##### `CONROE` <a name="CONROE" id="@awlsring/cdktf-proxmox.EmulatedType.CONROE"></a>

---


##### `EPYC` <a name="EPYC" id="@awlsring/cdktf-proxmox.EmulatedType.EPYC"></a>

---


##### `EPYC_IBPB` <a name="EPYC_IBPB" id="@awlsring/cdktf-proxmox.EmulatedType.EPYC_IBPB"></a>

---


##### `EPYC_ROME` <a name="EPYC_ROME" id="@awlsring/cdktf-proxmox.EmulatedType.EPYC_ROME"></a>

---


##### `EPYC_MILAN` <a name="EPYC_MILAN" id="@awlsring/cdktf-proxmox.EmulatedType.EPYC_MILAN"></a>

---


##### `HASWELL` <a name="HASWELL" id="@awlsring/cdktf-proxmox.EmulatedType.HASWELL"></a>

---


##### `HASWELL_IBRS` <a name="HASWELL_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.HASWELL_IBRS"></a>

---


##### `HASWELL_NO_TSX` <a name="HASWELL_NO_TSX" id="@awlsring/cdktf-proxmox.EmulatedType.HASWELL_NO_TSX"></a>

---


##### `HASWELL_NO_TSX_IBRS` <a name="HASWELL_NO_TSX_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.HASWELL_NO_TSX_IBRS"></a>

---


##### `HOST` <a name="HOST" id="@awlsring/cdktf-proxmox.EmulatedType.HOST"></a>

---


##### `IVY_BRIDGE` <a name="IVY_BRIDGE" id="@awlsring/cdktf-proxmox.EmulatedType.IVY_BRIDGE"></a>

---


##### `IVY_BRIDGE_IBRS` <a name="IVY_BRIDGE_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.IVY_BRIDGE_IBRS"></a>

---


##### `KNIGHTS_MILL` <a name="KNIGHTS_MILL" id="@awlsring/cdktf-proxmox.EmulatedType.KNIGHTS_MILL"></a>

---


##### `NEHALEM` <a name="NEHALEM" id="@awlsring/cdktf-proxmox.EmulatedType.NEHALEM"></a>

---


##### `NEHALEM_IBRS` <a name="NEHALEM_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.NEHALEM_IBRS"></a>

---


##### `OPTERON_G1` <a name="OPTERON_G1" id="@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G1"></a>

---


##### `OPTERON_G2` <a name="OPTERON_G2" id="@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G2"></a>

---


##### `OPTERON_G3` <a name="OPTERON_G3" id="@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G3"></a>

---


##### `OPTERON_G4` <a name="OPTERON_G4" id="@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G4"></a>

---


##### `OPTERON_G5` <a name="OPTERON_G5" id="@awlsring/cdktf-proxmox.EmulatedType.OPTERON_G5"></a>

---


##### `PENRYN` <a name="PENRYN" id="@awlsring/cdktf-proxmox.EmulatedType.PENRYN"></a>

---


##### `SKYLAKE_CLIENT` <a name="SKYLAKE_CLIENT" id="@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_CLIENT"></a>

---


##### `SKYLAKE_CLIENT_IBRS` <a name="SKYLAKE_CLIENT_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_CLIENT_IBRS"></a>

---


##### `SKYLAKE_SERVER` <a name="SKYLAKE_SERVER" id="@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_SERVER"></a>

---


##### `SKYLAKE_SERVER_IBRS` <a name="SKYLAKE_SERVER_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.SKYLAKE_SERVER_IBRS"></a>

---


##### `SANDY_BRIDGE` <a name="SANDY_BRIDGE" id="@awlsring/cdktf-proxmox.EmulatedType.SANDY_BRIDGE"></a>

---


##### `SANDY_BRIDGE_IBRS` <a name="SANDY_BRIDGE_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.SANDY_BRIDGE_IBRS"></a>

---


##### `WESTMERE` <a name="WESTMERE" id="@awlsring/cdktf-proxmox.EmulatedType.WESTMERE"></a>

---


##### `WESTMERE_IBRS` <a name="WESTMERE_IBRS" id="@awlsring/cdktf-proxmox.EmulatedType.WESTMERE_IBRS"></a>

---


##### `ATHLON` <a name="ATHLON" id="@awlsring/cdktf-proxmox.EmulatedType.ATHLON"></a>

---


##### `CORE2DUO` <a name="CORE2DUO" id="@awlsring/cdktf-proxmox.EmulatedType.CORE2DUO"></a>

---


##### `COREDUO` <a name="COREDUO" id="@awlsring/cdktf-proxmox.EmulatedType.COREDUO"></a>

---


##### `KVM32` <a name="KVM32" id="@awlsring/cdktf-proxmox.EmulatedType.KVM32"></a>

---


##### `KVM64` <a name="KVM64" id="@awlsring/cdktf-proxmox.EmulatedType.KVM64"></a>

---


##### `MAX` <a name="MAX" id="@awlsring/cdktf-proxmox.EmulatedType.MAX"></a>

---


##### `PENTIUM` <a name="PENTIUM" id="@awlsring/cdktf-proxmox.EmulatedType.PENTIUM"></a>

---


##### `PENTIUM2` <a name="PENTIUM2" id="@awlsring/cdktf-proxmox.EmulatedType.PENTIUM2"></a>

---


##### `PENTIUM3` <a name="PENTIUM3" id="@awlsring/cdktf-proxmox.EmulatedType.PENTIUM3"></a>

---


##### `PHENOM` <a name="PHENOM" id="@awlsring/cdktf-proxmox.EmulatedType.PHENOM"></a>

---


##### `QEMU32` <a name="QEMU32" id="@awlsring/cdktf-proxmox.EmulatedType.QEMU32"></a>

---


##### `QEMU64` <a name="QEMU64" id="@awlsring/cdktf-proxmox.EmulatedType.QEMU64"></a>

---


### FileFormat <a name="FileFormat" id="@awlsring/cdktf-proxmox.FileFormat"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.FileFormat.RAW">RAW</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.FileFormat.VMDK">VMDK</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.FileFormat.QCOW2">QCOW2</a></code> | *No description.* |

---

##### `RAW` <a name="RAW" id="@awlsring/cdktf-proxmox.FileFormat.RAW"></a>

---


##### `VMDK` <a name="VMDK" id="@awlsring/cdktf-proxmox.FileFormat.VMDK"></a>

---


##### `QCOW2` <a name="QCOW2" id="@awlsring/cdktf-proxmox.FileFormat.QCOW2"></a>

---


### KeyboardLayout <a name="KeyboardLayout" id="@awlsring/cdktf-proxmox.KeyboardLayout"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.DA">DA</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.DE">DE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.DE_CH">DE_CH</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.EN_GB">EN_GB</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.EN_US">EN_US</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.ES">ES</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.FI">FI</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.FR">FR</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.FR_BE">FR_BE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.FR_CA">FR_CA</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.FR_CH">FR_CH</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.HU">HU</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.IS">IS</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.IT">IT</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.JA">JA</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.LT">LT</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.NL">NL</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.NO">NO</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.PL">PL</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.PT">PT</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.PT_BR">PT_BR</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.SL">SL</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.SV">SV</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.KeyboardLayout.TR">TR</a></code> | *No description.* |

---

##### `DA` <a name="DA" id="@awlsring/cdktf-proxmox.KeyboardLayout.DA"></a>

---


##### `DE` <a name="DE" id="@awlsring/cdktf-proxmox.KeyboardLayout.DE"></a>

---


##### `DE_CH` <a name="DE_CH" id="@awlsring/cdktf-proxmox.KeyboardLayout.DE_CH"></a>

---


##### `EN_GB` <a name="EN_GB" id="@awlsring/cdktf-proxmox.KeyboardLayout.EN_GB"></a>

---


##### `EN_US` <a name="EN_US" id="@awlsring/cdktf-proxmox.KeyboardLayout.EN_US"></a>

---


##### `ES` <a name="ES" id="@awlsring/cdktf-proxmox.KeyboardLayout.ES"></a>

---


##### `FI` <a name="FI" id="@awlsring/cdktf-proxmox.KeyboardLayout.FI"></a>

---


##### `FR` <a name="FR" id="@awlsring/cdktf-proxmox.KeyboardLayout.FR"></a>

---


##### `FR_BE` <a name="FR_BE" id="@awlsring/cdktf-proxmox.KeyboardLayout.FR_BE"></a>

---


##### `FR_CA` <a name="FR_CA" id="@awlsring/cdktf-proxmox.KeyboardLayout.FR_CA"></a>

---


##### `FR_CH` <a name="FR_CH" id="@awlsring/cdktf-proxmox.KeyboardLayout.FR_CH"></a>

---


##### `HU` <a name="HU" id="@awlsring/cdktf-proxmox.KeyboardLayout.HU"></a>

---


##### `IS` <a name="IS" id="@awlsring/cdktf-proxmox.KeyboardLayout.IS"></a>

---


##### `IT` <a name="IT" id="@awlsring/cdktf-proxmox.KeyboardLayout.IT"></a>

---


##### `JA` <a name="JA" id="@awlsring/cdktf-proxmox.KeyboardLayout.JA"></a>

---


##### `LT` <a name="LT" id="@awlsring/cdktf-proxmox.KeyboardLayout.LT"></a>

---


##### `NL` <a name="NL" id="@awlsring/cdktf-proxmox.KeyboardLayout.NL"></a>

---


##### `NO` <a name="NO" id="@awlsring/cdktf-proxmox.KeyboardLayout.NO"></a>

---


##### `PL` <a name="PL" id="@awlsring/cdktf-proxmox.KeyboardLayout.PL"></a>

---


##### `PT` <a name="PT" id="@awlsring/cdktf-proxmox.KeyboardLayout.PT"></a>

---


##### `PT_BR` <a name="PT_BR" id="@awlsring/cdktf-proxmox.KeyboardLayout.PT_BR"></a>

---


##### `SL` <a name="SL" id="@awlsring/cdktf-proxmox.KeyboardLayout.SL"></a>

---


##### `SV` <a name="SV" id="@awlsring/cdktf-proxmox.KeyboardLayout.SV"></a>

---


##### `TR` <a name="TR" id="@awlsring/cdktf-proxmox.KeyboardLayout.TR"></a>

---


### MachineType <a name="MachineType" id="@awlsring/cdktf-proxmox.MachineType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.MachineType.I440FX">I440FX</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.MachineType.Q35">Q35</a></code> | *No description.* |

---

##### `I440FX` <a name="I440FX" id="@awlsring/cdktf-proxmox.MachineType.I440FX"></a>

---


##### `Q35` <a name="Q35" id="@awlsring/cdktf-proxmox.MachineType.Q35"></a>

---


### NetworkHashPolicy <a name="NetworkHashPolicy" id="@awlsring/cdktf-proxmox.NetworkHashPolicy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkHashPolicy.LAYER_2">LAYER_2</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkHashPolicy.LAYER_2_3">LAYER_2_3</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkHashPolicy.LAYER_3">LAYER_3</a></code> | *No description.* |

---

##### `LAYER_2` <a name="LAYER_2" id="@awlsring/cdktf-proxmox.NetworkHashPolicy.LAYER_2"></a>

---


##### `LAYER_2_3` <a name="LAYER_2_3" id="@awlsring/cdktf-proxmox.NetworkHashPolicy.LAYER_2_3"></a>

---


##### `LAYER_3` <a name="LAYER_3" id="@awlsring/cdktf-proxmox.NetworkHashPolicy.LAYER_3"></a>

---


### NetworkInterfaceModel <a name="NetworkInterfaceModel" id="@awlsring/cdktf-proxmox.NetworkInterfaceModel"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkInterfaceModel.VIRTIO">VIRTIO</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkInterfaceModel.E1000">E1000</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkInterfaceModel.RTL8139">RTL8139</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkInterfaceModel.VMXNET3">VMXNET3</a></code> | *No description.* |

---

##### `VIRTIO` <a name="VIRTIO" id="@awlsring/cdktf-proxmox.NetworkInterfaceModel.VIRTIO"></a>

---


##### `E1000` <a name="E1000" id="@awlsring/cdktf-proxmox.NetworkInterfaceModel.E1000"></a>

---


##### `RTL8139` <a name="RTL8139" id="@awlsring/cdktf-proxmox.NetworkInterfaceModel.RTL8139"></a>

---


##### `VMXNET3` <a name="VMXNET3" id="@awlsring/cdktf-proxmox.NetworkInterfaceModel.VMXNET3"></a>

---


### NetworkMode <a name="NetworkMode" id="@awlsring/cdktf-proxmox.NetworkMode"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.BALANCE_RR">BALANCE_RR</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.ACTIVE_BACKUP">ACTIVE_BACKUP</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.BALANCE_XOR">BALANCE_XOR</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.BALANCE_TLB">BALANCE_TLB</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.BALANCE_ALB">BALANCE_ALB</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.BALANCE_SLB">BALANCE_SLB</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.BROADCAST">BROADCAST</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.LCAP_802_3AD">LCAP_802_3AD</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.LCAP_BALANCE_SLB">LCAP_BALANCE_SLB</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.NetworkMode.LCAP_BALANCE_TCP">LCAP_BALANCE_TCP</a></code> | *No description.* |

---

##### `BALANCE_RR` <a name="BALANCE_RR" id="@awlsring/cdktf-proxmox.NetworkMode.BALANCE_RR"></a>

---


##### `ACTIVE_BACKUP` <a name="ACTIVE_BACKUP" id="@awlsring/cdktf-proxmox.NetworkMode.ACTIVE_BACKUP"></a>

---


##### `BALANCE_XOR` <a name="BALANCE_XOR" id="@awlsring/cdktf-proxmox.NetworkMode.BALANCE_XOR"></a>

---


##### `BALANCE_TLB` <a name="BALANCE_TLB" id="@awlsring/cdktf-proxmox.NetworkMode.BALANCE_TLB"></a>

---


##### `BALANCE_ALB` <a name="BALANCE_ALB" id="@awlsring/cdktf-proxmox.NetworkMode.BALANCE_ALB"></a>

---


##### `BALANCE_SLB` <a name="BALANCE_SLB" id="@awlsring/cdktf-proxmox.NetworkMode.BALANCE_SLB"></a>

---


##### `BROADCAST` <a name="BROADCAST" id="@awlsring/cdktf-proxmox.NetworkMode.BROADCAST"></a>

---


##### `LCAP_802_3AD` <a name="LCAP_802_3AD" id="@awlsring/cdktf-proxmox.NetworkMode.LCAP_802_3AD"></a>

---


##### `LCAP_BALANCE_SLB` <a name="LCAP_BALANCE_SLB" id="@awlsring/cdktf-proxmox.NetworkMode.LCAP_BALANCE_SLB"></a>

---


##### `LCAP_BALANCE_TCP` <a name="LCAP_BALANCE_TCP" id="@awlsring/cdktf-proxmox.NetworkMode.LCAP_BALANCE_TCP"></a>

---


### OsType <a name="OsType" id="@awlsring/cdktf-proxmox.OsType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.L24">L24</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.L26">L26</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.OTHER">OTHER</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_XP">WINDOWS_XP</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_2000">WINDOWS_2000</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_2003">WINDOWS_2003</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_2008">WINDOWS_2008</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_VISTA">WINDOWS_VISTA</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_7">WINDOWS_7</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_8">WINDOWS_8</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_10">WINDOWS_10</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.WINDOWS_11">WINDOWS_11</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.OsType.SOLARIS">SOLARIS</a></code> | *No description.* |

---

##### `L24` <a name="L24" id="@awlsring/cdktf-proxmox.OsType.L24"></a>

---


##### `L26` <a name="L26" id="@awlsring/cdktf-proxmox.OsType.L26"></a>

---


##### `OTHER` <a name="OTHER" id="@awlsring/cdktf-proxmox.OsType.OTHER"></a>

---


##### `WINDOWS_XP` <a name="WINDOWS_XP" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_XP"></a>

---


##### `WINDOWS_2000` <a name="WINDOWS_2000" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_2000"></a>

---


##### `WINDOWS_2003` <a name="WINDOWS_2003" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_2003"></a>

---


##### `WINDOWS_2008` <a name="WINDOWS_2008" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_2008"></a>

---


##### `WINDOWS_VISTA` <a name="WINDOWS_VISTA" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_VISTA"></a>

---


##### `WINDOWS_7` <a name="WINDOWS_7" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_7"></a>

---


##### `WINDOWS_8` <a name="WINDOWS_8" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_8"></a>

---


##### `WINDOWS_10` <a name="WINDOWS_10" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_10"></a>

---


##### `WINDOWS_11` <a name="WINDOWS_11" id="@awlsring/cdktf-proxmox.OsType.WINDOWS_11"></a>

---


##### `SOLARIS` <a name="SOLARIS" id="@awlsring/cdktf-proxmox.OsType.SOLARIS"></a>

---


### ZFSRaidLevel <a name="ZFSRaidLevel" id="@awlsring/cdktf-proxmox.ZFSRaidLevel"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@awlsring/cdktf-proxmox.ZFSRaidLevel.SINGLE">SINGLE</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.ZFSRaidLevel.MIRROR">MIRROR</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.ZFSRaidLevel.RAIDZ">RAIDZ</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.ZFSRaidLevel.RAIDZ2">RAIDZ2</a></code> | *No description.* |
| <code><a href="#@awlsring/cdktf-proxmox.ZFSRaidLevel.RAIDZ3">RAIDZ3</a></code> | *No description.* |

---

##### `SINGLE` <a name="SINGLE" id="@awlsring/cdktf-proxmox.ZFSRaidLevel.SINGLE"></a>

---


##### `MIRROR` <a name="MIRROR" id="@awlsring/cdktf-proxmox.ZFSRaidLevel.MIRROR"></a>

---


##### `RAIDZ` <a name="RAIDZ" id="@awlsring/cdktf-proxmox.ZFSRaidLevel.RAIDZ"></a>

---


##### `RAIDZ2` <a name="RAIDZ2" id="@awlsring/cdktf-proxmox.ZFSRaidLevel.RAIDZ2"></a>

---


##### `RAIDZ3` <a name="RAIDZ3" id="@awlsring/cdktf-proxmox.ZFSRaidLevel.RAIDZ3"></a>

---

